;	HeXHub version 5.11 Copyright (C) 2006-2014 Albu Cristian
;
;	This program is free software; you can redistribute it and/or modify
;	it under the terms of the GNU General Public License as published by
;	the Free Software Foundation.
;
;	This program is distributed in the hope that it will be useful,
;	but WITHOUT ANY WARRANTY; without even the implied warranty of
;	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;	GNU General Public License for more details.
;
;	You should have received a copy of the GNU General Public License
;	along with this program; if not, write to the Free Software
;	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
;
;	For more information send and e-mail to cristian.albu@gmail.com

syn_info	struc
	lastcount	dd	?
	lastip		dd	?
	lastdstip	dd	?
	lastport	dd	?
	isflood		dw	?
	chksum		dw	?
syn_info	ends

syn_str	struc
	syn_idx		db	?
	isflood		db	?
	lastip		dd	?
	sinfo		syn_info 	20 dup(<>)
syn_str	ends


drv_data	macro
	hDriver		dd	?
	hAdvapi		dd	?
	hServiceMgr	dd	?
	hService	dd	?
	drvver		dd	?
	drvport		dd	?
	_OpenSCManager	dd	?
	_CreateService	dd	?
	_CloseServiceHandle dd	?
	_StartService	dd	?
	_ControlService	dd	?
	_DeleteService	dd	?
	_OpenService	dd	?
	_ioctl		dd	?
	srvstat		SERVICE_STATUS <>

	drvpath		db	8192 dup(?)
endm

FWcall	macro	p1,p2,p3,p4,p5,p6,p7
	.if hDriver
		push	p7
		push	p6
		push	p5
		push	p4
		push	p3
		push	p2
		push	p1
		push	hDriver
		call	_ioctl
	.endif
endm

drv_procs	macro
drivername	db	'\\.\DDoSflt',0
drvsys		db	'DDoSflt.sys',0
serviceName	db	'DDoS Filter driver',0
service1	db	'DDoSflt',0
advapi		db	'advapi32.dll',0
advapi1		db	'OpenSCManagerA',0
advapi2		db	'CreateServiceA',0
advapi3		db	'CloseServiceHandle',0
advapi4		db	'StartServiceA',0
advapi5		db	'ControlService',0
advapi6		db	'DeleteService',0
advapi7		db	'OpenServiceA',0
fbtn1		db	'Register firewall driver',0
fbtn2		db	'Load driver',0
fbtn3		db	'Unregister firewall driver',0
fbtn4		db	'Unload driver',0
fstat1		db	'Firewall not loaded',0
fstat2		db	'Firewall cannot be loaded in this system',0
fstat3		db	'Firewall registered successfully',0
fstat4		db	'Error opening Service Control Manager database',0
fstat5		db	'Error opening service handle',0
fstat6		db	'Firewall loaded, version ',0
fstat7		db	'Firewall service started',0
fstat8		db	'Firewall unloaded',0
fstat9		db	'Firewall unregistered',0

initadv:.if hAdvapi==0
		invoke	LoadLibrary,addr advapi
		mov	hAdvapi,eax
		invoke	GetProcAddress,hAdvapi,addr advapi1
		mov	_OpenSCManager,eax
		invoke	GetProcAddress,hAdvapi,addr advapi2
		mov	_CreateService,eax
		.if eax==0
			mov	_OpenSCManager,0
		.endif
		invoke	GetProcAddress,hAdvapi,addr advapi3
		mov	_CloseServiceHandle,eax
		.if eax==0
			mov	_OpenSCManager,0
		.endif
		invoke	GetProcAddress,hAdvapi,addr advapi4
		mov	_StartService,eax
		.if eax==0
			mov	_OpenSCManager,0
		.endif
		invoke	GetProcAddress,hAdvapi,addr advapi5
		mov	_ControlService,eax
		.if eax==0
			mov	_OpenSCManager,0
		.endif
		invoke	GetProcAddress,hAdvapi,addr advapi6
		mov	_DeleteService,eax
		.if eax==0
			mov	_OpenSCManager,0
		.endif
		invoke	GetProcAddress,hAdvapi,addr advapi7
		mov	_OpenService,eax
		.if eax==0
			mov	_OpenSCManager,0
		.endif
	.endif
	ret

freg:	call	initadv
	.if _OpenSCManager
		push	SC_MANAGER_ALL_ACCESS
		push	0
		push	0
		call	_OpenSCManager
		mov	hServiceMgr,eax
		.if eax
			push	eax
			invoke	GetFullPathName,addr drvsys,8192,addr drvpath,esp
			pop	eax

			push	0
			push	0
			push	0
			push	0
			push	0
			push	offset drvpath
			push	SERVICE_ERROR_NORMAL
			push	SERVICE_DEMAND_START
			push	SERVICE_KERNEL_DRIVER
			push	SERVICE_ALL_ACCESS
			push	offset serviceName
			push	offset service1
			push	hServiceMgr
			call	_CreateService
			mov	hService,eax
			.if eax
				invoke	SetDlgItemText,hDlg17,64,addr fstat3
				invoke	SetDlgItemText,hDlg17,1,addr fbtn3
				invoke	SetDlgItemText,hDlg17,3,addr fbtn2
				and	firewall,1 xor -1
			.else
				push	SERVICE_ALL_ACCESS
				push	offset service1
				push	hServiceMgr
				call	_OpenService
				mov	hService,eax
				.if eax
					invoke	SetDlgItemText,hDlg17,64,addr fstat3
					invoke	SetDlgItemText,hDlg17,1,addr fbtn3
					and	firewall,1 xor -1
				.else
					invoke	SetDlgItemText,hDlg17,64,addr fstat5
					invoke	SetDlgItemText,hDlg17,1,addr fbtn1
					or	firewall,3
				.endif
			.endif
		.else
			invoke	SetDlgItemText,hDlg17,64,addr fstat4
			invoke	SetDlgItemText,hDlg17,1,addr fbtn1
			or	firewall,3
		.endif
	.else
		invoke	SetDlgItemText,hDlg17,64,addr fstat2
		invoke	SetDlgItemText,hDlg17,1,addr fbtn1
		or	firewall,3
	.endif
	ret

startfirewall:
	.if hDriver
		ret
	.endif
	call	initadv
	.if _OpenSCManager
		.if hService
			push	0
			push	0
			push	hService
			call	_StartService
			invoke	SetDlgItemText,hDlg17,64,addr fstat7
		.else
			call	freg
			.if hService
				push	0
				push	0
				push	hService
				call	_StartService
				invoke	SetDlgItemText,hDlg17,64,addr fstat7
			.else
				mov	hService,0
				push	hServiceMgr
				call	_CloseServiceHandle
				mov	hServiceMgr,0
				invoke	SetDlgItemText,hDlg17,64,addr fstat5
				or	firewall,3
			.endif
		.endif
	.endif
	invoke	CreateFile,addr drivername,GENERIC_READ or GENERIC_WRITE,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
	.if eax!=INVALID_HANDLE_VALUE
		mov	hDriver,eax
	.else
		lea	edx,DeviceIoControl
		.if edx==_ioctl
			mov	hDriver,0
		.else
			mov	hDriver,1
		.endif
	.endif
	ret

drvports:
	push	edi
	lea	edi,_ports
	.while edi
		assume	edi:ptr port_info
		mov	eax,dword ptr fsyn1-2
		mov	ax,word ptr[edi].portnum
		push	eax
		mov	edx,esp
		FWcall	2220e4h,edx,4,0,0,offset bread,0
		pop	eax
		assume	edi:nothing
		mov	edi,[edi]
	.endw
	pop	edi
		.if (_portmask&256)
			mov	eax,dword ptr fsyn1-2
			mov	ax,rstPort1
			push	eax
			mov	edx,esp
			FWcall	2220e4h,edx,4,0,0,offset bread,0
			pop	eax
		.endif
		.if (_portmask&512)
			mov	eax,dword ptr fsyn1-2
			mov	ax,rstPort2
			push	eax
			mov	edx,esp
			FWcall	2220e4h,edx,4,0,0,offset bread,0
			pop	eax
		.endif
		.if (_portmask&1024)
			mov	eax,dword ptr fsyn1-2
			mov	ax,rstPort3
			push	eax
			mov	edx,esp
			FWcall	2220e4h,edx,4,0,0,offset bread,0
			pop	eax
		.endif
		.if (_portmask&2048)
			mov	eax,dword ptr fsyn1-2
			mov	ax,rstPort4
			push	eax
			mov	edx,esp
			FWcall	2220e4h,edx,4,0,0,offset bread,0
			pop	eax
		.endif
	ret

drvuports:
	push	edi
	lea	edi,_ports
	.while edi
		assume	edi:ptr port_info
		mov	ax,word ptr[edi].portnum
		push	eax
		mov	edx,esp
		FWcall	2220e8h,edx,2,0,0,offset bread,0
		pop	eax
		assume	edi:nothing
		mov	edi,[edi]
	.endw
	pop	edi
		.if (_portmask&256)
			mov	ax,rstPort1
			push	eax
			mov	edx,esp
			FWcall	2220e8h,edx,2,0,0,offset bread,0
			pop	eax
		.endif
		.if (_portmask&512)
			mov	ax,rstPort2
			push	eax
			mov	edx,esp
			FWcall	2220e8h,edx,2,0,0,offset bread,0
			pop	eax
		.endif
		.if (_portmask&1024)
			mov	ax,rstPort3
			push	eax
			mov	edx,esp
			FWcall	2220e8h,edx,2,0,0,offset bread,0
			pop	eax
		.endif
		.if (_portmask&2048)
			mov	ax,rstPort4
			push	eax
			mov	edx,esp
			FWcall	2220e8h,edx,2,0,0,offset bread,0
			pop	eax
		.endif
	ret

drvinit:.if hDriver
		FWcall	2220e0h,offset pcapfl,16,0,0,offset bread,0
		FWcall	2220dch,0,0,offset drvver,4,offset bread,0
		FWcall	2220c0h,0,0,0,0,offset bread,0
		call	drvports
		mov	esi,hProf
		mov	edi,esi
		.while esi!=0
			lea	edi,dword ptr[esi+12]
			.while word ptr[edi]!=0
				.if (word ptr[edi+2]==-1)&&(word ptr[edi+48]!=0)&&(byte ptr[edi+8]==0)&&(byte ptr[edi+128+2+4+4]!=0)&&(!(byte ptr[edi+60]&1))
					mov eax,[edi+128+2]
					lea	edx,dword ptr[edi+128+2]
					FWcall	2220d0h,edx,8,0,0,offset bread,0
				.endif
				movzx	ecx,word ptr[edi]
				add	edi,ecx
			.endw
			mov	esi,dword ptr[esi]
		.endw
		lea	edi,drvpath
		lea	edx,fstat6
		call	copyedx
		movzx	eax,byte ptr drvver
		call	itoa
		mov	al,'.'
		stosb
		movzx	eax,byte ptr drvver[1]
		call	w2
		mov	al,0
		stosb
		invoke	SetDlgItemText,hDlg17,64,addr drvpath
		invoke	SetDlgItemText,hDlg17,3,addr fbtn4
		and	firewall,2 xor -1
	.else
		invoke	SetDlgItemText,hDlg17,64,addr fstat5
		invoke	SetDlgItemText,hDlg17,3,addr fbtn2
		or	firewall,2
	.endif
	ret

stopdrv:
	.if hDriver
		mov	esi,hProf
		mov	edi,esi
		.while esi!=0
			lea	edi,dword ptr[esi+12]
			.while word ptr[edi]!=0
				.if (word ptr[edi+2]==-1)&&(word ptr[edi+48]!=0)&&(word ptr[edi+48]!=2)&&(byte ptr[edi+8]==0)
					mov	al,[edi+56]
					and	al,7
					.if (al==0)&&(byte ptr[edi+128+1]==1)
						lea	eax,dword ptr[edi+128+2]
						FWcall	2220d8h,eax,8,0,0,offset bread,0
					.endif
				.endif
				movzx	ecx,word ptr[edi]
				add	edi,ecx
			.endw
			mov	esi,dword ptr[esi]
		.endw
		call	drvuports
		invoke	CloseHandle,hDriver
		lea	edx,DeviceIoControl
		.if edx==_ioctl
			mov	hDriver,0
		.else
			mov	hDriver,1
		.endif
	.endif
	.if hServiceMgr
		call	initadv
		.if _OpenSCManager
			push	offset srvstat
			push	SERVICE_CONTROL_STOP
			push	hService
			call	_ControlService
		.endif
	.endif
	invoke	SetDlgItemText,hDlg17,64,addr fstat8
	invoke	SetDlgItemText,hDlg17,3,addr fbtn2
	or	firewall,2
	ret

unregdrv:
	call	initadv
	.if _OpenSCManager==0
		ret
	.endif
	.if hDriver
		mov	esi,hProf
		mov	edi,esi
		.while esi!=0
			lea	edi,dword ptr[esi+12]
			.while word ptr[edi]!=0
				.if (word ptr[edi+2]==-1)&&(word ptr[edi+48]!=0)&&(word ptr[edi+48]!=2)&&(byte ptr[edi+8]==0)
					mov	al,[edi+56]
					and	al,7
					.if (al==0)&&(byte ptr[edi+128+1]==1)
						lea	eax,dword ptr[edi+128+2]
						FWcall	2220d8h,eax,8,0,0,offset bread,0
					.endif
				.endif
				movzx	ecx,word ptr[edi]
				add	edi,ecx
			.endw
			mov	esi,dword ptr[esi]
		.endw
		invoke	CloseHandle,hDriver
		lea	edx,DeviceIoControl
		.if edx==_ioctl
			mov	hDriver,0
		.else
			mov	hDriver,1
		.endif
	.endif
	call	initadv
	.if hServiceMgr
		push	offset srvstat
		push	SERVICE_CONTROL_STOP
		push	hService
		call	_ControlService
		push	hService
		call	_DeleteService
		push	hService
		call	_CloseServiceHandle
		push	hServiceMgr
		call	_CloseServiceHandle
		mov	hServiceMgr,0
		mov	hService,0
		invoke	SetDlgItemText,hDlg17,64,addr fstat9
		invoke	SetDlgItemText,hDlg17,1,addr fbtn1
		or	firewall,3
	.elseif _OpenSCManager
		push	SC_MANAGER_ALL_ACCESS
		push	0
		push	0
		call	_OpenSCManager
		mov	hServiceMgr,eax
		.if eax
			push	eax
			invoke	GetFullPathName,addr drvsys,8192,addr drvpath,esp
			pop	eax

			push	SERVICE_ALL_ACCESS
			push	offset service1
			push	hServiceMgr
			call	_OpenService
			mov	hService,eax
			.if eax
				invoke	SetDlgItemText,hDlg17,64,addr fstat3
				invoke	SetDlgItemText,hDlg17,1,addr fbtn3
				push	offset srvstat
				push	SERVICE_CONTROL_STOP
				push	hService
				call	_ControlService
				push	hService
				call	_DeleteService
				push	hService
				call	_CloseServiceHandle
				push	hServiceMgr
				call	_CloseServiceHandle
				mov	hServiceMgr,0
				mov	hService,0
				invoke	SetDlgItemText,hDlg17,64,addr fstat9
				invoke	SetDlgItemText,hDlg17,1,addr fbtn1
				or	firewall,3
			.else
				invoke	SetDlgItemText,hDlg17,64,addr fstat5
				invoke	SetDlgItemText,hDlg17,1,addr fbtn1
				invoke	GetDlgItem,hDlg17,3
			.endif
		.endif
	.endif
	invoke	SetDlgItemText,hDlg17,3,addr fbtn2
	or	firewall,2
	ret


drv_exit:
	.if hDriver
		mov	esi,hProf
		mov	edi,esi
		.while esi!=0
			lea	edi,dword ptr[esi+12]
			.while word ptr[edi]!=0
				.if (word ptr[edi+2]==-1)&&(word ptr[edi+48]!=0)&&(word ptr[edi+48]!=2)&&(byte ptr[edi+8]==0)
					mov	al,[edi+56]
					and	al,7
					.if (al==0)&&(byte ptr[edi+128+1]==1)
						lea	eax,dword ptr[edi+128+2]
						FWcall	2220d8h,eax,8,0,0,offset bread,0
					.endif
				.endif
				movzx	ecx,word ptr[edi]
				add	edi,ecx
			.endw
			mov	esi,dword ptr[esi]
		.endw
		invoke	CloseHandle,hDriver
		lea	edx,DeviceIoControl
		.if edx==_ioctl
			mov	hDriver,0
		.else
			mov	hDriver,1
		.endif
	.endif
	.if hServiceMgr
		push	offset srvstat
		push	SERVICE_CONTROL_STOP
		push	hService
		call	_ControlService
		push	hService
		call	_DeleteService
		push	hService
		call	_CloseServiceHandle
		push	hServiceMgr
		call	_CloseServiceHandle
		mov	hServiceMgr,0
		mov	hService,0
	.endif
	ret

wsyn:	assume	edx:ptr syn_str
	.if [edx].isflood==2
		push	edx
		mov	ecx,393
		call	getlstr
		pop	edx
		push	edx
		mov	eax,[edx].lastip
		push	eax
		call	w_ip
		pop	eax
		call	w_nick
		mov	ax,' .'
		stosw
		mov	ecx,394
		call	getlstr
		pop	edx
		push	edx
		mov	eax,[edx].lastip
		lea	edx,[edx].sinfo
		mov	ecx,20
		xor	ebx,ebx
		.while ecx!=0
			assume	edx:ptr syn_info
			.if (eax==[edx].lastip)&&(ebx!=[edx].lastport)
				mov	ebx,[edx].lastport
				push	eax
				push	edx
				push	ecx
				mov	eax,ebx
				push	ebx
				xchg	al,ah
				call	itoa
				pop	ebx
				mov	ax,' ,'
				stosw
				pop	ecx
				pop	edx
				pop	eax
			.endif
			lea	edx,[edx+sizeof syn_info]
			dec	ecx
			assume	edx:ptr syn_str
		.endw
		.if word ptr[edi-2]==' ,'
			dec	edi
			dec	edi
		.endif
		pop	edx
	.elseif [edx].isflood<128
		push	edx
		.if [edx].isflood==3
			mov	ecx,395
		.elseif [edx].isflood==4
			mov	ecx,396
		.elseif [edx].isflood==6
			mov	ecx,411
		.else
			mov	ecx,397
		.endif
		call	getlstr
		pop	edx
		push	edx
		mov	eax,[edx].lastip
		push	eax
		call	w_ip
		pop	eax
		call	w_nick
		pop	edx
		push	edx
		.if ([edx].isflood!=5)
			mov	ecx,398
			call	getlstr
			pop	edx
			push	edx
			mov	eax,[edx].lastip
			lea	edx,[edx].sinfo
			mov	ecx,20
			xor	ebx,ebx
			.while ecx!=0
				assume	edx:ptr syn_info
				.if (eax==[edx].lastip)&&(bx!=word ptr[edx].lastport)
					mov	bx,word ptr[edx].lastport
					add	ebx,10000h
				.endif
				lea	edx,[edx+sizeof syn_info]
				dec	ecx
				assume	edx:ptr syn_str
			.endw
			.if ebx>20000h
				mov	ecx,399
				call	getlstr
				mov	ax,'[ '
				stosw
				pop	edx
				push	edx
				mov	eax,[edx].lastip
				lea	edx,[edx].sinfo
				mov	ecx,20
				.while ecx!=0
					xor	ebx,ebx
					assume	edx:ptr syn_info
					.if (eax==[edx].lastip)&&(ebx!=[edx].lastport)
						mov	ebx,[edx].lastport
						push	eax
						push	edx
						push	ecx
						mov	eax,ebx
						push	ebx
						xchg	al,ah
						call	itoa
						pop	ebx
						mov	ax,' ,'
						stosw
						pop	ecx
						pop	edx
						pop	eax
					.endif
					lea	edx,[edx+sizeof syn_info]
					dec	ecx
					assume	edx:ptr syn_str
				.endw
				.if word ptr[edi-2]==' ,'
					dec	edi
					dec	edi
				.endif
				mov	al,']'
				stosb
			.else
				movzx	eax,bx
				xchg	al,ah
				call	itoa
			.endif
		.endif
		pop	edx
	.endif
	assume	edx:nothing
	ret

;eax=new rights
firewallban1:
	.if (hDriver!=0)&&(byte ptr[edi+128+1]==1)&&(byte ptr[edi+8]==0)
		push	eax
		and	al,7
		.if al==0
			.if (word ptr[edi+48]==0)
				push	ebx
				push	ecx
				push	edx
				lea	eax,dword ptr[edi+128+2]
				FWcall	2220d8h,eax,8,0,0,offset bread,0
				pop	edx
				pop	ecx
				pop	ebx
			.else
				mov	al,[edi+60]
				and	al,7
				.if (al!=0)
					push	ebx
					push	ecx
					push	edx
					lea	eax,dword ptr[edi+128+2]
					FWcall	2220d0h,eax,8,0,0,offset bread,0
					pop	edx
					pop	ecx
					pop	ebx
				.endif
			.endif
		.else
			mov	al,[edi+60]
			and	al,7
			.if (al==0)
				push	ebx
				push	ecx
				push	edx
				lea	eax,dword ptr[edi+128+2]
				FWcall	2220d8h,eax,8,0,0,offset bread,0
				pop	edx
				pop	ecx
				pop	ebx
			.endif
		.endif
		pop	eax
	.endif
	ret

firewallban:
	.if (hDriver!=0)&&(byte ptr[edi+128+1]==1)&&(byte ptr[edi+8]==0)
		push	eax
		push	ebx
		and	bl,7
		.if bl==0
			mov	al,[edi+60]
			and	al,7
			.if ((al!=0)||(word ptr[edi+48]==0)||(word ptr[edi+48]==2))
				push	ebx
				push	ecx
				push	edx
				lea	eax,dword ptr[edi+128+2]
				FWcall	2220d0h,eax,8,0,0,offset bread,0
				pop	edx
				pop	ecx
				pop	ebx
			.endif
		.else
			mov	al,[edi+60]
			and	al,7
			.if (al==0)
				push	ebx
				push	ecx
				push	edx
				lea	eax,dword ptr[edi+128+2]
				FWcall	2220d8h,eax,8,0,0,offset bread,0
				pop	edx
				pop	ecx
				pop	ebx
			.endif
		.endif
		pop	ebx
		pop	eax
	.endif
	ret

banr0	db	'Port scan detected',0
banr1	db	'TCP/SYN Flood detected',0
banr2	db	'UDP Flood detected',0
banr3	db	'ICMP Flood detected',0
banr4	db	'TCP/FIN Flood detected',0
op_driver:
	mov	eax,((sizeof syn_str)+(sizeof syn_str)+(sizeof syn_str)+4+4+4+4)
	push	eax
	FWcall	2220ech,0,0,offset fsynflood,eax,offset bread,0
	push	bread
	FWcall	222108h,0,0,offset ffinflood,(sizeof syn_str)+4,offset bread,0
	pop	bread
	pop	eax
	.if (bread!=eax)
		ret
	.endif
	mov	eax,fltban
	add	eax,fltport
	mov	ecx,fltsum
	mov	fltsum,eax
	sub	eax,ecx
	add	cmdreject,eax
	mov	eax,fsynflood.lastip
	.if (eax==100007fh)||(eax==saddr.sin_addr)||(eax==_myip)||(fhflag&1)
		mov	fsynflood.isflood,0
	.elseif fsynflood.isflood
		call	has_rights
		.if eax
			mov	fsynflood.isflood,0
		.endif
	.endif
	mov	eax,fudpflood.lastip
	.if (eax==100007fh)||(eax==saddr.sin_addr)||(eax==_myip)
		mov	fudpflood.isflood,0
	.elseif fudpflood.isflood
		call	has_rights
		.if eax
			mov	fudpflood.isflood,0
		.endif
	.endif
	mov	eax,ficmpflood.lastip
	.if (eax==100007fh)||(eax==saddr.sin_addr)||(eax==_myip)
		mov	ficmpflood.isflood,0
	.elseif ficmpflood.isflood
		call	has_rights
		.if eax
			mov	ficmpflood.isflood,0
		.endif
	.endif
	mov	eax,ffinflood.lastip
;	.if (eax==100007fh)||(eax==saddr.sin_addr)||(eax==_myip)
		mov	ffinflood.isflood,0
;	.endif
	.if fsynflood.isflood==2
		.if (firewall&64)
			lea	edx,fsynflood.sinfo
			mov	eax,fsynflood.lastip
			mov	ecx,20
			xor	ebx,ebx
			.while ecx!=0
				assume	edx:ptr syn_info
				.if (eax==[edx].lastip)&&(ebx!=[edx].lastport)
					inc	ebx
				.endif
				lea	edx,[edx+sizeof syn_info]
				dec	ecx
				assume	edx:ptr syn_str
			.endw
			.if ebx>10
				mov	eax,fsynflood.lastip
				lea	edx,banr0
				call	sban0
			.endif
		.endif
	.elseif fsynflood.isflood
		.if (firewall&64)
			mov	eax,fsynflood.lastip
			lea	edx,banr1
			call	sban0
		.endif
	.elseif fudpflood.isflood
	;	.if (firewall&64)
	;		lea	edx,fudpflood.sinfo
	;		mov	eax,fudpflood.lastip
	;		mov	ecx,20
	;		xor	ebx,ebx
	;		.while ecx!=0
	;			assume	edx:ptr syn_info
	;			.if (eax==[edx].lastip)&&(ebx!=[edx].lastport)
	;				inc	ebx
	;			.endif
	;			lea	edx,[edx+sizeof syn_info]
	;			dec	ecx
	;			assume	edx:ptr syn_str
	;		.endw
	;		.if ebx>10
	;			mov	eax,fudpflood.lastip
	;			lea	edx,banr2
	;			call	sban0
	;		.endif
	;	.endif
	.elseif ficmpflood.isflood
		.if (firewall&64)
			mov	eax,ficmpflood.lastip
			lea	edx,banr3
			call	sban0
		.endif
	.elseif ffinflood.isflood
		.if (firewall&64)
			mov	eax,ffinflood.lastip
			lea	edx,banr4
			call	sban0
		.endif
	.else
		ret
	.endif
	.if (!(firewall&128))
		ret
	.endif
	assume	esi:ptr usrstruc
	push	edi
	mov	edi,offset opmsgs
	push	esi

	mov	esi,offset threads+8
	.while dword ptr[esi]!=0
		.if dword ptr[esi]!=-1
			push	esi
			push	edx
			push	ebx
			mov	esi,dword ptr [esi]
			push	edi
			.if ([esi].loggedin==1)&&([esi+1].rights&_1_info1)
				mov	eax,':oT$'
				stosd
				mov	al,32
				stosb
				lea	edx,[esi].req_name
				call	copyedx
				mov	eax,'orF '
				stosd
				mov	eax,'  :m'
				stosd
				dec	edi
				lea	edx,opchat._name
				call	copyedx
				mov	eax,' <$ '
				stosd
				dec	edi
				lea	edx,rbstruc._name
				call	copyedx
				mov	ax,' >'
				stosw
				xor	eax,eax
				.if fsynflood.isflood
					inc	eax
				.endif
				.if fudpflood.isflood
					inc	eax
				.endif
				.if ficmpflood.isflood
					inc	eax
				.endif
				.if ffinflood.isflood
					inc	eax
				.endif
				.if eax>1
					mov	eax,90a0dh
					stosd
					dec	edi
				.endif
				.if fsynflood.isflood
					lea	edx,fsynflood
					call	wsyn
					.if (fudpflood.isflood)||(ficmpflood.isflood)||(ffinflood.isflood)
						mov	eax,90a0dh
						stosd
						dec	edi
					.endif
				.endif
				.if fudpflood.isflood
					lea	edx,fudpflood
					call	wsyn
					.if (ficmpflood.isflood)||(ffinflood.isflood)
						mov	eax,90a0dh
						stosd
						dec	edi
					.endif
				.endif
				.if ffinflood.isflood==9
					lea	edx,ffinflood
					call	wsyn
					.if (ficmpflood.isflood)
						mov	eax,90a0dh
						stosd
						dec	edi
					.endif
				.endif
				.if ficmpflood.isflood
					lea	edx,ficmpflood
					call	wsyn
				.endif

				mov	al,'|'
				stosb
				pop	ecx
				push	ecx
				sub	edi,ecx
				xchg	edi,ecx
				invoke	asend,edi,ecx
			.endif
			pop	edi
			pop	ebx
			pop	edx
			pop	esi
		.endif
		assume	esi:nothing
		lea	esi,[esi+4]
	.endw
	pop	esi
	pop	edi
	ret

endm
