;	HeXHub version 5.11 Copyright (C) 2006-2014 Albu Cristian
;
;	This program is free software; you can redistribute it and/or modify
;	it under the terms of the GNU General Public License as published by
;	the Free Software Foundation.
;
;	This program is distributed in the hope that it will be useful,
;	but WITHOUT ANY WARRANTY; without even the implied warranty of
;	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;	GNU General Public License for more details.
;
;	You should have received a copy of the GNU General Public License
;	along with this program; if not, write to the Free Software
;	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
;
;	For more information send and e-mail to cristian.albu@gmail.com

ERROR_NO_SYSTEM_RESOURCES=5AAh
max_record=65536/4
max_bc=100
max_r_data=(max_record-(max_bc*(sizeof s_broadcast)))
max_r_data_	equ	(max_record-(max_bc*(sizeof s_broadcast)))

s_broadcast	struct				;broadcast		;new user
	sb_size		dd	?		;
	sb_exclude	dd	?		;
	sb_hSocket	dd	?		;
	sb_tcount	dd	?		;
	sb_type		dw	?		;0=normal broadcast	;0=normal
						;1=language broadcast	;1=hello+myinfo
						;			;
	sb_accs		dw	?		;access level
s_broadcast	ends

s_record	struct
	s_next		dd	?
	s_prev		dd	?
	s_used		dd	?		;buffer size
	s_index		dd	?
	s_sendto	dd	?		;usrstruc to send / exclude
	s_socket	dd	?
	s_tcount	dd	?
	s_pending	dd	?		;0 = send finished
	s_opcode	db	?		;0 = free
						;1 = broadcast
						;2 = new_user + $hello 4 stealth dc++ users
						;3 = language needed
						;4 = private
						;5 = active search
						;6 = passive search
						;-1= will be removed
	s_data		s_broadcast max_bc dup(<>)
	s_bc		db	max_r_data_ dup(?)
s_record	ends


s_buffer	macro
	s_started	db	?			;single send thread flag
	s_buffers	dd	?
	s_lastbuf	dd	?			;last buffer in chain
	s_private	dd	?
	s_lastpriv	dd	?
	s_lastsid	dd	?

	s_time		dd	?
	s_lasterr	dd	?			;last error
	s_min		dd	?			;minimum block
	s_select	dd	2 dup(?)
	s_timewait	dd	?,?
	s_d_users	dd	?
	s_d_timer	dd	?
	s_d_cycles	dd	?
	s_d_lastuser	dd	?
	s_critical	CRITICAL_SECTION <>		;critical section
endm

s_user		macro
	s__bufno	dd	?
	s__idx		dd	?
	s__bufpm	dd	?
	s__idxpm	dd	?
	s__retry	dd	?
	s__lastsid	dd	?
	s__logintime	dd	?
;	s__loginblock	dd	?
	s__lastsendtime	dd	?
	s__leveltime	dd	?
	s__privcnt	dd	?
endm

s_sendthread	macro
assume	edx:ptr s_record
assume	esi:ptr usrstruc
s__thread	PROC	lParam:DWORD
	invoke	GetTickCount
	mov	s_time,eax
	.while 1
		.if distribfactor
				mov	eax,users
				xor	edx,edx
				mov	ecx,distribfactor
				mov	s_d_cycles,ecx
				.if ecx
					div	ecx
				.endif
				inc	eax
				mov	s_d_users,eax
				xor	edx,edx
				mov	eax,sndtimer1
				mov	s_min,-1
				mov	s_d_lastuser,offset threads+8
				.if eax
					div	ecx
					inc	eax
					mov	s_d_timer,eax
					mov	ecx,s_d_cycles
					.if ecx
						dec	ecx
					.endif
					mov	eax,sndtimer
					mov	s_time,eax
					.while ecx
						.if s_started==0
							mov	s_started,2
							invoke	ExitThread,0
						.endif
						push	ecx
						mov	eax,s_time
						.if eax>sndtimer
							mov	eax,sndtimer
							sub	s_time,eax
							call	s__private
						.endif
						push	s_d_users
						call	s__public
						pop	s_d_users
						.if s_d_timer
							invoke	Sleep,s_d_timer
							mov	eax,s_d_timer
							add	s_time,eax
						.else
							invoke	Sleep,1
							add	s_time,1
						.endif
						pop	ecx
						dec	ecx
						.break .if s_d_lastuser==0
					.endw
					.if s_d_lastuser
						call	s__private
						mov	s_d_users,-1
						call	s__public
					.endif
				.else
					mov	ecx,s_d_cycles
					.if ecx
						dec	ecx
					.endif
					.while ecx
						.if s_started==0
							mov	s_started,2
							invoke	ExitThread,0
						.endif
						push	ecx
						call	s__private
						push	s_d_users
						call	s__public
						pop	s_d_users
						.if sndtimer<1
							invoke	Sleep,1
						.else
							invoke	Sleep,sndtimer
						.endif
						pop	ecx
						dec	ecx
						.break .if s_d_lastuser==0
					.endw
					.if s_d_lastuser
						call	s__private
						mov	s_d_users,-1
						call	s__public
					.endif
				.endif
		.else
			.while 1
				.if s_started==0
					mov	s_started,2
					invoke	ExitThread,0
				.else
					call	s__private
					.if sndtimer<1
						invoke	Sleep,1
					.else
						invoke	Sleep,sndtimer
					.endif
					invoke	GetTickCount
					mov	ecx,eax
					sub	eax,s_time
					.break .if eax>=sndtimer1
				.endif
			.endw
			mov	s_d_lastuser,offset threads+8
			mov	s_d_users,-1
			mov	s_time,ecx
			mov	s_min,-1
			call	s__public
		.endif

	.endw
	invoke	ExitThread,0
	ret
s__thread	ENDP

s__private:
		inc	s_lastsid
		mov	edx,s_private
		.while (edx!=0)&&([edx].s_pending!=0)
			.if [edx].s_opcode==4
				push	edx
				call	s__pm
				pop	edx
			.endif
			mov	edx,[edx].s_next
		.endw
		invoke	EnterCriticalSection,addr s_critical
		mov	edx,s_private
		.if (IOCPf&128)&&(IOCPf&4)
			.while (edx!=s_lastpriv)&&([edx].s_opcode!=0)
				mov	esi,[edx].s_sendto
				mov	eax,[esi].hSocket
				.if ([esi].outDisable&4)
					xor	eax,eax
				.endif
				.if ([edx].s_opcode==-1)||(eax!=[edx].s_socket)||(eax==0)		;(!([esi].waiting&32))&&
					mov	[edx].s_opcode,0
					mov	[edx].s_pending,0
					assume	ecx:ptr s_record
					mov	eax,[edx].s_next
					mov	ecx,[edx].s_prev
					.if ecx
						mov	[ecx].s_next,eax
					.else
						mov	s_private,eax
					.endif
					assume	eax:ptr s_record
					mov	[eax].s_prev,ecx
					assume	eax:nothing
					mov	ecx,s_lastpriv
					mov	[ecx].s_next,edx
					mov	[edx].s_prev,ecx
					mov	[edx].s_next,0
					mov	s_lastpriv,edx
					mov	edx,eax
					assume	ecx:nothing
				.else
					mov	edx,[edx].s_next
				.endif
			.endw
		.else
			.while (edx!=s_lastpriv)&&(edx!=0)&&([edx].s_opcode!=0)
				mov	esi,[edx].s_sendto
				mov	eax,[esi].hSocket
				.if (eax!=[edx].s_socket)||(eax==0)||([edx].s_opcode==-1)
					mov	[edx].s_opcode,0
					mov	[edx].s_pending,0
					assume	ecx:ptr s_record
					mov	eax,[edx].s_next
					mov	ecx,[edx].s_prev
					.if ecx
						mov	[ecx].s_next,eax
					.else
						mov	s_private,eax
					.endif
					assume	eax:ptr s_record
					mov	[eax].s_prev,ecx
					assume	eax:nothing
					mov	ecx,s_lastpriv
					mov	[ecx].s_next,edx
					mov	[edx].s_prev,ecx
					mov	[edx].s_next,0
					mov	s_lastpriv,edx
					mov	edx,eax
					assume	ecx:nothing
				.else
					mov	edx,[edx].s_next
				.endif
			.endw
		.endif
		invoke	LeaveCriticalSection,addr s_critical
	ret


s__public:
		mov	edx,s_buffers
		.if [edx].s_pending
			mov	edi,s_d_lastuser
			.while dword ptr[edi]!=0
				.if dword ptr[edi]!=-1
					mov	esi,[edi]
					push	edi
					.if ([esi].hSocket!=0)&&([esi].s__idxpm==0)&&([esi].s__bufno!=0)&&(!([esi].outDisable&4))&&([esi].s__privcnt==0)&&(!([esi]._web&1))
						mov	edx,[esi].s__bufno
						.if ([esi].loggedin==1)&&([esi].pm_is_spam<2)&&(!([esi].waiting&2))
							mov	eax,[edx].s_index
							.if (eax>=max_cache_lvl)&&([esi].s__idx==0)
								mov	eax,tcount
								sub	eax,[esi].s__leveltime
								.if eax>=leveltimeout
									mov	eax,tcount
									mov	[esi].s__leveltime,eax
									jmp	s__nextlevel
								.endif
							.else
s__nextlevel:							push	[esi].s__retry
								push	esi
								.if [esi].s__retry==1
									mov	eax,tcount
									mov	[esi].s__lastsendtime,eax
								.endif
								.if ([esi].waiting&32)&&(IOCPf&128)&&(IOCPf&4)
									.if timeout1
										mov	eax,[esi].s__lastsendtime
										sub	eax,tcount
										.if eax>7fffffffh
											neg	eax
										.endif
										.if eax>timeout1
											onError	[esi].sessionId,2
											call	closeconn
										.endif
									.endif
								.else
								.if [esi].myinfwait&4096
									.while ([edx].s_opcode!=0)&&(edx!=s_lastbuf)
										.if ([edx].s_opcode==1)
											call	s__bcast
											.break
										.elseif ([edx].s_opcode==5)||(([edx].s_opcode==6)&&((!([esi+4].hubs&4))||(!(s_search.cmdflag&32))))
											.if ([edx].s_tcount!=0)||(esi==[edx].s_sendto)
												call	s__search
												.break
											.endif
										.elseif ([edx].s_opcode==3)
											call	s__lang
											.break
										.elseif ([edx].s_opcode==7)
											call	s__nickchg
											.break
										.endif
										mov	edx,[edx].s_next
										.break .if edx==0
										mov	[esi].s__bufno,edx
										mov	[esi].s__retry,0
										mov	[esi].s__idx,0
									.endw
								.else
									.while ([edx].s_opcode!=0)&&(edx!=s_lastbuf)
										.if ([edx].s_opcode==1)
											call	s__bcast1
											.break
										.elseif ([edx].s_opcode==2)
											call	s__bcast
											.break
										.elseif ([edx].s_opcode==5)||(([edx].s_opcode==6)&&((!([esi+4].hubs&4))||(!(s_search.cmdflag&32))))
											.if ([edx].s_tcount!=0)||(esi==[edx].s_sendto)
												call	s__search
												.break
											.endif
										.elseif ([edx].s_opcode==3)
											call	s__lang
											.break
										.elseif ([edx].s_opcode==7)
											call	s__nickchg
											.break
										.endif
										mov	edx,[edx].s_next
										.break .if edx==0
										mov	[esi].s__bufno,edx
										mov	[esi].s__retry,0
										mov	[esi].s__idx,0
									.endw
								.endif
								.endif
								pop	esi
								pop	eax
								.if timeout1&&(eax!=[esi].s__retry)&&([esi].s__retry>1)
									mov	eax,tcount
									sub	eax,[esi].s__lastsendtime
									.if eax>7fffffffh
										neg	eax
									.endif
									.if eax>timeout1
										onError	[esi].sessionId,2
										call	closeconn
									.endif
								.endif
							.endif
							mov	edx,[esi].s__bufno
							mov	eax,[edx].s_index
							.if eax<s_min
								mov	s_min,eax
							.endif
						.elseif [esi].pm_is_spam>=2
							.if edx
								mov	[esi].s__idx,0
								.while ([edx].s_opcode!=0)&&(edx!=s_lastbuf)
									mov	edx,[edx].s_next
									.break .if edx==0
									mov	[esi].s__bufno,edx
									mov	[esi].s__retry,0
									mov	[esi].s__idx,0
								.endw
							.endif
						.else
							mov	eax,tcount
							sub	eax,[esi].conntime
							.if eax>7fffffffh
								neg	eax
							.endif
							.if (s_validatenick.cmdflag&1)&&(eax>=s_validatenick.cmdparam1)
								onBadSettings	30
								.if eax
									mov	eax,tcount
									mov	[esi].conntime,eax
									onError	[esi].sessionId,1
									invoke	asend,addr _timeout,sizeof _timeout
									call	disconn			;
								.endif
							.elseif (eax>httpwait)&&(httpflags&1)&&(!(httpflags&2))&&(!([esi].myinfwait1&32))
								movzx	edx,[esi].connport
								.if dx==httpport
									call	sendlock
								.endif
							.endif
						.endif
					.endif
					pop	edi
				.endif
				lea	edi,[edi+4]
				.if s_d_users
					dec	s_d_users
					.if s_d_users==0
						mov	s_d_lastuser,edi
						ret
					.endif
				.endif
			.endw

			;remove commands
			invoke	EnterCriticalSection,addr s_critical
			.if s_min!=-1
				.while s_min>1
					mov	edx,s_buffers
					mov	[edx].s_opcode,0
					mov	[edx].s_pending,0
					assume	ecx:ptr s_record
					mov	eax,[edx].s_next
					mov	ecx,[edx].s_prev
					mov	s_buffers,eax
					assume	eax:ptr s_record
					mov	[eax].s_prev,ecx
					assume	eax:nothing
					mov	ecx,s_lastbuf
					mov	[ecx].s_next,edx
					mov	[edx].s_prev,ecx
					mov	[edx].s_next,0
					mov	s_lastbuf,edx
					assume	ecx:nothing
					dec	s_min
				.endw
			.endif
			xor	ecx,ecx
			inc	ecx
			mov	edx,s_buffers
			.while edx!=0
				.if [edx].s_opcode==0
					mov	[edx].s_pending,0
				.endif
				mov	[edx].s_index,ecx
				mov	edx,[edx].s_next
				inc	ecx
			.endw
			invoke	LeaveCriticalSection,addr s_critical
			mov	s_d_lastuser,0
		.endif
	ret


delpriv:	invoke	EnterCriticalSection,addr s_critical
		mov	edx,s_private
		.while (edx!=s_lastpriv)&&([edx].s_opcode!=0)
			.if (esi==[edx].s_sendto)||([edx].s_opcode==-1)
				mov	[edx].s_opcode,0
				mov	[edx].s_pending,0
				assume	ecx:ptr s_record
				mov	eax,[edx].s_next
				mov	ecx,[edx].s_prev
				.if ecx
					mov	[ecx].s_next,eax
				.else
					mov	s_private,eax
				.endif
				assume	eax:ptr s_record
				mov	[eax].s_prev,ecx
				assume	eax:nothing
				mov	ecx,s_lastpriv
				mov	[ecx].s_next,edx
				mov	[edx].s_prev,ecx
				mov	[edx].s_next,0
				mov	s_lastpriv,edx
				mov	edx,eax
				assume	ecx:nothing
			.else
				mov	edx,[edx].s_next
			.endif
		.endw
		invoke	LeaveCriticalSection,addr s_critical
	ret

;edi,ecx
s_add_private:
		.if ([esi].hSocket==0)||(ecx==0)||(edi==0)
			ret
		.elseif ecx>=(max_r_data-1024)
			push	edi
			.while 1
				push	ecx
				push	edi
				.if ecx>=(max_r_data-1024)
					mov	ecx,(max_r_data-1024)
				.endif
				call	s_a_p
				pop	edi
				pop	ecx
				.break .if ecx<(max_r_data-1024)
				sub	ecx,max_r_data-1024
				add	edi,max_r_data-1024
				.break .if ecx==0
			.endw
			pop	edi
			ret
		.endif
s_a_p:		push	ebx
		push	ecx
		invoke	EnterCriticalSection,addr s_critical
		pop	ecx
		mov	edx,s_private
		.while edx!=s_lastpriv
			.if ([edx].s_opcode==4)&&([edx].s_pending==-1)&&([edx].s_sendto==esi)
				mov	eax,[esi].hSocket
				.if eax==[edx].s_socket
					mov	eax,max_r_data-256
					sub	eax,[edx].s_used
					.if ([edx].s_used!=0)&&(eax>ecx)
						push	esi
						push	edi
						mov	eax,[edx].s_used
						add	[edx].s_used,ecx
						mov	esi,edi
						lea	edi,[edx+eax].s_data
						push	edi
						push	ecx
						rep	movsb
						pop	ecx
						pop	edi
						mov	esi,[esp+4]
						push	ecx
						invoke	zcompress,edi,ecx
						pop	eax
						sub	eax,ecx
						sub	[edx].s_used,eax
						pop	edi
						pop	esi
						invoke	LeaveCriticalSection,addr s_critical
						pop	ebx
						ret
					.endif
					mov	[edx].s_pending,-2
				.endif
			.endif
			.if ([edx].s_pending==0)
				push	esi
				push	edi
		;		inc	[esi].s__privcnt
				mov	[edx].s_opcode,4
				mov	[edx].s_used,ecx
				mov	[edx].s_sendto,esi
				mov	eax,[esi].hSocket
				mov	[edx].s_socket,eax
				mov	esi,edi
				lea	edi,[edx].s_data
				push	edi
				push	ecx
				rep	movsb
				pop	ecx
				pop	edi
				mov	esi,[esp+4]
				push	ecx
				invoke	zcompress,edi,ecx
				pop	eax
				sub	eax,ecx
				sub	[edx].s_used,eax
				mov	[edx].s_pending,-1		;send not started
				pop	edi
				pop	esi
				invoke	LeaveCriticalSection,addr s_critical
				pop	ebx
				ret
			.endif
			mov	edx,[edx].s_next
		.endw
		push	esi
		push	edi
	;	inc	[esi].s__privcnt
		mov	[edx].s_next,0
		mov	[edx].s_opcode,4
		mov	[edx].s_used,ecx
		mov	[edx].s_sendto,esi
		mov	esi,edi
		lea	edi,[edx].s_data
		push	edi
		push	ecx
		rep	movsb
		pop	ecx
		pop	edi
		mov	esi,[esp+4]
		push	ecx
		invoke	zcompress,edi,ecx
		pop	eax
		sub	eax,ecx
		sub	[edx].s_used,eax
		pop	edi
		pop	esi
		mov	eax,[esi].hSocket
		mov	[edx].s_socket,eax

		push	edx
		invoke	GlobalAlloc,GPTR,sizeof s_record
		pop	edx
		.if eax
			assume	eax:ptr s_record
			mov	[eax].s_prev,edx
			mov	[eax].s_next,0
			mov	[edx].s_next,eax
			mov	[eax].s_opcode,0
			mov	[eax].s_used,0
			mov	[eax].s_pending,0
			mov	ecx,[edx].s_index
			inc	ecx
			mov	[eax].s_index,ecx
			mov	s_lastpriv,eax
			mov	[edx].s_pending,-1		;send not started
		.else
			mov	[edx].s_opcode,0
			mov	[edx].s_sendto,0
			call	no_mem
		.endif
		assume	eax:nothing
		invoke	LeaveCriticalSection,addr s_critical
		pop	ebx
		ret

s_disconn:
	.if [esi].hSocket==0
		ret
	.endif
	or	[esi].waiting,2
	push	ebx
	push	ecx
	invoke	EnterCriticalSection,addr s_critical
	pop	ecx
	mov	edx,s_private
	.while edx!=s_lastpriv
		.if ([edx].s_pending==0)
			mov	[edx].s_opcode,4
			mov	[edx].s_used,0
			mov	[edx].s_sendto,esi
			mov	eax,[esi].hSocket
			mov	[edx].s_socket,eax
			mov	[edx].s_pending,-1		;send not started
			invoke	LeaveCriticalSection,addr s_critical
			pop	ebx
			ret
		.endif
		mov	edx,[edx].s_next
	.endw
	mov	[edx].s_next,0
	mov	[edx].s_opcode,4
	mov	[edx].s_used,0
	mov	[edx].s_sendto,esi
	mov	eax,[esi].hSocket
	mov	[edx].s_socket,eax

	push	edx
	invoke	GlobalAlloc,GPTR,sizeof s_record
	pop	edx
	push	eax
	.if eax
		assume	eax:ptr s_record
		mov	[eax].s_prev,edx
		mov	[eax].s_next,0
		mov	[edx].s_next,eax
		mov	[eax].s_opcode,0
		mov	[eax].s_used,0
		mov	[eax].s_pending,0
		mov	ecx,[edx].s_index
		inc	ecx
		mov	[eax].s_index,ecx
		mov	s_lastpriv,eax
		mov	[edx].s_pending,-1		;send not started
		assume	eax:nothing
	.else
		mov	[edx].s_opcode,0
		mov	[edx].s_sendto,0
	.endif
	push	edx
	push	eax
	invoke	LeaveCriticalSection,addr s_critical
	pop	eax
	pop	edx
	pop	eax
	.if eax==0
		call	closeconn
		call	no_mem
	.endif
	pop	ebx
	ret

s_add_search:
		.if [esi].hSocket==0
			ret
		.endif
		push	edx
		push	ebx
		push	ecx
		invoke	EnterCriticalSection,addr s_critical
		pop	ecx
		mov	edx,s_buffers
		.while edx!=s_lastbuf
			.if ([edx].s_pending==-1)&&((([edx].s_opcode==5)&&(byte ptr[edi+8]!='H'))||(([edx].s_opcode==6)&&(byte ptr[edi+8]=='H')))
				mov	eax,max_r_data-256
				sub	eax,[edx].s_used
				.if (eax>ecx)
					push	esi
					push	edi
					mov	eax,[edx].s_used
					add	[edx].s_used,ecx
					mov	esi,edi
					lea	edi,[edx+eax].s_data
					rep	movsb
					pop	edi
					pop	esi
					mov	eax,[esp+4]
					mov	eax,[eax]
					mov	[edx].s_sendto,eax
					.if (s_search.cmdflag&1)&&(!([esi+5].rights&_5_spam2))
						mov	[edx].s_tcount,0
					.else
						mov	[edx].s_tcount,-1
					.endif
					invoke	LeaveCriticalSection,addr s_critical
					pop	ebx
					pop	edx
					ret
				.endif
				mov	[edx].s_pending,-2
			.endif
			.if ([edx].s_pending==0)
				push	esi
				push	edi
				.if (byte ptr[edi+8]!='H')
					mov	[edx].s_opcode,5
				.else
					mov	[edx].s_opcode,6
				.endif
				mov	[edx].s_used,ecx
				mov	esi,edi
				lea	edi,[edx].s_data
				rep	movsb
				mov	[edx].s_pending,-1		;send not started
				pop	edi
				pop	esi
				mov	eax,[esp+4]
				mov	eax,[eax]
				mov	[edx].s_sendto,eax
				.if (s_search.cmdflag&1)&&(!([esi+5].rights&_5_spam2))
					mov	[edx].s_tcount,0
				.else
					mov	[edx].s_tcount,-1
				.endif
				invoke	LeaveCriticalSection,addr s_critical
				pop	ebx
				pop	edx
				ret
			.endif
			mov	edx,[edx].s_next
		.endw
		mov	eax,[esp+4]
		mov	eax,[eax]
		mov	[edx].s_sendto,eax
		.if (s_search.cmdflag&1)&&(!([esi+5].rights&_5_spam2))
			mov	[edx].s_tcount,0
		.else
			mov	[edx].s_tcount,-1
		.endif
		push	esi
		push	edi
		mov	[edx].s_next,0
		.if (byte ptr[edi+8]!='H')
			mov	[edx].s_opcode,5
		.else
			mov	[edx].s_opcode,6
		.endif
		mov	[edx].s_used,ecx
		mov	esi,edi
		lea	edi,[edx].s_data
		rep	movsb
		pop	edi
		pop	esi

		push	edx
		invoke	GlobalAlloc,GPTR,sizeof s_record
		pop	edx
		.if eax
			assume	eax:ptr s_record
			mov	[eax].s_prev,edx
			mov	[eax].s_next,0
			mov	[edx].s_next,eax
			mov	[eax].s_opcode,0
			mov	[eax].s_used,0
			mov	[eax].s_pending,0
			mov	ecx,[edx].s_index
			inc	ecx
			mov	[eax].s_index,ecx
			mov	s_lastbuf,eax
			mov	[edx].s_pending,-1		;send not started
			assume	eax:nothing
		.else
			mov	[edx].s_opcode,0
			mov	[edx].s_sendto,0
			mov	[edx].s_pending,0
			call	no_mem
		.endif
		invoke	LeaveCriticalSection,addr s_critical
		pop	ebx
		pop	edx
		ret


;ebx=lptr
s_add_lang:
		push	edx
		push	ecx
		invoke	EnterCriticalSection,addr s_critical
		pop	ecx
		mov	edx,s_buffers
		.while edx!=s_lastbuf
			.if ([edx].s_pending==0)
				pop	eax
				push	eax
				push	esi
				push	edi
				mov	[edx].s_opcode,3
				mov	[edx].s_used,ecx
				mov	esi,edi
				lea	edi,[edx].s_data
				stosd
				rep	movsb
				mov	[edx].s_pending,-1		;send not started
				pop	edi
				pop	esi
				mov	[edx].s_sendto,esi
				mov	eax,[esi].hSocket
				mov	[edx].s_socket,eax
				mov	eax,tcount
				mov	[edx].s_tcount,eax
				invoke	LeaveCriticalSection,addr s_critical
				pop	edx
				ret
			.endif
			mov	edx,[edx].s_next
		.endw
		mov	[edx].s_sendto,esi
		mov	eax,[esi].hSocket
		mov	[edx].s_socket,eax
		mov	eax,tcount
		mov	[edx].s_tcount,eax
		pop	eax
		push	eax
		push	esi
		push	edi
		mov	[edx].s_next,0
		mov	[edx].s_opcode,3
		mov	[edx].s_used,ecx
		mov	esi,edi
		lea	edi,[edx].s_data
		stosd
		rep	movsb
		pop	edi
		pop	esi

		push	edx
		invoke	GlobalAlloc,GPTR,sizeof s_record
		pop	edx
		.if eax
			assume	eax:ptr s_record
			mov	[eax].s_prev,edx
			mov	[eax].s_next,0
			mov	[edx].s_next,eax
			mov	[eax].s_opcode,0
			mov	[eax].s_used,0
			mov	[eax].s_pending,0
			mov	ecx,[edx].s_index
			inc	ecx
			mov	[eax].s_index,ecx
			mov	s_lastbuf,eax
			mov	[edx].s_pending,-1		;send not started
			assume	eax:nothing
		.else
			mov	[edx].s_opcode,0
			mov	[edx].s_pending,0
			mov	[edx].s_sendto,0
			call	no_mem
		.endif
		invoke	LeaveCriticalSection,addr s_critical
		pop	edx
		ret

s_add_nickchange:
		.if [esi].hSocket==0
			ret
		.endif
		push	edx
		push	ebx
		push	ecx
		invoke	EnterCriticalSection,addr s_critical
		pop	ecx
		mov	edx,s_buffers
		.while edx!=s_lastbuf
			.if ([edx].s_pending==-1)&&([edx].s_opcode==7)
				mov	eax,max_r_data-256
				sub	eax,[edx].s_used
				.if (eax>ecx)
					push	esi
					push	edi
					mov	eax,[edx].s_used
					add	[edx].s_used,ecx
					mov	esi,edi
					lea	edi,[edx+eax].s_data
					rep	movsb
					pop	edi
					pop	esi
					mov	eax,[esp+4]
					mov	eax,[eax]
					mov	[edx].s_sendto,eax
					mov	eax,tcount
					mov	[edx].s_tcount,eax
					invoke	LeaveCriticalSection,addr s_critical
					pop	ebx
					pop	edx
					ret
				.endif
				mov	[edx].s_pending,-2
			.endif
			.if ([edx].s_pending==0)
				push	esi
				push	edi
				mov	[edx].s_opcode,7
				mov	[edx].s_used,ecx
				mov	esi,edi
				lea	edi,[edx].s_data
				rep	movsb
				mov	[edx].s_pending,-1		;send not started
				pop	edi
				pop	esi
				mov	eax,[esp+4]
				mov	eax,[eax]
				mov	[edx].s_sendto,eax
				mov	eax,tcount
				mov	[edx].s_tcount,eax
				invoke	LeaveCriticalSection,addr s_critical
				pop	ebx
				pop	edx
				ret
			.endif
			mov	edx,[edx].s_next
		.endw
		mov	eax,[esp+4]
		mov	eax,[eax]
		mov	[edx].s_sendto,eax
		mov	eax,tcount
		mov	[edx].s_tcount,eax
		push	esi
		push	edi
		mov	[edx].s_next,0
		mov	[edx].s_opcode,7
		mov	[edx].s_used,ecx
		mov	esi,edi
		lea	edi,[edx].s_data
		rep	movsb
		pop	edi
		pop	esi

		push	edx
		invoke	GlobalAlloc,GPTR,sizeof s_record
		pop	edx
		.if eax
			assume	eax:ptr s_record
			mov	[eax].s_prev,edx
			mov	[eax].s_next,0
			mov	[edx].s_next,eax
			mov	[eax].s_opcode,0
			mov	[eax].s_used,0
			mov	[eax].s_pending,0
			mov	ecx,[edx].s_index
			inc	ecx
			mov	[eax].s_index,ecx
			mov	s_lastbuf,eax
			mov	[edx].s_pending,-1		;send not started
			assume	eax:nothing
		.else
			mov	[edx].s_opcode,0
			mov	[edx].s_sendto,0
			mov	[edx].s_pending,0
			call	no_mem
		.endif
		invoke	LeaveCriticalSection,addr s_critical
		pop	ebx
		pop	edx
		ret

s_add_bc:
	.if ecx>(max_r_data-1024)
		push	edi
		.while 1
			push	ecx
			push	edi
			.if ecx>=(max_r_data-1024)
				mov	ecx,(max_r_data-1024)
			.endif
			call	s_a_bc
			pop	edi
			pop	ecx
			.break .if ecx<=(max_r_data-1024)
			sub	ecx,max_r_data-1024
			add	edi,max_r_data-1024
			.break .if ecx==0
		.endw
		pop	edi
		ret
	.endif
	assume	ebx:ptr s_broadcast
s_a_bc:		push	ebx
		push	ecx
		invoke	EnterCriticalSection,addr s_critical
		pop	ecx
		mov	edx,s_buffers
		.while edx!=s_lastbuf
			.if ([edx].s_opcode==1)&&([edx].s_pending==-1)
				lea	ebx,[edx].s_data
				push	ecx
				xor	eax,eax
				xor	ecx,ecx
				.while ecx<(max_bc-1)
					.if dword ptr[ebx]==-1
						pop	ecx
						mov	eax,max_r_data
						sub	eax,[edx].s_used
						.if (eax>ecx)
							mov	eax,[esi].access
							mov	[ebx].sb_accs,ax
							mov	[ebx].sb_size,ecx
							mov	[ebx].sb_exclude,esi
							xor	eax,eax
							mov	eax,[esi].hSocket
							mov	[ebx].sb_hSocket,eax
							mov	[ebx].sb_type,0
							mov	eax,tcount
							mov	[ebx].sb_tcount,eax
							mov	dword ptr[ebx+sizeof s_broadcast],-1
							push	esi
							push	edi
							mov	eax,[edx].s_used
							add	[edx].s_used,ecx
							mov	esi,edi
							lea	edi,[edx+eax].s_bc
							rep	movsb
							pop	edi
							pop	esi
							invoke	LeaveCriticalSection,addr s_critical
							pop	ebx
							ret
						.endif
						mov	[edx].s_pending,-2
						push	ecx
						.break
					.endif
					lea	ebx,[ebx+sizeof s_broadcast]
					inc	ecx
				.endw
				mov	[edx].s_pending,-2
				pop	ecx
			.endif
			.if ([edx].s_pending==0)
				lea	ebx,[edx].s_data
				mov	[ebx].sb_size,ecx
				mov	eax,[esi].access
				mov	[ebx].sb_accs,ax
				mov	[ebx].sb_exclude,esi
				xor	eax,eax
				mov	eax,[esi].hSocket
				mov	[ebx].sb_hSocket,eax
				mov	[ebx].sb_type,0
				mov	eax,tcount
				mov	[ebx].sb_tcount,eax
				mov	dword ptr[ebx+sizeof s_broadcast],-1
				push	esi
				push	edi
				mov	[edx].s_opcode,1
				mov	[edx].s_used,ecx
				mov	esi,edi
				lea	edi,[edx].s_bc
				rep	movsb
				mov	[edx].s_pending,-1		;send not started
				pop	edi
				pop	esi
				invoke	LeaveCriticalSection,addr s_critical
				pop	ebx
				ret
			.endif
			mov	edx,[edx].s_next
		.endw
		lea	ebx,[edx].s_data
		mov	eax,[esi].access
		mov	[ebx].sb_accs,ax
		mov	[ebx].sb_size,ecx
		mov	[ebx].sb_exclude,esi
		xor	eax,eax
		mov	eax,[esi].hSocket
		mov	[ebx].sb_hSocket,eax
		mov	[ebx].sb_type,0
		mov	eax,tcount
		mov	[ebx].sb_tcount,eax
		mov	dword ptr[ebx+sizeof s_broadcast],-1
		push	esi
		push	edi
		mov	[edx].s_next,0
		mov	[edx].s_opcode,1
		mov	[edx].s_used,ecx
		mov	[edx].s_sendto,esi
		mov	esi,edi
		lea	edi,[edx].s_bc
		rep	movsb
		pop	edi
		pop	esi
		mov	eax,[esi].hSocket
		mov	[edx].s_socket,eax

		push	edx
		invoke	GlobalAlloc,GPTR,sizeof s_record
		pop	edx
		.if eax
			assume	eax:ptr s_record
			mov	[eax].s_prev,edx
			mov	[eax].s_next,0
			mov	[edx].s_next,eax
			mov	[eax].s_opcode,0
			mov	[eax].s_used,0
			mov	[eax].s_pending,0
			mov	ecx,[edx].s_index
			inc	ecx
			mov	[eax].s_index,ecx
			mov	s_lastbuf,eax
			mov	[edx].s_pending,-1		;send not started
			assume	eax:nothing
		.else
			mov	[edx].s_opcode,0
			mov	[edx].s_pending,0
			mov	[edx].s_sendto,0
			call	no_mem
		.endif
		invoke	LeaveCriticalSection,addr s_critical
		pop	ebx
	assume	ebx:nothing
	ret

s_add_user:
	assume	ebx:ptr s_broadcast
	push	ebx
	push	ecx
	invoke	EnterCriticalSection,addr s_critical
	pop	ecx
	mov	edx,s_buffers
	.while edx!=s_lastbuf
		.if ([edx].s_opcode==1)&&([edx].s_pending==-1)
			lea	ebx,[edx].s_data
			push	ecx
			xor	eax,eax
			xor	ecx,ecx
			.while ecx<(max_bc-1)
				.if dword ptr[ebx]==-1
					pop	ecx
					mov	eax,max_r_data
					sub	eax,[edx].s_used
					.if (eax>ecx)
						mov	[ebx].sb_size,ecx
						mov	[ebx].sb_exclude,esi
						xor	eax,eax
						mov	eax,[esi].hSocket
						mov	[ebx].sb_hSocket,eax
						mov	[ebx].sb_type,1
						mov	eax,tcount
						mov	[ebx].sb_tcount,eax
						mov	dword ptr[ebx+sizeof s_broadcast],-1
						push	esi
						push	edi
						mov	eax,[edx].s_used
						add	[edx].s_used,ecx
						mov	esi,edi
						lea	edi,[edx+eax].s_bc
						rep	movsb
						pop	edi
						pop	esi
						invoke	LeaveCriticalSection,addr s_critical
						pop	ebx
						ret
					.endif
					mov	[edx].s_pending,-2
					push	ecx
					.break
				.endif
				lea	ebx,[ebx+sizeof s_broadcast]
				inc	ecx
			.endw
			mov	[edx].s_pending,-2
			pop	ecx
		.endif
		.if ([edx].s_pending==0)
			lea	ebx,[edx].s_data
			mov	[ebx].sb_size,ecx
			mov	[ebx].sb_exclude,esi
			xor	eax,eax
			mov	eax,[esi].hSocket
			mov	[ebx].sb_hSocket,eax
			mov	eax,tcount
			mov	[ebx].sb_tcount,eax
			mov	[ebx].sb_type,1
			mov	dword ptr[ebx+sizeof s_broadcast],-1
			push	esi
			push	edi
			mov	[edx].s_opcode,1
			mov	[edx].s_used,ecx
			mov	esi,edi
			lea	edi,[edx].s_bc
			rep	movsb
			mov	[edx].s_pending,-1		;send not started
			pop	edi
			pop	esi
			invoke	LeaveCriticalSection,addr s_critical
			pop	ebx
			ret
		.endif
		mov	edx,[edx].s_next
	.endw
	lea	ebx,[edx].s_data
	mov	[ebx].sb_size,ecx
	mov	[ebx].sb_exclude,esi
	xor	eax,eax
	mov	eax,[esi].hSocket
	mov	[ebx].sb_hSocket,eax
	mov	[ebx].sb_type,1
	mov	eax,tcount
	mov	[ebx].sb_tcount,eax
	mov	dword ptr[ebx+sizeof s_broadcast],-1
	push	esi
	push	edi
	mov	[edx].s_next,0
	mov	[edx].s_opcode,1
	mov	[edx].s_used,ecx
	mov	[edx].s_sendto,esi
	mov	esi,edi
	lea	edi,[edx].s_bc
	rep	movsb
	pop	edi
	pop	esi
	mov	eax,[esi].hSocket
	mov	[edx].s_socket,eax

	push	edx
	invoke	GlobalAlloc,GPTR,sizeof s_record
	pop	edx
	.if eax
		assume	eax:ptr s_record
		mov	[eax].s_prev,edx
		mov	[eax].s_next,0
		mov	[edx].s_next,eax
		mov	[eax].s_opcode,0
		mov	[eax].s_used,0
		mov	[eax].s_pending,0
		mov	ecx,[edx].s_index
		inc	ecx
		mov	[eax].s_index,ecx
		mov	s_lastbuf,eax
		mov	[edx].s_pending,-1		;send not started
		assume	eax:nothing
	.else
		mov	[edx].s_opcode,0
		mov	[edx].s_pending,0
		mov	[edx].s_sendto,0
		call	no_mem
	.endif
	invoke	LeaveCriticalSection,addr s_critical
	pop	ebx
	assume	ebx:nothing
	ret

s_add_user1:
	assume	ebx:ptr s_broadcast
	push	ebx
	push	ecx
	invoke	EnterCriticalSection,addr s_critical
	pop	ecx
	mov	edx,s_buffers
	.while edx!=s_lastbuf
		.if ([edx].s_opcode==2)&&([edx].s_pending==-1)
			lea	ebx,[edx].s_data
			push	ecx
			xor	eax,eax
			xor	ecx,ecx
			.while ecx<(max_bc-1)
				.if dword ptr[ebx]==-1
					pop	ecx
					mov	eax,max_r_data
					sub	eax,[edx].s_used
					.if (eax>ecx)
						mov	[ebx].sb_size,ecx
						mov	[ebx].sb_exclude,esi
						xor	eax,eax
						mov	eax,[esi].hSocket
						mov	[ebx].sb_hSocket,eax
						mov	[ebx].sb_type,0
						mov	eax,tcount
						mov	[ebx].sb_tcount,eax
						mov	dword ptr[ebx+sizeof s_broadcast],-1
						push	esi
						push	edi
						mov	eax,[edx].s_used
						add	[edx].s_used,ecx
						mov	esi,edi
						lea	edi,[edx+eax].s_bc
						rep	movsb
						pop	edi
						pop	esi
						invoke	LeaveCriticalSection,addr s_critical
						pop	ebx
						ret
					.endif
					mov	[edx].s_pending,-2
					push	ecx
					.break
				.endif
				lea	ebx,[ebx+sizeof s_broadcast]
				inc	ecx
			.endw
			mov	[edx].s_pending,-2
			pop	ecx
		.endif
		.if ([edx].s_pending==0)
			lea	ebx,[edx].s_data
			mov	[ebx].sb_size,ecx
			mov	[ebx].sb_exclude,esi
			xor	eax,eax
			mov	eax,[esi].hSocket
			mov	[ebx].sb_hSocket,eax
			mov	eax,tcount
			mov	[ebx].sb_tcount,eax
			mov	[ebx].sb_type,0
			mov	dword ptr[ebx+sizeof s_broadcast],-1
			push	esi
			push	edi
			mov	[edx].s_opcode,2
			mov	[edx].s_used,ecx
			mov	esi,edi
			lea	edi,[edx].s_bc
			rep	movsb
			mov	[edx].s_pending,-1		;send not started
			pop	edi
			pop	esi
			invoke	LeaveCriticalSection,addr s_critical
			pop	ebx
			ret
		.endif
		mov	edx,[edx].s_next
	.endw
	lea	ebx,[edx].s_data
	mov	[ebx].sb_size,ecx
	mov	[ebx].sb_exclude,esi
	xor	eax,eax
	mov	eax,[esi].hSocket
	mov	[ebx].sb_hSocket,eax
	mov	[ebx].sb_type,0
	mov	eax,tcount
	mov	[ebx].sb_tcount,eax
	mov	dword ptr[ebx+sizeof s_broadcast],-1
	push	esi
	push	edi
	mov	[edx].s_next,0
	mov	[edx].s_opcode,2
	mov	[edx].s_used,ecx
	mov	[edx].s_sendto,esi
	mov	esi,edi
	lea	edi,[edx].s_bc
	rep	movsb
	pop	edi
	pop	esi
	mov	eax,[esi].hSocket
	mov	[edx].s_socket,eax

	push	edx
	invoke	GlobalAlloc,GPTR,sizeof s_record
	pop	edx
	.if eax
		assume	eax:ptr s_record
		mov	[eax].s_prev,edx
		mov	[eax].s_next,0
		mov	[edx].s_next,eax
		mov	[eax].s_opcode,0
		mov	[eax].s_used,0
		mov	[eax].s_pending,0
		mov	ecx,[edx].s_index
		inc	ecx
		mov	[eax].s_index,ecx
		mov	s_lastbuf,eax
		mov	[edx].s_pending,-1		;send not started
		assume	eax:nothing
	.else
		mov	[edx].s_opcode,0
		mov	[edx].s_pending,0
		mov	[edx].s_sendto,0
		call	no_mem
	.endif
	invoke	LeaveCriticalSection,addr s_critical
	pop	ebx
	assume	ebx:nothing
	ret

s_nlist:
	.if ([esi].pm_is_spam>1)||([esi].waiting&2)
		ret
	.endif
s_newuser:
	push	edi
	.if (s_getnicklist.cmdflag&2)&&([esi].myinfwait&4096)
		.if ([esi+3].rights&_3_op)&&([esi].modifier&2)&&(!([esi+3].rights&_3_op0))
			mov	eax,'LpO$'
			stosd
			mov	eax,' tsi'
			stosd
			lea	ebx,[esi]._name
			.while byte ptr[ebx]!=0
				mov	al,[ebx]
				stosb
				inc	ebx
			.endw
			mov	ax,'$$'
			stosw
			mov	al,'|'
			stosb
		.else
			jmp	_snu
		.endif
		push	edx
		mov	edx,esi
		call	getinfo
		add	edi,ecx
		pop	edx
	.else
_snu:		push	edx
		mov	edx,esi
		call	getinfo
		add	edi,ecx
		pop	edx
		.if ([esi+3].rights&_3_op)&&([esi].modifier&2)&&(!([esi+3].rights&_3_op0))
			mov	eax,'LpO$'
			stosd
			mov	eax,' tsi'
			stosd
			lea	ebx,[esi]._name
			.while byte ptr[ebx]!=0
				mov	al,[ebx]
				stosb
				inc	ebx
			.endw
			mov	ax,'$$'
			stosw
			mov	al,'|'
			stosb
		.endif
	.endif
	mov	ecx,edi
	pop	edi
	sub	ecx,edi
	call	s_add_user
	push	edi
	call	myinf1_
	mov	ecx,edi
	pop	edi
	sub	ecx,edi
	.if ecx
		call	s_add_bc
	.endif

	push	edi
	mov	eax,'leH$'
	stosd
	mov	ax,'ol'
	stosw
	mov	al,32
	stosb
	lea	ebx,[esi].req_name
	.while byte ptr[ebx]!=0
		mov	al,[ebx]
		stosb
		inc	ebx
	.endw
	mov	al,'|'
	stosb
	mov	edx,esi
	call	getinfo
	add	ecx,edi
	pop	edi
	sub	ecx,edi
	call	s_add_user1
	.if ([esi+3].rights&_3_op)&&([esi].modifier&2)
		push	esi
		mov	ebx,esi
		mov	edx,offset threads+8
		.while dword ptr[edx]!=0
			mov	esi,dword ptr [edx]
			.if (esi!=-1)&&(esi!=ebx)
				push	edx
				assume	ebx:ptr usrstruc
				.if ([esi].loggedin==1)&&([esi].hSocket!=0)&&(!([ebx+3].rights&_3_op0))||([esi+3].rights&_3_op1)
					.if (!([esi].myinfwait&4096))
						push	ebx
						push	edi
						call	getoplist1
						mov	ecx,edi
						pop	edi
						sub	ecx,edi
						call	s_add_private
						pop	ebx
					.elseif [ebx+3].rights&_3_op0
						push	ebx
						push	edi
						mov	eax,'LpO$'
						stosd
						mov	eax,' tsi'
						stosd
						assume	ebx:ptr usrstruc
						lea	edx,[ebx]._name
						call	copyedx
						assume	ebx:nothing
						mov	ax,'$$'
						stosw
						mov	al,'|'
						stosb
						mov	ecx,edi
						pop	edi
						sub	ecx,edi
						call	s_add_private
						pop	ebx
					.endif
				.endif
				assume	ebx:nothing
				pop	edx
			.endif
			lea	edx,[edx+4]
		.endw
		pop	esi
	.endif
	mov	ecx,[esi].access
	.if (!(appearflag&16384))
		push	esi
		mov	ebx,esi
		mov	edx,offset threads+8
		.while dword ptr[edx]!=0
			mov	esi,dword ptr [edx]
			.if (esi!=-1)&&(esi!=ebx)
				push	edx
				assume	ebx:ptr usrstruc
				.if ([esi].loggedin==1)&&([esi].hSocket!=0)&&([esi+5].rights&_5_rsvd2)&&([esi].myinfwait1&2)&&(ecx<[esi].access)
					push	ecx
					push	ebx
					push	edi
					mov	eax,'esU$'
					stosd
					mov	eax,' PIr'
					stosd
					assume	ebx:ptr usrstruc
					lea	edx,[ebx]._name
					call	copyedx
					mov	al,32
					stosb
					mov	eax,[ebx]._ip
					call	w_ip
					assume	ebx:nothing
					mov	al,'|'
					stosb
					mov	ecx,edi
					pop	edi
					sub	ecx,edi
					call	s_add_private
					pop	ebx
					pop	ecx
				.endif
				assume	ebx:nothing
				pop	edx
			.endif
			lea	edx,[edx+4]
		.endw
		pop	esi
	.endif
	ret

s_newop:
	push	edi
	.if ([esi+3].rights&_3_op)&&([esi].modifier&2)&&(!([esi+3].rights&_3_op0))
		mov	eax,'LpO$'
		stosd
		mov	eax,' tsi'
		stosd
		lea	ebx,[esi]._name
		.while byte ptr[ebx]!=0
			mov	al,[ebx]
			stosb
			inc	ebx
		.endw
		mov	ax,'$$'
		stosw
		mov	al,'|'
		stosb
	.else
		pop	edi
		ret
	.endif
	mov	ecx,edi
	pop	edi
	sub	ecx,edi
	call	s_add_user

	.if ([esi+3].rights&_3_op)&&([esi].modifier&2)
		push	esi
		mov	ebx,esi
		mov	edx,offset threads+8
		.while dword ptr[edx]!=0
			mov	esi,dword ptr [edx]
			.if (esi!=-1)&&(esi!=ebx)
				push	edx
				assume	ebx:ptr usrstruc
				.if ([esi].loggedin==1)&&([esi].hSocket!=0)&&(!([ebx+3].rights&_3_op0))||([esi+3].rights&_3_op1)
					.if (!([esi].myinfwait&4096))
						push	ebx
						push	edi
						call	getoplist1
						mov	ecx,edi
						pop	edi
						sub	ecx,edi
						call	s_add_private
						pop	ebx
					.elseif [ebx+3].rights&_3_op0
						push	ebx
						push	edi
						mov	eax,'LpO$'
						stosd
						mov	eax,' tsi'
						stosd
						assume	ebx:ptr usrstruc
						lea	edx,[ebx]._name
						call	copyedx
						assume	ebx:nothing
						mov	ax,'$$'
						stosw
						mov	al,'|'
						stosb
						mov	ecx,edi
						pop	edi
						sub	ecx,edi
						call	s_add_private
						pop	ebx
					.endif
				.endif
				assume	ebx:nothing
				pop	edx
			.endif
			lea	edx,[edx+4]
		.endw
		pop	esi
	.endif
	ret

no_bufs:.if (send_buff>100h)&&(send_buff!=0)&&(IOCPf&64)
		.if (send_buff>400h)
			sub	send_buff,64
		.else
			sub	send_buff,16
		.endif
		invoke	SetDlgItemInt,hDlg7,109,send_buff,0
		mov	eax,tcount
		sub	eax,last_n
		.if eax>7fffffffh
			neg	eax
		.endif
		.if eax>60
			mov	eax,tcount
			mov	last_n,eax
			mov	eax,100
			.if s_to.cmdflag&32
				mov	ax,word ptr s_to.cmdparam2+2
			.endif
			.if op_messages<ax
				movzx	ecx,op_messages
				shl	ecx,6
				lea	edi,[ecx+offset op_str]
				scasd
				mov	eax,3
				stosd
				mov	eax,tcount
				stosd
				inc	op_messages
			.endif
		.endif
	.endif
	.if s_started==1
		.if sndtimer<10
			invoke	Sleep,100
		.else
			invoke	Sleep,sndtimer
		.endif
	.endif
	mov	s_lasterr,-1
	ret

no_mem:
	invoke	EnterCriticalSection,addr s_critical
	xor	ebx,ebx
	mov	ecx,offset s_buffers
	mov	edx,[ecx]
	.while edx!=0
		.if [edx].s_opcode==0
			mov	eax,dword ptr[edx]
			mov	[ecx],eax
			push	ecx
			push	ebx
			invoke	GlobalFree,edx
			pop	ebx
			pop	ecx
			mov	edx,[ecx]
			inc	ebx
		.else
			mov	ecx,edx
			mov	edx,[edx].s_next
		.endif
	.endw
	mov	ecx,offset s_private
	mov	edx,[ecx]
	.while edx!=0
		.if [edx].s_opcode==0
			mov	eax,dword ptr[edx]
			mov	[ecx],eax
			push	ecx
			push	ebx
			invoke	GlobalFree,edx
			pop	ebx
			pop	ecx
			mov	edx,[ecx]
			inc	ebx
		.else
			mov	ecx,edx
			mov	edx,[edx].s_next
		.endif
	.endw
	push	ebx
	invoke	LeaveCriticalSection,addr s_critical
	pop	ebx
	.if ebx
		push	edi
		mov	eax,100
		.if s_to.cmdflag&32
			mov	ax,word ptr s_to.cmdparam2+2
		.endif
		.if op_messages<ax
			movzx	ecx,op_messages
			shl	ecx,6
			lea	edi,[ecx+offset op_str]
			mov	eax,ebx
			stosd
			mov	eax,7
			stosd
			mov	eax,tcount
			stosd
			inc	op_messages
		.endif
		pop	edi
		ret
	.endif
	mov	eax,users
	.if eax<max_users
		.if eax>100
			push	eax
			xor	edx,edx
			mov	ecx,100
			div	ecx
			pop	eax
			.if eax>edx
				sub	eax,edx
			.endif
		.endif
		push	edi
		mov	max_users,eax
		invoke	SetDlgItemInt,hDlg2,100,max_users,0
		mov	eax,100
		.if s_to.cmdflag&32
			mov	ax,word ptr s_to.cmdparam2+2
		.endif
		.if op_messages<ax
			movzx	ecx,op_messages
			shl	ecx,6
			lea	edi,[ecx+offset op_str]
			scasd
			mov	eax,6
			stosd
			mov	eax,tcount
			stosd
			inc	op_messages
		.endif
		pop	edi
	.endif
	ret

getlblock:
	push	ebx
	mov	[esi].loggedin,1
	mov	eax,[esi].ipptr
	assume	eax:ptr ip_info
	and	[eax].waiting,64 xor -1
	assume	eax:nothing
	mov	eax,tcount
	mov	[esi].s__logintime,eax
	.if ([esi].waiting&16)
		.if logins!=0
			dec	logins
		.endif
		and	[esi].waiting,16 xor -1
	.endif
	.if ([esi].accflag&2)&&([esi].userid!=0)
		mov	eax,[esi].profptr
		mov	byte ptr[eax+290],1
		mov	ebx,[eax+278]
		mov	[eax+538],ebx
		mov	ebx,[eax+278+4]
		mov	[eax+538+4],ebx
	.endif
	pop	ebx
	ret

_s_rem:	.if edx==s_lastpriv
		ret
	.endif
	push	eax
	mov	[edx].s_opcode,0
	mov	[edx].s_pending,0
	assume	ecx:ptr s_record
	mov	eax,[edx].s_next
	mov	ecx,[edx].s_prev
	.if ecx
		mov	[ecx].s_next,eax
	.else
		mov	s_private,eax
	.endif
	assume	eax:ptr s_record
	mov	[eax].s_prev,ecx
	assume	eax:nothing
	mov	ecx,s_lastpriv
	mov	[ecx].s_next,edx
	mov	[edx].s_prev,ecx
	mov	[edx].s_next,0
	mov	s_lastpriv,edx
	mov	edx,eax
	pop	eax
	assume	ecx:nothing
	ret

s__pm:
	push	esi
	mov	esi,[edx].s_sendto
	mov	eax,s_lastsid
	xchg	[esi].s__lastsid,eax
	.if eax==s_lastsid
		pop	esi
		ret
	.endif
	.if (IOCPf&128)&&(IOCPf&4)
		.if ([esi].waiting&32)
			pop	esi
			ret
		.endif
	.endif
	.if ([esi].s__idx!=0)||(([esi].s__bufpm!=edx)&&([esi].s__idxpm!=0))
		pop	esi
		ret
	.elseif [edx].s_used==0
		mov	eax,[esi].hSocket
		.if (eax==[edx].s_socket)&&(eax!=0)
			call	closeconn
		.endif
		pop	esi
		ret
	.endif
	.if ([esi].s__privcnt)&&([esi].s__idxpm==0)
		dec	[esi].s__privcnt
	.endif
	.if (IOCPf&128)&&(IOCPf&4)
		mov	[esi].s__lastsid,esi
		jmp	_pm_IOCP
	.endif
	mov	eax,[esi].hSocket
	.if (eax!=[edx].s_socket)||([esi].hSocket==0)
_srem:		push	edx
		invoke	EnterCriticalSection,addr s_critical
		pop	edx
		mov	[edx].s_opcode,-1
		mov	edx,[edx].s_next
		.while (edx!=s_lastpriv)&&([edx].s_opcode!=0)
			.break .if (([edx].s_sendto==esi)&&([edx].s_opcode==4)&&(eax==[edx].s_socket))
			mov	edx,[edx].s_next
		.endw
		mov	[esi].s__bufpm,edx
		mov	[esi].s__idxpm,0
		mov	[esi].s__retry,0
		push	edx
		invoke	LeaveCriticalSection,addr s_critical
		pop	edx
	.else
		mov	[esi].s__bufpm,edx
		.if hIOCP!=0
			mov	s_timewait,0
			mov	s_timewait[4],0
			mov	s_select,1
			mov	dword ptr s_select+4,eax
			push	edx
			invoke	select,1,0,addr s_select,0,addr s_timewait
			pop	edx
			.if eax!=1
				push	edx
				.if eax==SOCKET_ERROR
					invoke WSAGetLastError
					.if (eax==WSAENOBUFS)
						call	no_bufs
					.elseif (eax==WSAEWOULDBLOCK)
					.elseif (eax==WSAEINPROGRESS)
					.elseif (eax==ERROR_IO_PENDING)
					.elseif eax==WSAEINVAL
						int 3
					.else
						onError	[esi].sessionId,64
						call	closeconn
						pop	edx
						jmp	_srem
					.endif
				.else
					inc	[esi].s__retry
					mov	eax,[esi].s__retry
					.if (SendRetries!=0)&&(eax>SendRetries)
						pop	edx
						push	edx
						mov	[edx].s_opcode,-1
						onError	[esi].sessionId,8
						call	closeconn
					.endif
				.endif
				pop	edx
				pop	esi
				ret
			.endif
		.endif
		push	edx
		invoke	EnterCriticalSection,addr s_critical
		pop	edx
		push	edx
		lea	eax,[edx].s_data
		add	eax,[esi].s__idxpm
		mov	ecx,[edx].s_used
		sub	ecx,[esi].s__idxpm
		mov	[edx].s_pending,1
		push	eax
		push	ecx
		invoke	LeaveCriticalSection,addr s_critical
		pop	ecx
		pop	eax
		.if (ecx>send_buff)&&(send_buff!=0)
			mov	ecx,send_buff
		.endif
		mov	dl,1
		.if ([esi].outDisable&1)
			.if [esi].lpDis
				push	eax
				push	esi
				push	edi
				push	ebx
				push	ecx
				push	ecx
				push	eax
				call	[esi].lpDis
				pop	ecx
				pop	ebx
				pop	edi
				pop	esi
				.if eax!=0
					mov	dl,1
				.else
					mov	dl,0
				.endif
				pop	eax
			.else
				mov	dl,0
			.endif
		.endif
		.if dl==0
			mov	eax,ecx
		.else
			add	bps_s,ecx
			invoke	send,[esi].hSocket,eax,ecx,0
		.endif
		.if eax==SOCKET_ERROR
			invoke WSAGetLastError
			.if (eax==WSAENOBUFS)
				call	no_bufs
			.elseif (eax==WSAEWOULDBLOCK)||(eax==WSAEINPROGRESS)||(eax==ERROR_IO_PENDING)
			.elseif eax==WSAEINVAL
				int 3
			.else
				onError	[esi].sessionId,64
				call	closeconn
				pop	edx
				jmp	_srem
			.endif
			pop	edx
			inc	[esi].s__retry
			mov	eax,[esi].s__retry
			.if (SendRetries!=0)&&(eax>SendRetries)
				mov	[edx].s_opcode,-1
				push	edx
				onError	[esi].sessionId,8
				call	closeconn
				pop	edx
			.endif
			pop	esi
			ret
		.endif
		push	eax
		invoke	EnterCriticalSection,addr s_critical
		pop	eax
		pop	edx
		mov	ecx,eax
		add	ecx,[esi].s__idxpm
		.if ecx>=[edx].s_used
			mov	[edx].s_opcode,-1
			.if [edx].s_next
				mov	edx,[edx].s_next
				.while (edx!=s_lastpriv)&&([edx].s_opcode!=0)
					.break .if (([edx].s_sendto==esi)&&([edx].s_opcode==4)&&(eax==[edx].s_socket))
					mov	edx,[edx].s_next
				.endw
			.else
				mov	[edx].s_opcode,0
			.endif
			mov	[esi].s__bufpm,edx
			mov	[esi].s__idxpm,0
			mov	[esi].s__retry,0
			mov	s_lasterr,1
		.elseif ecx>[edx].s_used
			int 3
		.else
			add	[esi].s__idxpm,eax
			.if eax==0
				push	edx
				.if s_lasterr!=-1
					mov	s_lasterr,0
				.endif
				invoke	LeaveCriticalSection,addr s_critical
				inc	[esi].s__retry
				mov	eax,[esi].s__retry
				.if (SendRetries!=0)&&(eax>SendRetries)
					pop	edx
					push	edx
					mov	[edx].s_opcode,-1
					onError	[esi].sessionId,8
					call	closeconn
				.endif
				pop	edx
				pop	esi
				ret
			.else
				mov	s_lasterr,1
				mov	[esi].s__retry,0
			.endif
		.endif
		push	edx
		invoke	LeaveCriticalSection,addr s_critical
		pop	edx
	.endif
	pop	esi
	ret

s__search:
	.if [edx].s_sendto==esi
		movzx	eax,word ptr s_search.cmdparam1
		.if (s_search.cmdflag&1)&&(!([esi+5].rights&_5_spam2))
			mov	[edx].s_tcount,eax
		.endif
	.endif
	dec	[edx].s_tcount
	mov	ecx,[edx].s_used
	sub	ecx,[esi].s__idx
	lea	eax,[edx].s_data


_s_noIOCP:
	.if (IOCPf&128)&&(IOCPf&4)
		.if (!([esi].waiting&32))
			jmp	s___trans
		.endif
		ret
	.endif
	push	eax
	push	ecx
	mov	eax,[esi].hSocket
	.if eax==0
		pop	ecx
		pop	eax
		ret
	.endif
	.if hIOCP!=0
		mov	s_timewait,0
		mov	s_timewait[4],0
		mov	s_select,1
		mov	dword ptr s_select+4,eax
		push	edx
		push	eax
		invoke	select,1,0,addr s_select,0,addr s_timewait
		pop	ecx
		pop	edx
		.if eax!=1
			push	edx
			.if eax==SOCKET_ERROR
				invoke WSAGetLastError
				.if (eax==WSAENOBUFS)
					call	no_bufs
				.elseif (eax==WSAEWOULDBLOCK)||(eax==WSAEINPROGRESS)||(eax==ERROR_IO_PENDING)
				.elseif eax==WSAEINVAL
					int 3
				.else
					onError	[esi].sessionId,64
					call	closeconn
				.endif
			.else
				inc	[esi].s__retry
				mov	eax,[esi].s__retry
				.if (SendRetries!=0)&&(eax>SendRetries)
					onError	[esi].sessionId,8
					call	closeconn
				.endif
			.endif
			pop	edx
			pop	ecx
			pop	eax
			ret
		.endif
	.endif
	pop	ecx
	pop	eax
	push	edx
	add	eax,[esi].s__idx
	.if (ecx>send_buff)&&(send_buff!=0)
		mov	ecx,send_buff
	.endif
	mov	dl,1
	.if ([esi].outDisable&1)
		.if [esi].lpDis
			push	eax
			push	esi
			push	edi
			push	ebx
			push	ecx
			push	ecx
			push	eax
			call	[esi].lpDis
			pop	ecx
			pop	ebx
			pop	edi
			pop	esi
			.if eax!=0
				mov	dl,1
			.else
				mov	dl,0
			.endif
			pop	eax
		.else
			mov	dl,0
		.endif
	.endif
	.if dl==0
		mov	eax,ecx
	.else
		add	bps_s,ecx
		invoke	send,[esi].hSocket,eax,ecx,0
	.endif
	.if eax==SOCKET_ERROR
		invoke WSAGetLastError
		.if (eax==WSAENOBUFS)
			call	no_bufs
		.elseif (eax==WSAEWOULDBLOCK)||(eax==WSAEINPROGRESS)||(eax==ERROR_IO_PENDING)
		.elseif eax==WSAEINVAL
			int 3
		.else
			onError	[esi].sessionId,64
			call	closeconn
		.endif
		pop	edx
		inc	[esi].s__retry
		mov	eax,[esi].s__retry
		.if (SendRetries!=0)&&(eax>SendRetries)
			push	edx
			onError	[esi].sessionId,8
			call	closeconn
			pop	edx
		.endif
		ret
	.endif
	push	eax
	invoke	EnterCriticalSection,addr s_critical
	pop	eax
	pop	edx
	mov	ecx,eax
	add	ecx,[esi].s__idx
	.if ecx>=[edx].s_used
		mov	edx,[edx].s_next
		mov	[esi].s__bufno,edx
		mov	[esi].s__idx,0
		mov	[esi].s__retry,0
		mov	s_lasterr,1
	.elseif ecx>[edx].s_used
		int 3
	.else
		add	[esi].s__idx,eax
		.if eax==0
			push	edx
			.if s_lasterr!=-1
				mov	s_lasterr,0
			.endif
			invoke	LeaveCriticalSection,addr s_critical
			inc	[esi].s__retry
			mov	eax,[esi].s__retry
			.if (SendRetries!=0)&&(eax>SendRetries)
				onError	[esi].sessionId,8
				call	closeconn
			.endif
			pop	edx
			ret
		.else
			mov	s_lasterr,1
			mov	[esi].s__retry,0
		.endif
	.endif
	push	edx
	invoke	LeaveCriticalSection,addr s_critical
	pop	edx
	ret


s__lang:
	mov	eax,[esi].lptr
	mov	ecx,[esi].s__logintime
	.if ([edx].s_sendto==esi)||(eax!=dword ptr [edx].s_data)||(ecx>[edx].s_tcount)
		mov	edx,[edx].s_next
		mov	[esi].s__bufno,edx
		mov	[esi].s__idx,0
		mov	[esi].s__retry,0
		ret
	.endif
	mov	ecx,[edx].s_used
	sub	ecx,[esi].s__idx
	lea	eax,[edx+4].s_data
	jmp	_s_noIOCP

s__nickchg:
	mov	eax,[esi].lptr
	mov	ecx,[esi].s__logintime
	.if ([edx].s_sendto==esi)||(!([esi].myinfwait1&4))||(ecx>[edx].s_tcount)
		mov	edx,[edx].s_next
		mov	[esi].s__bufno,edx
		mov	[esi].s__idx,0
		mov	[esi].s__retry,0
		ret
	.endif
	mov	ecx,[edx].s_used
	sub	ecx,[esi].s__idx
	lea	eax,[edx].s_data
	jmp	_s_noIOCP

s__bcast:
	push	[edx].s_used
	push	edx
	lea	ebx,[edx].s_data
	xor	eax,eax
	assume	ebx:ptr s_broadcast
	.while dword ptr[ebx]!=-1
		.break .if eax==[esi].s__idx
		mov	ecx,[ebx].sb_size
		add	ecx,eax
		.break .if ecx>[esi].s__idx
		mov	eax,ecx
		add	ebx,sizeof s_broadcast
	.endw
	.if eax==[esi].s__idx
		mov	ecx,[esi].hSocket
		.while dword ptr[ebx]!=-1
			push	eax
			.if (!([esi].rights&_0_chat2))
				push	ecx
				lea	ecx,[edx].s_bc
				add	eax,ecx
				pop	ecx
				.if (byte ptr[eax]=='<')
					mov	eax,[esi].access
					.if ax<[ebx].sb_accs
						jmp	_fltr
					.endif
				.endif
			.endif
			mov	eax,[esi].s__logintime
			.if (eax<=[ebx].sb_tcount)&&((esi!=[ebx].sb_exclude)||(ecx!=[ebx].sb_hSocket))
				pop	eax
				.break
			.endif
_fltr:			pop	eax
			add	eax,[ebx].sb_size
			add	ebx,sizeof s_broadcast
		.endw
		.if eax==[edx].s_used
			pop	edx
;			.if [edx].s_pending==-1
				push	edx
				invoke	EnterCriticalSection,addr s_critical
				pop	edx
				pop	eax
				.if eax!=[edx].s_used
					push	edx
					invoke	LeaveCriticalSection,addr s_critical
					pop	edx
					jmp	s__bcast
				.endif
				push	eax
				mov	[edx].s_pending,-2
				push	edx
				invoke	LeaveCriticalSection,addr s_critical
				pop	edx
;			.endif
			pop	eax
			mov	edx,[edx].s_next
			mov	[esi].s__bufno,edx
			mov	[esi].s__idx,0
			mov	[esi].s__retry,0
			ret
		.endif
		xor	ecx,ecx
	.else
		sub	ecx,[esi].s__idx
		mov	eax,[esi].s__idx
		add	ebx,sizeof s_broadcast
	.endif
	mov	[esi].s__idx,eax
	mov	eax,[esi].hSocket
	.while dword ptr[ebx]!=-1
		.if (esi==[ebx].sb_exclude)&&(eax==[ebx].sb_hSocket)
_fltr1:			.if ecx==0
				mov	ecx,[ebx].sb_size
				add	[esi].s__idx,ecx
				xor	ecx,ecx
				add	ebx,sizeof s_broadcast
				.break .if dword ptr[ebx]==-1
			.else
				.break
			.endif
		.else
			.if (!([esi].rights&_0_chat2))
				push	eax
				push	ecx
				mov	eax,ecx
				lea	ecx,[edx].s_bc
				add	eax,ecx
				pop	ecx
				.if (byte ptr[eax]=='<')
					mov	eax,[esi].access
					.if ax<[ebx].sb_accs
						pop	eax
						jmp	_fltr1
					.endif
				.endif
				pop	eax
			.endif
			push	ecx
			mov	ecx,[esi].s__logintime
			.if ecx>[ebx].sb_tcount
				pop	ecx
				.if ecx==0
					mov	ecx,[ebx].sb_size
					add	[esi].s__idx,ecx
					xor	ecx,ecx
					add	ebx,sizeof s_broadcast
					.break .if dword ptr[ebx]==-1
				.else
					.break
				.endif
				push	ecx
			.endif
			pop	ecx
		.endif
		add	ecx,[ebx].sb_size
		add	ebx,sizeof s_broadcast
	.endw
	.if ecx==0
		pop	edx
	;	.if [edx].s_pending==-1
			push	edx
			invoke	EnterCriticalSection,addr s_critical
			pop	edx
			pop	eax
			.if eax!=[edx].s_used
				push	edx
				invoke	LeaveCriticalSection,addr s_critical
				pop	edx
				jmp	s__bcast
			.endif
			push	eax
			mov	[edx].s_pending,-2
			push	edx
			invoke	LeaveCriticalSection,addr s_critical
			pop	edx
	;	.endif
		pop	eax
		mov	edx,[edx].s_next
		mov	[esi].s__bufno,edx
		mov	[esi].s__idx,0
		mov	[esi].s__retry,0
		.if [edx].s_opcode==1
			jmp	s__bcast
		.endif
		ret
	.endif
	pop	edx
	pop	eax

_s_bc_noIOCP:
	.if [esi].hSocket==0
		ret
	.endif
	lea	eax,[edx].s_bc
	.if (IOCPf&128)&&(IOCPf&4)
		.if (!([esi].waiting&32))
			jmp	s___trans
		.endif
		ret
	.endif
	add	eax,[esi].s__idx
	.if (ecx>send_buff)&&(send_buff!=0)
		mov	ecx,send_buff
	.endif
	.if hIOCP!=0
		push	eax
		push	ecx
		mov	s_timewait,0
		mov	s_timewait[4],0
		mov	s_select,1
		mov	eax,[esi].hSocket
		mov	dword ptr s_select+4,eax
		push	edx
		invoke	select,1,0,addr s_select,0,addr s_timewait
		pop	edx
		pop	ecx
		.if eax!=1
			.if eax==SOCKET_ERROR
				pop	eax
				invoke WSAGetLastError
				.if (eax==WSAENOBUFS)
					call	no_bufs
				.elseif (eax==WSAEWOULDBLOCK)||(eax==WSAEINPROGRESS)||(eax==ERROR_IO_PENDING)
				.elseif eax==WSAEINVAL
					int 3
				.else
					onError	[esi].sessionId,64
					call	closeconn
				.endif
				push	eax
			.else
				inc	[esi].s__retry
				mov	eax,[esi].s__retry
				.if (SendRetries!=0)&&(eax>SendRetries)
					onError	[esi].sessionId,8
					call	closeconn
				.endif
			.endif
			pop	eax
			ret
		.endif
		pop	eax
	.endif
	mov	dl,1
	.if ([esi].outDisable&1)
		.if [esi].lpDis
			push	eax
			push	esi
			push	edi
			push	ebx
			push	ecx
			push	ecx
			push	eax
			call	[esi].lpDis
			pop	ecx
			pop	ebx
			pop	edi
			pop	esi
			.if eax!=0
				mov	dl,1
			.else
				mov	dl,0
			.endif
			pop	eax
		.else
			mov	dl,0
		.endif
	.endif
	.if dl==0
		mov	eax,ecx
	.else
		add	bps_s,ecx
		invoke	send,[esi].hSocket,eax,ecx,0
	.endif
	.if eax==SOCKET_ERROR
		invoke WSAGetLastError
		.if (eax==WSAENOBUFS)
			call	no_bufs
		.elseif (eax==WSAEWOULDBLOCK)||(eax==WSAEINPROGRESS)||(eax==ERROR_IO_PENDING)
		.elseif eax==WSAEINVAL
			int 3
		.else
			onError	[esi].sessionId,64
			call	closeconn
		.endif
		inc	[esi].s__retry
		mov	eax,[esi].s__retry
		.if (SendRetries!=0)&&(eax>SendRetries)
			onError	[esi].sessionId,8
			call	closeconn
		.endif
		ret
	.endif
	mov	edx,[esi].s__bufno
	mov	ecx,eax
	add	ecx,[esi].s__idx
	push	[edx].s_used
	.if ecx>=[edx].s_used
	;	.if [edx].s_pending==-1
			push	edx
			invoke	EnterCriticalSection,addr s_critical
			pop	edx
			pop	eax
			.if eax!=[edx].s_used
				mov	eax,[edx].s_used
				mov	[esi].s__idx,eax
				invoke	LeaveCriticalSection,addr s_critical
				ret
			.endif
			push	eax
			mov	[edx].s_pending,-2
			push	edx
			invoke	LeaveCriticalSection,addr s_critical
			pop	edx
	;	.endif
		mov	edx,[edx].s_next
		mov	[esi].s__bufno,edx
		mov	[esi].s__idx,0
		mov	[esi].s__retry,0
	.elseif ecx>[edx].s_used
		int 3
	.else
		add	[esi].s__idx,eax
		.if eax==0
			.if s_lasterr!=-1
				mov	s_lasterr,0
			.endif
			inc	[esi].s__retry
			mov	eax,[esi].s__retry
			.if (SendRetries!=0)&&(eax>SendRetries)
				push	edx
				onError	[esi].sessionId,8
				call	closeconn
				pop	edx
			.endif
			pop	eax
			ret
		.else
			mov	[esi].s__retry,0
		.endif
	.endif
	pop	eax
	ret

s__bcast1:
	push	[edx].s_used
	push	edx
	lea	ebx,[edx].s_data
	xor	eax,eax
	assume	ebx:ptr s_broadcast
	.while dword ptr[ebx]!=-1
		.break .if eax==[esi].s__idx
		mov	ecx,[ebx].sb_size
		add	ecx,eax
		.break .if ecx>[esi].s__idx
		mov	eax,ecx
		add	ebx,sizeof s_broadcast
	.endw
	.if eax==[esi].s__idx
		mov	ecx,[esi].hSocket
		.while dword ptr[ebx]!=-1
			push	eax
			mov	eax,[esi].s__logintime
			.if (eax<=[ebx].sb_tcount)&&((esi!=[ebx].sb_exclude)||(ecx!=[ebx].sb_hSocket))&&([ebx].sb_type!=1)
				pop	eax
				.break
			.endif
			pop	eax
			add	eax,[ebx].sb_size
			add	ebx,sizeof s_broadcast
		.endw
		.if eax==[edx].s_used
			pop	edx
;			.if [edx].s_pending==-1
				push	edx
				invoke	EnterCriticalSection,addr s_critical
				pop	edx
				pop	eax
				.if eax!=[edx].s_used
					push	edx
					invoke	LeaveCriticalSection,addr s_critical
					pop	edx
					jmp	s__bcast1
				.endif
				push	eax
				mov	[edx].s_pending,-2
				push	edx
				invoke	LeaveCriticalSection,addr s_critical
				pop	edx
;			.endif
			pop	eax
			mov	edx,[edx].s_next
			mov	[esi].s__bufno,edx
			mov	[esi].s__idx,0
			mov	[esi].s__retry,0
			ret
		.endif
		xor	ecx,ecx
	.else
		sub	ecx,[esi].s__idx
		mov	eax,[esi].s__idx
		add	ebx,sizeof s_broadcast
	.endif
	mov	[esi].s__idx,eax
	mov	eax,[esi].hSocket
	.while dword ptr[ebx]!=-1
		.if ((esi==[ebx].sb_exclude)&&(eax==[ebx].sb_hSocket))||([ebx].sb_type==1)
			.if ecx==0
				mov	ecx,[ebx].sb_size
				add	[esi].s__idx,ecx
				xor	ecx,ecx
				add	ebx,sizeof s_broadcast
				.break .if dword ptr[ebx]==-1
			.else
				.break
			.endif
		.else
			push	ecx
			mov	ecx,[esi].s__logintime
			.if ecx>[ebx].sb_tcount
				pop	ecx
				.if ecx==0
					mov	ecx,[ebx].sb_size
					add	[esi].s__idx,ecx
					xor	ecx,ecx
					add	ebx,sizeof s_broadcast
					.break .if dword ptr[ebx]==-1
				.else
					.break
				.endif
				push	ecx
			.endif
			pop	ecx
		.endif
		add	ecx,[ebx].sb_size
		add	ebx,sizeof s_broadcast
	.endw
	.if ecx==0
		pop	edx
	;	.if [edx].s_pending==-1
			push	edx
			invoke	EnterCriticalSection,addr s_critical
			pop	edx
			pop	eax
			.if eax!=[edx].s_used
				push	edx
				invoke	LeaveCriticalSection,addr s_critical
				pop	edx
				jmp	s__bcast1
			.endif
			push	eax
			mov	[edx].s_pending,-2
			push	edx
			invoke	LeaveCriticalSection,addr s_critical
			pop	edx
	;	.endif
		pop	eax
		mov	edx,[edx].s_next
		mov	[esi].s__bufno,edx
		mov	[esi].s__idx,0
		mov	[esi].s__retry,0
		.if [edx].s_opcode==2
			jmp	s__bcast1
		.endif
		ret
	.endif
	pop	edx
	pop	eax
	assume	ebx:nothing
	jmp	_s_bc_noIOCP


s__pm_IOCP:
	push	esi
	mov	esi,[edx].s_sendto
	.if ([esi].s__idx!=0)||(([esi].s__bufpm!=edx)&&([esi].s__idxpm!=0))
		pop	esi
		xor	eax,eax
		ret
	.endif
_pm_IOCP:
	mov	eax,[esi].hSocket
	.if (eax!=[edx].s_socket)||([esi].hSocket==0)
_srem_:		push	edx
		invoke	EnterCriticalSection,addr s_critical
		pop	edx
		call	_s_rem
		mov	[esi].s__bufpm,edx
		mov	[esi].s__idxpm,0
		mov	[esi].s__retry,0
		push	edx
		invoke	LeaveCriticalSection,addr s_critical
		pop	edx
	.else
		push	edx
		invoke	EnterCriticalSection,addr s_critical
		pop	edx
		push	edx
		mov	[esi].s__bufpm,edx
		mov	[edx].s_pending,1
		invoke	LeaveCriticalSection,addr s_critical
		pop	edx
		push	edx
		lea	eax,[edx].s_data
		add	eax,[esi].s__idxpm
		mov	ecx,[edx].s_used
		sub	ecx,[esi].s__idxpm

		mov	[esi].ovr_send.opcode,OP_SEND
		push	[esi].hSocket
		pop	[esi].ovr_send.hSocket
		mov	[esi].ovr_send.hMem,esi
		mov	[esi].ovr_send.retries,0
		push	edi
		push	eax
		lea	edi,[esi].ovr_send.ovr
		xor	eax,eax
		stosd
		stosd
		stosd
		stosd
		stosd
		pop	eax
		pop	edi
		mov	[esi].ovr_send.buffer2,eax
		mov	[esi].ovr_send.bfidx2,0
		mov	[esi].ovr_send.bfsize2,ecx
		mov	eax,tcount
		mov	[esi].s__lastsendtime,eax
		mov	[esi].last_op,1
		mov	dl,1
		.if ([esi].outDisable&1)
			.if [esi].lpDis
				push	eax
				push	esi
				push	edi
				push	ebx
				push	ecx
				push	[esi].ovr_send.bfsize2
				push	[esi].ovr_send.buffer2
				call	[esi].lpDis
				pop	ecx
				pop	ebx
				pop	edi
				pop	esi
				.if eax!=0
					mov	dl,1
				.else
					mov	dl,0
				.endif
				pop	eax
			.else
				mov	dl,0
			.endif
		.endif
		.if dl==0
			xor	eax,eax
			inc	eax
		.else
			or	[esi].waiting,32
			mov	[esi].ovr_send.written,0
			invoke	WriteFile,[esi].hSocket,[esi].ovr_send.buffer2,[esi].ovr_send.bfsize2,addr [esi].ovr_send.written,addr [esi].ovr_send
		.endif
		.if eax==0
			invoke WSAGetLastError
			.if (eax==WSAENOBUFS)||(eax==ERROR_NO_SYSTEM_RESOURCES)
				call	no_bufs
			.elseif (eax==WSAEWOULDBLOCK)
				and	[esi].waiting,32 xor -1
			.elseif (eax==WSAEINPROGRESS)||(eax==ERROR_IO_PENDING)
				xor	eax,eax
				inc	eax
			.elseif eax==WSAEINVAL
				int 3
			.else
				onError	[esi].sessionId,64
				call	closeconn
				pop	edx
				jmp	_srem_
			.endif
		.endif
		pop	edx
		pop	esi
		ret
	.endif
	pop	esi
	xor	eax,eax
	ret


s__ntrans:
	mov	ecx,[edx].s_used
	sub	ecx,[esi].s__idx
	lea	eax,[edx].s_data
	jmp	s___trans
s__ltrans:
	mov	ecx,[edx].s_used
	sub	ecx,[esi].s__idx
	lea	eax,[edx+4].s_data
	jmp	s___trans
s__bctrans:
	lea	eax,[edx].s_bc
	jmp	s___trans
s__trans:
	mov	ecx,[edx].s_used
	sub	ecx,[esi].s__idx
	lea	eax,[edx].s_data
s___trans:
	.if (!([esi].hSocket))
		ret
	.endif
	add	eax,[esi].s__idx
	mov	[esi].ovr_send.opcode,OP_SEND
	push	[esi].hSocket
	pop	[esi].ovr_send.hSocket
	mov	[esi].ovr_send.hMem,esi
	mov	[esi].ovr_send.retries,0
	push	edi
	push	eax
	lea	edi,[esi].ovr_send.ovr
	xor	eax,eax
	stosd
	stosd
	stosd
	stosd
	stosd
	pop	eax
	pop	edi
	mov	[esi].ovr_send.buffer2,eax
	mov	[esi].ovr_send.bfidx2,0
	mov	[esi].ovr_send.bfsize2,ecx
	mov	eax,tcount
	mov	[esi].s__lastsendtime,eax
	mov	[esi].last_op,2
	mov	dl,1
	.if ([esi].outDisable&1)
		.if [esi].lpDis
			push	eax
			push	esi
			push	edi
			push	ebx
			push	ecx
			push	[esi].ovr_send.bfsize2
			push	[esi].ovr_send.buffer2
			call	[esi].lpDis
			pop	ecx
			pop	ebx
			pop	edi
			pop	esi
			.if eax!=0
				mov	dl,1
			.else
				mov	dl,0
			.endif
			pop	eax
		.else
			mov	dl,0
		.endif
	.endif
	.if dl==0
		xor	eax,eax
		inc	eax
	.else
		or	[esi].waiting,32
		mov	[esi].ovr_send.written,0
		invoke	WriteFile,[esi].hSocket,[esi].ovr_send.buffer2,[esi].ovr_send.bfsize2,addr [esi].ovr_send.written,addr [esi].ovr_send
	.endif
	.if eax==0
		invoke WSAGetLastError
		.if (eax==WSAENOBUFS)||(eax==ERROR_NO_SYSTEM_RESOURCES)
			call	no_bufs
		.elseif (eax==WSAEWOULDBLOCK)
			and	[esi].waiting,32 xor -1
		.elseif (eax==WSAEINPROGRESS)||(eax==ERROR_IO_PENDING)
			xor	eax,eax
			inc	eax
		.elseif eax==WSAEINVAL
			int 3
		.else
			onError	[esi].sessionId,64
			call	closeconn
		.endif
	.endif
	ret


s__nickchange_IOCP:
	mov	eax,[esi].lptr
	mov	ecx,[esi].s__logintime
	.if ([edx].s_sendto==esi)||(!([esi].myinfwait1&4))||(ecx>[edx].s_tcount)
		mov	edx,[edx].s_next
		mov	[esi].s__bufno,edx
		mov	[esi].s__idx,0
		mov	[esi].s__retry,0
		ret
	.endif
	call	s__ntrans
	ret


s__search_IOCP:
	.if [edx].s_sendto==esi
		movzx	eax,word ptr s_search.cmdparam1
		.if (s_search.cmdflag&1)&&(!([esi+5].rights&_5_spam2))
			mov	[edx].s_tcount,eax
		.endif
	.endif
	dec	[edx].s_tcount
	call	s__trans
	ret


s__lang_IOCP:
	mov	eax,[esi].lptr
	mov	ecx,[esi].s__logintime
	.if ([edx].s_sendto==esi)||(eax!=dword ptr [edx].s_data)||(ecx>[edx].s_tcount)
		mov	edx,[edx].s_next
		mov	[esi].s__bufno,edx
		mov	[esi].s__idx,0
		mov	[esi].s__retry,0
		ret
	.endif
	call	s__ltrans
	ret

s__bcast_IOCP:
	push	esi
	push	[edx].s_used
	push	edx
	lea	ebx,[edx].s_data
	xor	eax,eax
	assume	ebx:ptr s_broadcast
	.while dword ptr[ebx]!=-1
		.break .if eax==[esi].s__idx
		mov	ecx,[ebx].sb_size
		add	ecx,eax
		.break .if ecx>[esi].s__idx
		mov	eax,ecx
		add	ebx,sizeof s_broadcast
	.endw
	.if eax==[esi].s__idx
		mov	ecx,[esi].hSocket
		.while dword ptr[ebx]!=-1
			push	eax
			mov	eax,[esi].s__logintime
			.if (eax<=[ebx].sb_tcount)&&((esi!=[ebx].sb_exclude)||(ecx!=[ebx].sb_hSocket))
				pop	eax
				.break
			.endif
			pop	eax
			add	eax,[ebx].sb_size
			add	ebx,sizeof s_broadcast
		.endw
		.if eax==[edx].s_used
			pop	edx
;			.if [edx].s_pending==-1
				push	edx
				invoke	EnterCriticalSection,addr s_critical
				pop	edx
				pop	eax
				.if eax!=[edx].s_used
					push	edx
					invoke	LeaveCriticalSection,addr s_critical
					pop	edx
					pop	esi
					jmp	s__bcast_IOCP
				.endif
				push	eax
				mov	[edx].s_pending,-2
				push	edx
				invoke	LeaveCriticalSection,addr s_critical
				pop	edx
;			.endif
			pop	eax
			pop	esi
			mov	edx,[edx].s_next
			mov	[esi].s__bufno,edx
			mov	[esi].s__idx,0
			mov	[esi].s__retry,0
			ret
		.endif
		xor	ecx,ecx
	.else
		sub	ecx,[esi].s__idx
		mov	eax,[esi].s__idx
		add	ebx,sizeof s_broadcast
	.endif
	mov	[esi].s__idx,eax
	mov	eax,[esi].hSocket
	.while dword ptr[ebx]!=-1
		.if (esi==[ebx].sb_exclude)&&(eax==[ebx].sb_hSocket)
			.if ecx==0
				mov	ecx,[ebx].sb_size
				add	[esi].s__idx,ecx
				xor	ecx,ecx
				add	ebx,sizeof s_broadcast
				.break .if dword ptr[ebx]==-1
			.else
				.break
			.endif
		.else
			push	ecx
			mov	ecx,[esi].s__logintime
			.if ecx>[ebx].sb_tcount
				pop	ecx
				.if ecx==0
					mov	ecx,[ebx].sb_size
					add	[esi].s__idx,ecx
					xor	ecx,ecx
					add	ebx,sizeof s_broadcast
					.break .if dword ptr[ebx]==-1
				.else
					.break
				.endif
				push	ecx
			.endif
			pop	ecx
		.endif
		add	ecx,[ebx].sb_size
		add	ebx,sizeof s_broadcast
	.endw
	.if ecx==0
		pop	edx
	;	.if [edx].s_pending==-1
			push	edx
			invoke	EnterCriticalSection,addr s_critical
			pop	edx
			pop	eax
			.if eax!=[edx].s_used
				push	edx
				invoke	LeaveCriticalSection,addr s_critical
				pop	edx
				pop	esi
				jmp	s__bcast_IOCP
			.endif
			push	eax
			mov	[edx].s_pending,-2
			push	edx
			invoke	LeaveCriticalSection,addr s_critical
			pop	edx
	;	.endif
		pop	eax
		pop	esi
		mov	edx,[edx].s_next
		mov	[esi].s__bufno,edx
		mov	[esi].s__idx,0
		mov	[esi].s__retry,0
		.if [edx].s_opcode==1
			jmp	s__bcast_IOCP
		.endif
		ret
	.endif
	call	s__bctrans

	pop	edx
	pop	eax
	pop	esi
	assume	ebx:nothing
	ret

s__bcast1_IOCP:
	push	esi
	push	[edx].s_used
	push	edx
	lea	ebx,[edx].s_data
	xor	eax,eax
	assume	ebx:ptr s_broadcast
	.while dword ptr[ebx]!=-1
		.break .if eax==[esi].s__idx
		mov	ecx,[ebx].sb_size
		add	ecx,eax
		.break .if ecx>[esi].s__idx
		mov	eax,ecx
		add	ebx,sizeof s_broadcast
	.endw
	.if eax==[esi].s__idx
		mov	ecx,[esi].hSocket
		.while dword ptr[ebx]!=-1
			push	eax
			mov	eax,[esi].s__logintime
			.if (eax<=[ebx].sb_tcount)&&((esi!=[ebx].sb_exclude)||(ecx!=[ebx].sb_hSocket))&&([ebx].sb_type!=1)
				pop	eax
				.break
			.endif
			pop	eax
			add	eax,[ebx].sb_size
			add	ebx,sizeof s_broadcast
		.endw
		.if eax==[edx].s_used
			pop	edx
;			.if [edx].s_pending==-1
				push	edx
				invoke	EnterCriticalSection,addr s_critical
				pop	edx
				pop	eax
				.if eax!=[edx].s_used
					push	edx
					invoke	LeaveCriticalSection,addr s_critical
					pop	edx
					pop	esi
					jmp	s__bcast1_IOCP
				.endif
				push	eax
				mov	[edx].s_pending,-2
				push	edx
				invoke	LeaveCriticalSection,addr s_critical
				pop	edx
;			.endif
			pop	eax
			pop	esi
			mov	edx,[edx].s_next
			mov	[esi].s__bufno,edx
			mov	[esi].s__idx,0
			mov	[esi].s__retry,0
			ret
		.endif
		xor	ecx,ecx
	.else
		sub	ecx,[esi].s__idx
		mov	eax,[esi].s__idx
		add	ebx,sizeof s_broadcast
	.endif
	mov	[esi].s__idx,eax
	mov	eax,[esi].hSocket
	.while dword ptr[ebx]!=-1
		.if ((esi==[ebx].sb_exclude)&&(eax==[ebx].sb_hSocket))||([ebx].sb_type==1)
			.if ecx==0
				mov	ecx,[ebx].sb_size
				add	[esi].s__idx,ecx
				xor	ecx,ecx
				add	ebx,sizeof s_broadcast
				.break .if dword ptr[ebx]==-1
			.else
				.break
			.endif
		.else
			push	ecx
			mov	ecx,[esi].s__logintime
			.if ecx>[ebx].sb_tcount
				pop	ecx
				.if ecx==0
					mov	ecx,[ebx].sb_size
					add	[esi].s__idx,ecx
					xor	ecx,ecx
					add	ebx,sizeof s_broadcast
					.break .if dword ptr[ebx]==-1
				.else
					.break
				.endif
				push	ecx
			.endif
			pop	ecx
		.endif
		add	ecx,[ebx].sb_size
		add	ebx,sizeof s_broadcast
	.endw
	.if ecx==0
		pop	edx
	;	.if [edx].s_pending==-1
			push	edx
			invoke	EnterCriticalSection,addr s_critical
			pop	edx
			pop	eax
			.if eax!=[edx].s_used
				push	edx
				invoke	LeaveCriticalSection,addr s_critical
				pop	edx
				pop	esi
				jmp	s__bcast1_IOCP
			.endif
			push	eax
			mov	[edx].s_pending,-2
			push	edx
			invoke	LeaveCriticalSection,addr s_critical
			pop	edx
	;	.endif
		pop	eax
		pop	esi
		mov	edx,[edx].s_next
		mov	[esi].s__bufno,edx
		mov	[esi].s__idx,0
		mov	[esi].s__retry,0
		.if [edx].s_opcode==2
			jmp	s__bcast1
		.endif
		ret
	.endif
	call	s__bctrans

	pop	edx
	pop	eax
	pop	esi
	assume	ebx:nothing
	ret

assume	esi:nothing
assume	edx:nothing
endm






;edi,ecx
s_add_broadcast	macro
	ret
endm

s_userinit	macro
	.if (s_started!=0)
		invoke	EnterCriticalSection,addr s_critical
		assume	edx:ptr s_record
		mov	edx,s_buffers
		mov	ecx,edx
		.while ([edx].s_pending==-2)&&(edx!=s_lastbuf)
			mov	ecx,edx
			mov	edx,[edx].s_next
		.endw
		mov	[esi].s__bufno,ecx
		mov	edx,s_private
		.while ([edx].s_opcode!=0)&&(edx!=s_lastpriv)
			mov	edx,[edx].s_next
		.endw
		mov	[esi].s__bufpm,edx
		mov	[esi].ovr_send.bfidx2,edx
		mov	[esi].ovr_send.buffer2,0
		mov	[esi].ovr_send.bfidx2,0
		mov	[esi].ovr_send.bfsize2,0
		mov	[esi].last_op,0
		mov	[esi].s__idx,0
		mov	[esi].s__idxpm,0
		mov	[esi].s__retry,0
		mov	[esi].locked,0
		mov	[esi].http_tmp,0
		mov	[esi].http_tmp[4],0
		mov	[esi]._web,0
		mov	word ptr[esi].lastmc[MAX_MSG_LAST-2],7c00h
		mov	eax,sess_start
		inc	sess_start
		mov	[esi].sessionId,eax
		.if IOCPf&256
			invoke	setsockopt,[esi].hSocket,SOL_SOCKET,SO_KEEPALIVE,addr reuseaddr,4
		.endif
		assume	edx:nothing
		invoke	LeaveCriticalSection,addr s_critical
	.endif
endm


s_init		macro
	.if (IOCPf&32)||((IOCPf&128)&&(IOCPf&4))
		mov	s_started,2
		invoke	InitializeCriticalSection,addr s_critical
		invoke	GlobalAlloc,GPTR,sizeof s_record
		assume	eax:ptr s_record
		mov	s_buffers,eax
		mov	s_lastbuf,eax
		mov	s_lasterr,0
		mov	[eax].s_prev,0
		mov	[eax].s_next,0
		mov	[eax].s_opcode,0
		mov	[eax].s_used,0
		mov	[eax].s_index,1
		mov	[eax].s_pending,0
		invoke	GlobalAlloc,GPTR,sizeof s_record
		assume	eax:ptr s_record
		mov	s_private,eax
		mov	s_lastpriv,eax
		mov	s_lasterr,0
		mov	[eax].s_prev,0
		mov	[eax].s_next,0
		mov	[eax].s_opcode,0
		mov	[eax].s_used,0
		mov	[eax].s_index,1
		mov	[eax].s_pending,0
		assume	eax:nothing
		.if IOCPf&32
			mov	s_started,1
			invoke	CreateThread,0,0,addr s__thread,edi,0,addr thrid
		.endif
	.else
		mov	s_lasterr,0
		mov	s_started,0
		mov	s_buffers,0
		mov	s_lastbuf,0
	.endif
	mov	logins,0
endm

s_free		macro
	.if s_started
		.if s_started==1
			mov	s_started,0
			.while s_started!=2
				invoke	Sleep,2
			.endw
		.endif
		mov	s_started,0
		mov	s_lasterr,0
		invoke	EnterCriticalSection,addr s_critical
		mov	esi,s_buffers
		.while esi!=0
			push	dword ptr[esi]
			invoke	GlobalFree,esi
			pop	esi
		.endw
		mov	esi,s_private
		.while esi!=0
			push	dword ptr[esi]
			invoke	GlobalFree,esi
			pop	esi
		.endw
		invoke	LeaveCriticalSection,addr s_critical
		invoke	DeleteCriticalSection,addr s_critical
	.endif
endm

s_enter		macro
;	.if s_started
;		invoke	EnterCriticalSection,addr s_critical
;	.endif
endm

s_leave		macro
;	.if s_started
;		invoke	LeaveCriticalSection,addr s_critical
;	.endif
endm

