;	HeXHub version 5.11 Copyright (C) 2006-2014 Albu Cristian
;
;	This program is free software; you can redistribute it and/or modify
;	it under the terms of the GNU General Public License as published by
;	the Free Software Foundation.
;
;	This program is distributed in the hope that it will be useful,
;	but WITHOUT ANY WARRANTY; without even the implied warranty of
;	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;	GNU General Public License for more details.
;
;	You should have received a copy of the GNU General Public License
;	along with this program; if not, write to the Free Software
;	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
;
;	For more information send and e-mail to cristian.albu@gmail.com

include	webc.h

htmlproc	PROTO	:DWORD,:DWORD,:DWORD,:DWORD
dlg1021		PROTO	:DWORD,:DWORD,:DWORD,:DWORD
dlg1022		PROTO	:DWORD,:DWORD,:DWORD,:DWORD
VARMAX1=327680/5/2

web_info	struct
	next		dd	?
	hostname	db	256 dup(?)
	client		db	100 dup(?)
	clientip	dd	?,?
	webredir	db	512 dup(?)
	webindex	db	512 dup(?)
	webshare	db	512 dup(?)
	webopt		db	?
	_404		db	512 dup(?)
	forbid		db	8192-4 dup(?)
	accessadd	dd	?
	upload		dd	?
	webflags	dd	?
	rssmax		dd	?
	rssfile		db	512 dup(?)
web_info	ends

web_user_info	struct
	buffer_out	dd	?
	buffer_out_size	dd	?
	bufptr		dd	?	;pointer in buffer_out
	buffer_in	dd	?
	hThread		dd	?
	ptr_web_info	dd	?
	ptr_usrstruc	dd	?
	proxy_flags	dd	?
	realip		dd	?
	newlocation	dd	?
	newcookies	dd	?
	cptr		dd	?,?
	cpages		dd	?,?
	cpages1		db	?
	ptrcomments	dd	?,?,?
	_host		db	512 dup(?)
	referer		db	1024 dup(?)
	user_agent	db	512 dup(?)
	cookies		db	1024 dup(?)
	get_path	db	1024 dup(?)
	tmp_buffer_in	db	32768 dup(?)
	wdataf		dd	?
	wdatad		dd	?
	wdatab		dd	?,?
	wdata		WIN32_FIND_DATA <>
	_var		db	?
web_user_info	ends

web_strings	macro
webfile		db	'web.dat',0
websig		db	'Web1',0
defweb		db	'Web\',0
defrss		db	'Web\rss.xml',0
_defidx		db	'\'
defidx		db	'index.html',0
httphdr		db	'HTTP/1.0 ',0
http200		db	'200 OK',13,10,0
http404		db	'404 Not Found',13,10,0
httpfound0	db	'300 Multiple Choices',13,10,'Location: ',0
httpfound	db	'301 Moved permanently'
httploc		db	13,10,'Location: ',0
httpfound1	db	'302 Found',13,10,'Location: ',0
httpfound2	db	'303 See Other',13,10,'Location: ',0
httpfound3	db	'304 Not Modified',13,10,'Location: ',0
httpfound4	db	'305 Use Proxy',13,10,'Location: ',0
httpfound5	db	'306 ',13,10,'Location: ',0
httpfound6	db	'307 Temporary Redirect',13,10,'Location: ',0
httpct1		db	'Content-Type: ',0
defct1		db	'application/octet-stream',0
httpctype	db	'Content-Type: text/html;charset=UTF-8',13,10
httpclen	db	'Content-Length: ',0
httpconn	db	'Connection: ',0
cclose		db	'Close',13,10,0
ckeep		db	'Keep-Alive',13,10,0
;cachectrl	label	byte
cachectrl	db	'Pragma: no-cache',13,10,'Cache-Control: private',13,10
httpserv	db	'Server: HeXHub',13,10,0
cookiex		db	'; Expires: Tue, 1-Jan-1980 00:00:00 GMT',0
wredir		db	'<HTML><HEAD><TITLE>301 Moved permanently</TITLE></HEAD><BODY><H1>301 Moved</H1>The document has moved <A HREF="',0
wredir1		db	'">here</A>.</BODY></HTML>',13,10,0
wdays		db	'Sun,Mon,Tue,Wed,Thu,Fri,Sat,'
wmonths		db	'Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec '

include	mime.h

http300	dd	offset httpfound0
	dd	offset httpfound
	dd	offset httpfound1
	dd	offset httpfound2
	dd	offset httpfound3
	dd	offset httpfound4
	dd	offset httpfound5
	dd	offset httpfound6
endm

websettings	macro
	httpport	dw	?
	httpflags	dd	?	;bit 0 = don't send $Lock
	httpcnt		dw	?
	httpmem		dd	?
	webtmp		db	8192 dup(?)
endm

web_init	macro
	lea	edi,w_info
	mov	ecx,sizeof web_info
	xor	eax,eax
	push	edi
	rep	stosb
	pop	ebx
	assume	ebx:ptr web_info
	mov	[ebx].webflags,4+16+256+2048+32768
	mov	[ebx].rssmax,100
	lea	edi,[ebx].webshare
	lea	edx,defweb
	call	copyedx
	lea	edi,[ebx].rssfile
	lea	edx,defrss
	call	copyedx
	assume	ebx:nothing

	mov	httpport,80
	mov	httpflags,1
	mov	httpmem,0
	mov	httpcnt,0
	invoke	CreateFile,addr webfile,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,0,0
	.if eax!=INVALID_HANDLE_VALUE
		push	eax
		invoke	ReadFile,eax,addr webtmp,4,addr bread,0
		pop	eax
		push	eax
		.if dword ptr webtmp=='1beW'
			invoke	ReadFile,eax,addr httpport,2+4+2,addr bread,0
			.if bread==2+4+2
				movzx	ecx,httpcnt
				lea	edi,httpmem
				.while ecx
					push	ecx
					invoke	GlobalAlloc,GPTR,sizeof web_info
					mov	[edi],eax
					mov	edi,eax
					mov	eax,[esp+4]
					invoke	ReadFile,eax,edi,sizeof web_info,addr bread,0
					mov	dword ptr[edi],0
					pop	ecx
					dec	ecx
				.endw
			.endif
		.else
			mov	edx,dword ptr webtmp
			mov	dword ptr httpport,edx
			invoke	ReadFile,eax,addr httpport[4],2+2,addr bread,0
			.if bread==2+2
				movzx	ecx,httpcnt
				lea	edi,httpmem
				.while ecx
					push	ecx
					invoke	GlobalAlloc,GPTR,sizeof web_info
					mov	[edi],eax
					mov	edi,eax
					mov	eax,[esp+4]
					invoke	ReadFile,eax,edi,sizeof web_info-4-512,addr bread,0
					assume	edi:ptr web_info
					mov	[edi].rssmax,1000
					assume	edi:nothing
					mov	dword ptr[edi],0
					pop	ecx
					dec	ecx
				.endw
			.endif
		.endif
		call	CloseHandle
	.endif
endm

web_save	macro
	invoke	SetFileAttributes,addr webfile,0
	invoke	DeleteFile,addr webfile
	.if (httpport!=80)||(httpflags!=1)||(httpmem!=0)
		invoke	CreateFile,addr webfile,GENERIC_WRITE,FILE_SHARE_READ,0,CREATE_ALWAYS,0,0
		.if eax!=INVALID_HANDLE_VALUE
			push	eax
			invoke	WriteFile,eax,addr websig,4,addr bread,0
			pop	eax
			push	edi
			push	eax
			xor	ecx,ecx
			mov	edx,httpmem
			.while edx
				inc	ecx
				mov	edx,[edx]
			.endw
			mov	httpcnt,cx
			invoke	WriteFile,eax,addr httpport,2+4+2,addr bread,0
			movzx	ecx,httpcnt
			mov	edi,httpmem
			.while ecx
				push	ecx
				mov	eax,[esp+4]
				invoke	WriteFile,eax,edi,sizeof web_info,addr bread,0
				mov	edi,[edi]
				pop	ecx
				dec	ecx
			.endw
			call	CloseHandle
			pop	edi
		.endif
	.endif
endm

web_free	macro
	mov	esi,httpmem
	.while esi
		push	dword ptr[esi]
		invoke	GlobalFree,esi
		pop	esi
	.endw
endm

httpdlg		macro
	assume	edi:ptr web_info
host_get_params:
	invoke	GetDlgItemText,esi,101,addr w_info.hostname,255
	invoke	GetDlgItemText,esi,102,addr w_info.client,99
	push	esi
	lea	esi,w_info.client
	call	getrange
	mov	w_info.clientip,eax
	mov	w_info[4].clientip,edx
	pop	esi
	invoke	GetDlgItemText,esi,103,addr w_info.webredir,511
	invoke	GetDlgItemText,esi,104,addr w_info.webindex,507
	mov	dword ptr w_info.webindex[508],0
	invoke	GetDlgItemText,esi,105,addr w_info.webshare,511
	invoke	IsDlgButtonChecked,esi,500
	.if eax==BST_CHECKED
		mov	w_info.webopt,0
	.else
		invoke	IsDlgButtonChecked,esi,501
		.if eax==BST_CHECKED
			mov	w_info.webopt,1
		.else
			mov	w_info.webopt,2
		.endif
	.endif
	invoke	GetDlgItemText,esi,107,addr w_info._404,511
;	and	w_info.webflags,64
	invoke	IsDlgButtonChecked,esi,401
	.if eax==BST_CHECKED
		or	w_info.webflags,1
	.else
		and	w_info.webflags,1 xor -1
	.endif
	invoke	IsDlgButtonChecked,esi,404
	.if eax==BST_CHECKED
		or	w_info.webflags,2
	.else
		and	w_info.webflags,2 xor -1
	.endif
	invoke	IsDlgButtonChecked,esi,405
	.if eax==BST_CHECKED
		or	w_info.webflags,4
	.else
		and	w_info.webflags,4 xor -1
	.endif
	push	esi
	push	edi
	lea	esi,w_info[4]
	mov	ecx,sizeof web_info-4
	lea	edi,[edi+4]
	rep	movsb
	pop	edi
	pop	esi
	ret

host_set_params:
	push	esi
	push	edi
	mov	esi,edi
	lea	edi,w_info
	mov	ecx,sizeof web_info
	rep	movsb
	pop	edi
	pop	esi
	invoke	SetDlgItemText,esi,101,addr [edi].hostname
	invoke	SetDlgItemText,esi,102,addr [edi].client
	invoke	SetDlgItemText,esi,103,addr [edi].webredir
	invoke	SetDlgItemText,esi,104,addr [edi].webindex
	invoke	SetDlgItemText,esi,105,addr [edi].webshare
	.if [edi].webopt==0
		invoke	CheckDlgButton,esi,500,BST_CHECKED
		invoke	CheckDlgButton,esi,501,BST_UNCHECKED
		invoke	CheckDlgButton,esi,502,BST_UNCHECKED
		invoke	GetDlgItem,esi,103
		invoke	EnableWindow,eax,1
		invoke	GetDlgItem,esi,104
		invoke	EnableWindow,eax,0
		invoke	GetDlgItem,esi,7
		invoke	EnableWindow,eax,0
		invoke	GetDlgItem,esi,105
		invoke	EnableWindow,eax,0
		invoke	GetDlgItem,esi,8
		invoke	EnableWindow,eax,0
	.elseif [edi].webopt==1
		invoke	CheckDlgButton,esi,500,BST_UNCHECKED
		invoke	CheckDlgButton,esi,501,BST_CHECKED
		invoke	CheckDlgButton,esi,502,BST_UNCHECKED
		invoke	GetDlgItem,esi,103
		invoke	EnableWindow,eax,0
		invoke	GetDlgItem,esi,104
		invoke	EnableWindow,eax,1
		invoke	GetDlgItem,esi,7
		invoke	EnableWindow,eax,1
		invoke	GetDlgItem,esi,105
		invoke	EnableWindow,eax,0
		invoke	GetDlgItem,esi,8
		invoke	EnableWindow,eax,0
	.else
		invoke	CheckDlgButton,esi,500,BST_UNCHECKED
		invoke	CheckDlgButton,esi,501,BST_UNCHECKED
		invoke	CheckDlgButton,esi,502,BST_CHECKED
		invoke	GetDlgItem,esi,103
		invoke	EnableWindow,eax,0
		invoke	GetDlgItem,esi,104
		invoke	EnableWindow,eax,0
		invoke	GetDlgItem,esi,7
		invoke	EnableWindow,eax,0
		invoke	GetDlgItem,esi,105
		invoke	EnableWindow,eax,1
		invoke	GetDlgItem,esi,8
		invoke	EnableWindow,eax,1
	.endif
	invoke	SetDlgItemText,esi,107,addr [edi]._404
	.if [edi].webflags&1
		invoke	CheckDlgButton,esi,401,BST_CHECKED
		invoke	GetDlgItem,esi,102
		invoke	EnableWindow,eax,1
	.else
		invoke	CheckDlgButton,esi,401,BST_UNCHECKED
		invoke	GetDlgItem,esi,102
		invoke	EnableWindow,eax,0
	.endif
	.if [edi].webflags&2
		invoke	CheckDlgButton,esi,404,BST_CHECKED
		invoke	GetDlgItem,esi,107
		invoke	EnableWindow,eax,1
		invoke	GetDlgItem,esi,20
		invoke	EnableWindow,eax,1
	.else
		invoke	CheckDlgButton,esi,404,BST_UNCHECKED
		invoke	GetDlgItem,esi,107
		invoke	EnableWindow,eax,0
		invoke	GetDlgItem,esi,20
		invoke	EnableWindow,eax,0
	.endif
	.if [edi].webflags&4
		invoke	CheckDlgButton,esi,405,BST_CHECKED
		invoke	GetDlgItem,esi,88
		invoke	EnableWindow,eax,1
	.else
		invoke	CheckDlgButton,esi,405,BST_UNCHECKED
		invoke	GetDlgItem,esi,88
		invoke	EnableWindow,eax,0
	.endif
	ret
	assume	edi:nothing

dlg1021	PROC	hDlg:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	.if uMsg==WM_INITDIALOG
		invoke	SendDlgItemMessage,hDlg,100,EM_LIMITTEXT,512,0
		invoke	SendDlgItemMessage,hDlg,200,EM_LIMITTEXT,8192,0
		invoke	SetDlgItemText,hDlg,200,addr w_info.forbid
		invoke	SetDlgItemText,hDlg,100,addr w_info.rssfile
		mov	eax,w_info.accessadd
		.if eax>49999
			xor	eax,eax
			inc	eax
		.endif
		invoke	SetDlgItemInt,hDlg,102,eax,0
		invoke	SetDlgItemInt,hDlg,101,w_info.rssmax,0
		.if w_info.webflags&8
			invoke	CheckDlgButton,hDlg,400,BST_CHECKED
		.endif
		.if w_info.webflags&4096		;notify in opchat
			invoke	CheckDlgButton,hDlg,401,BST_CHECKED
		.endif
		.if w_info.webflags&8192		;notify in mainchat
			invoke	CheckDlgButton,hDlg,402,BST_CHECKED
		.endif
		.if w_info.webflags&16384		;update rss
			invoke	CheckDlgButton,hDlg,403,BST_CHECKED
			invoke	GetDlgItem,hDlg,87
			invoke	EnableWindow,eax,1
			invoke	GetDlgItem,hDlg,100
			invoke	EnableWindow,eax,1
			invoke	GetDlgItem,hDlg,88
			invoke	EnableWindow,eax,1
			invoke	GetDlgItem,hDlg,89
			invoke	EnableWindow,eax,1
			invoke	GetDlgItem,hDlg,101
			invoke	EnableWindow,eax,1
		.else
			invoke	GetDlgItem,hDlg,87
			invoke	EnableWindow,eax,0
			invoke	GetDlgItem,hDlg,100
			invoke	EnableWindow,eax,0
			invoke	GetDlgItem,hDlg,88
			invoke	EnableWindow,eax,0
			invoke	GetDlgItem,hDlg,89
			invoke	EnableWindow,eax,0
			invoke	GetDlgItem,hDlg,101
			invoke	EnableWindow,eax,0
		.endif
		.if w_info.webflags&65536		;add access level points
			invoke	CheckDlgButton,hDlg,404,BST_CHECKED
			invoke	GetDlgItem,hDlg,102
			invoke	EnableWindow,eax,1
			invoke	GetDlgItem,hDlg,10
			invoke	EnableWindow,eax,1
		.else
			invoke	GetDlgItem,hDlg,102
			invoke	EnableWindow,eax,0
			invoke	GetDlgItem,hDlg,10
			invoke	EnableWindow,eax,0
		.endif
		.if w_info.webflags&65536*2		;add access level points
			invoke	CheckDlgButton,hDlg,405,BST_CHECKED
		.endif
	.elseif uMsg==WM_COMMAND
		mov	eax,wParam
		.if ax==2
			invoke	EndDialog,hDlg,0
		.elseif ax==1
			invoke	GetDlgItemText,hDlg,200,addr w_info.forbid,8191-4
			invoke	IsDlgButtonChecked,hDlg,400
			.if eax==BST_CHECKED
				or	w_info.webflags,8
			.else
				and	w_info.webflags,8 xor -1
			.endif
			invoke	IsDlgButtonChecked,hDlg,401
			.if eax==BST_CHECKED
				or	w_info.webflags,4096
			.else
				and	w_info.webflags,4096 xor -1
			.endif
			invoke	IsDlgButtonChecked,hDlg,402
			.if eax==BST_CHECKED
				or	w_info.webflags,8192
			.else
				and	w_info.webflags,8192 xor -1
			.endif
			invoke	IsDlgButtonChecked,hDlg,403
			.if eax==BST_CHECKED
				or	w_info.webflags,16384
			.else
				and	w_info.webflags,16384 xor -1
			.endif
			invoke	IsDlgButtonChecked,hDlg,404
			.if eax==BST_CHECKED
				or	w_info.webflags,65536
			.else
				and	w_info.webflags,65536 xor -1
			.endif
			invoke	IsDlgButtonChecked,hDlg,405
			.if eax==BST_CHECKED
				or	w_info.webflags,65536*2
			.else
				and	w_info.webflags,65536*2 xor -1
			.endif
			invoke	GetDlgItemText,hDlg,100,addr w_info.rssfile,511
			invoke	GetDlgItemInt,hDlg,101,0,0
			mov	w_info.rssmax,eax
			invoke	GetDlgItemInt,hDlg,102,0,0
			.if eax>49999
				xor	eax,eax
				inc	eax
			.endif
			mov	w_info.accessadd,eax
			invoke	EndDialog,hDlg,1
		.elseif ax==88
			invoke	GetDlgItemText,hDlg,100,addr webtmp,8191
			mov	ofn.lStructSize,sizeof OPENFILENAME
			push	hDlg
			pop	ofn.hwndOwner
			push	hInstance
			pop	ofn.hInstance
			mov	ofn.lpstrFilter,offset fltxml
			mov	ofn.lpstrCustomFilter,0
			mov	ofn.nMaxCustFilter,0
			mov	ofn.nFilterIndex,1
			mov	ofn.lpstrFile,offset webtmp
			mov	ofn.nMaxFile,511
			mov	ofn.lpstrFileTitle,0
			mov	ofn.lpstrFileTitle,0
			mov	ofn.lpstrInitialDir,0
			mov	ofn.lpstrTitle,0
			mov	ofn.Flags,OFN_EXPLORER or OFN_PATHMUSTEXIST or OFN_HIDEREADONLY or OFN_LONGNAMES or OFN_NOCHANGEDIR
			mov	ofn.nFileOffset,0
			mov	ofn.nFileExtension,0
			mov	ofn.lpstrDefExt,0
			mov	ofn.lCustData,0
			mov	ofn.lpfnHook,0
			mov	ofn.lpTemplateName,0
			invoke	GetSaveFileName,addr ofn
			.if eax!=0
				invoke	SetDlgItemText,hDlg,100,addr webtmp
			.endif
		.elseif ax==403
			invoke	IsDlgButtonChecked,hDlg,403
			.if eax==BST_CHECKED
				invoke	GetDlgItem,hDlg,87
				invoke	EnableWindow,eax,1
				invoke	GetDlgItem,hDlg,100
				invoke	EnableWindow,eax,1
				invoke	GetDlgItem,hDlg,88
				invoke	EnableWindow,eax,1
				invoke	GetDlgItem,hDlg,89
				invoke	EnableWindow,eax,1
				invoke	GetDlgItem,hDlg,101
				invoke	EnableWindow,eax,1
			.else
				invoke	GetDlgItem,hDlg,87
				invoke	EnableWindow,eax,0
				invoke	GetDlgItem,hDlg,100
				invoke	EnableWindow,eax,0
				invoke	GetDlgItem,hDlg,88
				invoke	EnableWindow,eax,0
				invoke	GetDlgItem,hDlg,89
				invoke	EnableWindow,eax,0
				invoke	GetDlgItem,hDlg,101
				invoke	EnableWindow,eax,0
			.endif
		.elseif ax==404
			invoke	IsDlgButtonChecked,hDlg,404
			.if eax==BST_CHECKED
				invoke	GetDlgItem,hDlg,102
				invoke	EnableWindow,eax,1
				invoke	GetDlgItem,hDlg,10
				invoke	EnableWindow,eax,1
			.else
				invoke	GetDlgItem,hDlg,102
				invoke	EnableWindow,eax,0
				invoke	GetDlgItem,hDlg,10
				invoke	EnableWindow,eax,0
			.endif
		.endif
	.endif
	xor	eax,eax
	ret
dlg1021	ENDP

dlg1022	PROC	hDlg:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	.if uMsg==WM_INITDIALOG
		mov	eax,w_info.upload
		invoke	SetDlgItemInt,hDlg,137,eax,0
		.if w_info.webflags&16
			invoke	CheckDlgButton,hDlg,429,BST_CHECKED
			invoke	GetDlgItem,hDlg,434
			invoke	EnableWindow,eax,1
		.else
			invoke	CheckDlgButton,hDlg,429,BST_UNCHECKED
			invoke	GetDlgItem,hDlg,434
			invoke	EnableWindow,eax,0
		.endif
		.if w_info.webflags&32
			invoke	CheckDlgButton,hDlg,435,BST_CHECKED
			invoke	GetDlgItem,hDlg,137
			invoke	EnableWindow,eax,1
			invoke	GetDlgItem,hDlg,86
			invoke	EnableWindow,eax,1
		.else
			invoke	CheckDlgButton,hDlg,435,BST_UNCHECKED
			invoke	GetDlgItem,hDlg,137
			invoke	EnableWindow,eax,0
			invoke	GetDlgItem,hDlg,86
			invoke	EnableWindow,eax,0
		.endif
		.if w_info.webflags&128
			invoke	CheckDlgButton,hDlg,436,BST_CHECKED
		.else
			invoke	CheckDlgButton,hDlg,436,BST_UNCHECKED
		.endif
		.if w_info.webflags&256
			invoke	CheckDlgButton,hDlg,437,BST_CHECKED
			invoke	GetDlgItem,hDlg,438
			invoke	EnableWindow,eax,1
		.else
			invoke	CheckDlgButton,hDlg,437,BST_UNCHECKED
			invoke	GetDlgItem,hDlg,438
			invoke	EnableWindow,eax,0
		.endif
		.if w_info.webflags&1024
			invoke	CheckDlgButton,hDlg,439,BST_CHECKED
		.else
			invoke	CheckDlgButton,hDlg,439,BST_UNCHECKED
		.endif
		.if w_info.webflags&512
			invoke	CheckDlgButton,hDlg,438,BST_CHECKED
		.else
			invoke	CheckDlgButton,hDlg,438,BST_UNCHECKED
		.endif
		.if w_info.webflags&32768
			invoke	CheckDlgButton,hDlg,440,BST_CHECKED
		.else
			invoke	CheckDlgButton,hDlg,440,BST_UNCHECKED
		.endif
		.if w_info.webflags&2048
			invoke	CheckDlgButton,hDlg,434,BST_CHECKED
		.else
			invoke	CheckDlgButton,hDlg,434,BST_UNCHECKED
		.endif
	.elseif uMsg==WM_COMMAND
		mov	eax,wParam
		.if ax==2
			invoke	EndDialog,hDlg,0
		.elseif ax==1
			invoke	GetDlgItemInt,hDlg,137,0,0
			mov	w_info.upload,eax
			invoke	IsDlgButtonChecked,hDlg,429
			.if eax==BST_CHECKED
				or	w_info.webflags,16
			.else
				and	w_info.webflags,16 xor -1
			.endif
			invoke	IsDlgButtonChecked,hDlg,434
			.if eax==BST_CHECKED
				or	w_info.webflags,2048
			.else
				and	w_info.webflags,2048 xor -1
			.endif
			invoke	IsDlgButtonChecked,hDlg,435
			.if eax==BST_CHECKED
				or	w_info.webflags,32
			.else
				and	w_info.webflags,32 xor -1
			.endif
			invoke	IsDlgButtonChecked,hDlg,436
			.if eax==BST_CHECKED
				or	w_info.webflags,128
			.else
				and	w_info.webflags,128 xor -1
			.endif
			invoke	IsDlgButtonChecked,hDlg,437
			.if eax==BST_CHECKED
				or	w_info.webflags,256
			.else
				and	w_info.webflags,256 xor -1
			.endif
			invoke	IsDlgButtonChecked,hDlg,438
			.if eax==BST_CHECKED
				or	w_info.webflags,512
			.else
				and	w_info.webflags,512 xor -1
			.endif
			invoke	IsDlgButtonChecked,hDlg,439
			.if eax==BST_CHECKED
				or	w_info.webflags,1024
			.else
				and	w_info.webflags,1024 xor -1
			.endif
			invoke	IsDlgButtonChecked,hDlg,440
			.if eax==BST_CHECKED
				or	w_info.webflags,32768
			.else
				and	w_info.webflags,32768 xor -1
			.endif
			invoke	EndDialog,hDlg,1
		.elseif ax==429
			invoke	IsDlgButtonChecked,hDlg,429
			.if eax==BST_CHECKED
				invoke	GetDlgItem,hDlg,434
				invoke	EnableWindow,eax,1
			.else
				invoke	GetDlgItem,hDlg,434
				invoke	EnableWindow,eax,0
			.endif
		.elseif ax==435
			invoke	IsDlgButtonChecked,hDlg,435
			.if eax==BST_CHECKED
				invoke	GetDlgItem,hDlg,137
				invoke	EnableWindow,eax,1
				invoke	GetDlgItem,hDlg,86
				invoke	EnableWindow,eax,1
			.else
				invoke	GetDlgItem,hDlg,137
				invoke	EnableWindow,eax,0
				invoke	GetDlgItem,hDlg,86
				invoke	EnableWindow,eax,0
			.endif
		.elseif ax==437
			invoke	IsDlgButtonChecked,hDlg,437
			.if eax==BST_CHECKED
				invoke	GetDlgItem,hDlg,438
				invoke	EnableWindow,eax,1
			.else
				invoke	GetDlgItem,hDlg,438
				invoke	EnableWindow,eax,0
			.endif
		.endif
	.endif
	xor	eax,eax
	ret
dlg1022	ENDP

lvhost	db	'HTTP Hosts (* = any)',0
flthtm	db	'HTML files (*.html)',0,'*.html;*.htm',0,'Text files (*.txt)',0,'*.txt',0,'All files (*.*)',0,'*.*',0,0
fltxml	db	'XML files (*.xml)',0,'*.xml',0,'RSS files (*.rss)',0,'*.rss',0,'Text files (*.txt)',0,'*.txt',0,'All files (*.*)',0,'*.*',0,0
sh32	db	'shell32.dll',0
o32	db	'ole32.dll',0
shbr	db	'SHBrowseForFolder',0
shgp	db	'SHGetPathFromIDList',0
ctmem	db	'CoTaskMemFree',0
hctrls	dw	10,100,400,200,11,101,401,102,500,103,501,104,7,502,105,8,50,404,107,20,405,88,1,3,4,5,6,-1	;402,106,9,403,
hctrls1	dw	10,100,400,200,11,101,401,500,501,502,50,404,405,1,3,4,5,6,-1	;402,
dlg19proc	PROC	uses esi edi ebx hDlg:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	local	lvcol:LV_COLUMN
	local	lvit:LV_ITEM
	.if uMsg==WM_INITDIALOG
		invoke	SendDlgItemMessage,hDlg,200,LVM_SETEXTENDEDLISTVIEWSTYLE,LVS_EX_ONECLICKACTIVATE or LVS_EX_CHECKBOXES or LVS_EX_FULLROWSELECT or LVS_EX_TRACKSELECT,LVS_EX_ONECLICKACTIVATE or LVS_EX_CHECKBOXES or LVS_EX_FULLROWSELECT or LVS_EX_TRACKSELECT
		mov	lvcol.imask,LVCF_FMT or LVCF_TEXT or LVCF_WIDTH
		mov	lvcol.fmt,LVCFMT_LEFT
		mov	lvcol.lx,154
		mov	lvcol.pszText,offset lvhost
		mov	lvcol.cchTextMax,sizeof lvhost
		mov	lvcol.iSubItem,0
		invoke	SendDlgItemMessage,hDlg,200,LVM_INSERTCOLUMN,0,addr lvcol
		invoke	SendDlgItemMessage,hDlg,101,EM_LIMITTEXT,255,0
		invoke	SendDlgItemMessage,hDlg,102,EM_LIMITTEXT,99,0
		invoke	SendDlgItemMessage,hDlg,103,EM_LIMITTEXT,511,0
		invoke	SendDlgItemMessage,hDlg,104,EM_LIMITTEXT,511,0
		invoke	SendDlgItemMessage,hDlg,105,EM_LIMITTEXT,511,0
		invoke	SendDlgItemMessage,hDlg,108,EM_LIMITTEXT,8191,0

		lea	edi,w_info
		call	host_set_params

		movzx	eax,httpport
		invoke	SetDlgItemInt,hDlg,100,eax,0
		.if (httpflags&1)
			invoke	CheckDlgButton,hDlg,409,BST_CHECKED
		.else
			lea	esi,hctrls
			cld
			.while word ptr[esi]!=-1
				lodsw
				movzx	eax,ax
				invoke	GetDlgItem,hDlg,eax
				invoke	EnableWindow,eax,0
			.endw
		.endif
		.if httpflags&2
			invoke	CheckDlgButton,hDlg,400,BST_CHECKED
		.endif
		mov	esi,httpmem
		assume	esi:ptr web_info
		mov	lvit.iItem,0
		.while esi
			mov	lvit.imask,LVIF_TEXT or LVIF_PARAM or LVIF_STATE
			mov	lvit.iSubItem,0
			.if [esi].webflags&64
				mov	eax,8192
			.else
				mov	eax,4096
			.endif
			mov	lvit.state,eax
			mov	lvit.stateMask,LVIS_STATEIMAGEMASK
			lea	eax,[esi].hostname
			mov	lvit.pszText,eax
			mov	lvit.cchTextMax,256
			mov	lvit.lParam,esi
			invoke	SendDlgItemMessage,hDlg,200,LVM_INSERTITEM,0,addr lvit
			mov	lvit.imask,LVIF_STATE
			invoke	SendDlgItemMessage,hDlg,200,LVM_SETITEMSTATE,lvit.iItem,addr lvit
			inc	lvit.iItem
			mov	esi,[esi].next
		.endw
		assume	esi:nothing
	.elseif uMsg==WM_COMMAND
		mov	eax,wParam
		mov	ebx,eax
		shr	ebx,16
		.if ax==1
			mov	esi,hDlg
			invoke	GlobalAlloc,GPTR,sizeof web_info
			mov	edi,eax
			mov	dword ptr[edi],0
			lea	edx,httpmem
			.while dword ptr[edx]
				mov	edx,[edx]
			.endw
			mov	[edx],edi
			call	host_get_params
			invoke	SendDlgItemMessage,hDlg,200,LVM_GETITEMCOUNT,0,0
			mov	lvit.iItem,eax
			mov	lvit.imask,LVIF_TEXT or LVIF_PARAM or LVIF_STATE
			mov	lvit.iSubItem,0
			mov	eax,8192 or LVIS_SELECTED
			mov	lvit.state,eax
			mov	lvit.stateMask,LVIS_STATEIMAGEMASK or LVIS_SELECTED
			assume	edi:ptr web_info
			or	[edi].webflags,64
			lea	eax,[edi].hostname
			assume	edi:nothing
			mov	lvit.pszText,eax
			mov	lvit.cchTextMax,256
			mov	lvit.lParam,edi
			invoke	SendDlgItemMessage,hDlg,200,LVM_INSERTITEM,0,addr lvit
			mov	lvit.imask,LVIF_STATE
			mov	lvit.iItem,eax
			mov	lvit.state,8192 or LVIS_SELECTED
			mov	lvit.stateMask,LVIS_STATEIMAGEMASK or LVIS_SELECTED
			invoke	SendDlgItemMessage,hDlg,200,LVM_SETITEMSTATE,lvit.iItem,addr lvit
		.elseif ax==88
			invoke	DialogBoxParam,hInstance,1021,hDlg,addr dlg1021,0
		.elseif ax==5
			invoke	DialogBoxParam,hInstance,1022,hDlg,addr dlg1022,0
		.elseif ax==3
			invoke	SendDlgItemMessage,hDlg,200,LVM_GETNEXTITEM,-1,LVIS_SELECTED
			.if eax!=-1
				mov	lvit.imask,LVIF_PARAM
				mov	lvit.lParam,0
				mov	lvit.iItem,eax
				mov	lvit.iSubItem,0
				invoke	SendDlgItemMessage,hDlg,200,LVM_GETITEM,0,addr lvit
				.if lvit.lParam!=0
					mov	edi,lvit.lParam
					mov	esi,hDlg
					call	host_get_params
					mov	lvit.imask,LVIF_TEXT
					mov	lvit.iSubItem,0
					assume	edi:ptr web_info
					lea	eax,[edi].hostname
					assume	edi:nothing
					mov	lvit.pszText,eax
					mov	lvit.cchTextMax,256
					invoke	SendDlgItemMessage,hDlg,200,LVM_SETITEM,0,addr lvit
				.endif
			.endif
		.elseif ax==4
			invoke	SendDlgItemMessage,hDlg,200,LVM_GETNEXTITEM,-1,LVIS_SELECTED
			.if eax!=-1
				mov	lvit.imask,LVIF_PARAM
				mov	lvit.lParam,0
				mov	lvit.iItem,eax
				mov	lvit.iSubItem,0
				invoke	SendDlgItemMessage,hDlg,200,LVM_GETITEM,0,addr lvit
				.if lvit.lParam!=0
					mov	edi,lvit.lParam
					lea	edx,httpmem
					.while (edi!=[edx])&&(edx!=0)
						mov	edx,[edx]
					.endw
					.if edx
						mov	eax,[edi]
						mov	[edx],eax
						invoke	SendDlgItemMessage,hDlg,200,LVM_DELETEITEM,lvit.iItem,0
						invoke	SendDlgItemMessage,hDlg,200,LVM_GETITEMCOUNT,0,0
						.if eax
							dec	eax
						.endif
						.if eax>lvit.iItem
							mov	eax,lvit.iItem
						.endif
						mov	lvit.iItem,eax
						mov	lvit.imask,LVIF_STATE
						mov	lvit.iItem,eax
						mov	lvit.state,LVIS_SELECTED
						mov	lvit.stateMask,LVIS_SELECTED
						invoke	SendDlgItemMessage,hDlg,200,LVM_SETITEMSTATE,lvit.iItem,addr lvit
					.endif
				.endif
			.endif
		.elseif ax==5
			invoke	DialogBoxParam,hInstance,1022,hDlg,addr dlg1022,0
		.elseif ax==7
			invoke	GetDlgItemText,hDlg,104,addr webtmp,8191
			mov	ofn.lStructSize,sizeof OPENFILENAME
			push	hDlg
			pop	ofn.hwndOwner
			push	hInstance
			pop	ofn.hInstance
			mov	ofn.lpstrFilter,offset flthtm
			mov	ofn.lpstrCustomFilter,0
			mov	ofn.nMaxCustFilter,0
			mov	ofn.nFilterIndex,1
			mov	ofn.lpstrFile,offset webtmp
			mov	ofn.nMaxFile,511
			mov	ofn.lpstrFileTitle,0
			mov	ofn.lpstrFileTitle,0
			mov	ofn.lpstrInitialDir,0
			mov	ofn.lpstrTitle,0
			mov	ofn.Flags,OFN_EXPLORER or OFN_FILEMUSTEXIST or OFN_HIDEREADONLY or OFN_LONGNAMES or OFN_NOCHANGEDIR or OFN_PATHMUSTEXIST
			mov	ofn.nFileOffset,0
			mov	ofn.nFileExtension,0
			mov	ofn.lpstrDefExt,0
			mov	ofn.lCustData,0
			mov	ofn.lpfnHook,0
			mov	ofn.lpTemplateName,0
			invoke	GetOpenFileName,addr ofn
			.if eax!=0
				invoke	SetDlgItemText,hDlg,104,addr webtmp
			.endif
		.elseif ax==8
			.if shbrowseforfolder==0
				.if shell32==0
					invoke	LoadLibrary,addr sh32
					mov	shell32,eax
				.endif
				.if shell32
					invoke	GetProcAddress,shell32,addr shbr
					mov	shbrowseforfolder,eax
					invoke	GetProcAddress,shell32,addr shgp
					mov	shgetpathfromidlist,eax
				.endif
			.endif
			.if shbrowseforfolder
				invoke	GlobalAlloc,GPTR,8192
				push	eax
				invoke	GetCurrentDirectory,8192,eax
				mov	eax,hDlg
				mov	shbff.hwndOwner,eax
				push	offset shbff
				call	shbrowseforfolder
				.if eax!=0
					push	eax
					push	offset webtmp
					push	eax
					call	shgetpathfromidlist
					.if cotaskmemfree==0
						.if ole32==0
							invoke	LoadLibrary,addr o32
							mov	ole32,eax
						.endif
						.if eax
							invoke	GetProcAddress,ole32,addr ctmem
							mov	cotaskmemfree,eax
						.endif
					.endif
					pop	eax
					.if cotaskmemfree
						push	eax
						call	cotaskmemfree
					.endif
					invoke	SetDlgItemText,hDlg,105,addr webtmp
				.endif
				pop	eax
				push	eax
				invoke	SetCurrentDirectory,eax
				call	GlobalFree
			.endif
		.elseif ax==20
			invoke	GetDlgItemText,hDlg,107,addr webtmp,8191
			mov	ofn.lStructSize,sizeof OPENFILENAME
			push	hDlg
			pop	ofn.hwndOwner
			push	hInstance
			pop	ofn.hInstance
			mov	ofn.lpstrFilter,offset flthtm
			mov	ofn.lpstrCustomFilter,0
			mov	ofn.nMaxCustFilter,0
			mov	ofn.nFilterIndex,1
			mov	ofn.lpstrFile,offset webtmp
			mov	ofn.nMaxFile,511
			mov	ofn.lpstrFileTitle,0
			mov	ofn.lpstrFileTitle,0
			mov	ofn.lpstrInitialDir,0
			mov	ofn.lpstrTitle,0
			mov	ofn.Flags,OFN_EXPLORER or OFN_FILEMUSTEXIST or OFN_HIDEREADONLY or OFN_LONGNAMES or OFN_NOCHANGEDIR or OFN_PATHMUSTEXIST
			mov	ofn.nFileOffset,0
			mov	ofn.nFileExtension,0
			mov	ofn.lpstrDefExt,0
			mov	ofn.lCustData,0
			mov	ofn.lpfnHook,0
			mov	ofn.lpTemplateName,0
			invoke	GetOpenFileName,addr ofn
			.if eax!=0
				invoke	SetDlgItemText,hDlg,107,addr webtmp
			.endif
		.elseif (ax==400)&&(httpflags&1)
			invoke	IsDlgButtonChecked,hDlg,400
			.if eax==BST_CHECKED
				or	httpflags,2
			.else
				and	httpflags,2 xor -1
			.endif
		.elseif (ax==401)&&(httpflags&1)
			invoke	IsDlgButtonChecked,hDlg,401
			.if eax==BST_CHECKED
				invoke	GetDlgItem,hDlg,102
				invoke	EnableWindow,eax,1
			.else
				invoke	GetDlgItem,hDlg,102
				invoke	EnableWindow,eax,0
			.endif
		.elseif (ax==404)&&(httpflags&1)
			invoke	IsDlgButtonChecked,hDlg,404
			.if eax==BST_CHECKED
				invoke	GetDlgItem,hDlg,107
				invoke	EnableWindow,eax,1
				invoke	GetDlgItem,hDlg,20
				invoke	EnableWindow,eax,1
			.else
				invoke	GetDlgItem,hDlg,107
				invoke	EnableWindow,eax,0
				invoke	GetDlgItem,hDlg,20
				invoke	EnableWindow,eax,0
			.endif
		.elseif (ax==405)&&(httpflags&1)
			invoke	IsDlgButtonChecked,hDlg,405
			.if eax==BST_CHECKED
				invoke	GetDlgItem,hDlg,88
				invoke	EnableWindow,eax,1
			.else
				invoke	GetDlgItem,hDlg,88
				invoke	EnableWindow,eax,0
			.endif
		.elseif ax==409
			movzx	eax,ax
			invoke	IsDlgButtonChecked,hDlg,eax
			.if eax==BST_CHECKED
				or	httpflags,1
				lea	esi,hctrls1
				cld
				.while word ptr[esi]!=-1
					lodsw
					movzx	eax,ax
					invoke	GetDlgItem,hDlg,eax
					invoke	EnableWindow,eax,1
				.endw
				invoke	IsDlgButtonChecked,hDlg,401
				.if eax==BST_CHECKED
					invoke	GetDlgItem,hDlg,102
					invoke	EnableWindow,eax,1
				.else
					invoke	GetDlgItem,hDlg,102
					invoke	EnableWindow,eax,0
				.endif
				invoke	IsDlgButtonChecked,hDlg,404
				.if eax==BST_CHECKED
					invoke	GetDlgItem,hDlg,107
					invoke	EnableWindow,eax,1
					invoke	GetDlgItem,hDlg,20
					invoke	EnableWindow,eax,1
				.else
					invoke	GetDlgItem,hDlg,107
					invoke	EnableWindow,eax,0
					invoke	GetDlgItem,hDlg,20
					invoke	EnableWindow,eax,0
				.endif
				invoke	IsDlgButtonChecked,hDlg,405
				.if eax==BST_CHECKED
					invoke	GetDlgItem,hDlg,88
					invoke	EnableWindow,eax,1
				.else
					invoke	GetDlgItem,hDlg,88
					invoke	EnableWindow,eax,0
				.endif
				invoke	IsDlgButtonChecked,hDlg,500
				.if eax==BST_CHECKED
					invoke	GetDlgItem,hDlg,103
					invoke	EnableWindow,eax,1
					invoke	GetDlgItem,hDlg,104
					invoke	EnableWindow,eax,0
					invoke	GetDlgItem,hDlg,7
					invoke	EnableWindow,eax,0
					invoke	GetDlgItem,hDlg,105
					invoke	EnableWindow,eax,0
					invoke	GetDlgItem,hDlg,8
					invoke	EnableWindow,eax,0
				.else
					invoke	IsDlgButtonChecked,hDlg,501
					.if eax==BST_CHECKED
						invoke	GetDlgItem,hDlg,103
						invoke	EnableWindow,eax,0
						invoke	GetDlgItem,hDlg,104
						invoke	EnableWindow,eax,1
						invoke	GetDlgItem,hDlg,7
						invoke	EnableWindow,eax,1
						invoke	GetDlgItem,hDlg,105
						invoke	EnableWindow,eax,0
						invoke	GetDlgItem,hDlg,8
						invoke	EnableWindow,eax,0
					.else
						invoke	IsDlgButtonChecked,hDlg,502
						.if eax==BST_CHECKED
							invoke	GetDlgItem,hDlg,103
							invoke	EnableWindow,eax,0
							invoke	GetDlgItem,hDlg,104
							invoke	EnableWindow,eax,0
							invoke	GetDlgItem,hDlg,7
							invoke	EnableWindow,eax,0
							invoke	GetDlgItem,hDlg,105
							invoke	EnableWindow,eax,1
							invoke	GetDlgItem,hDlg,8
							invoke	EnableWindow,eax,1
						.endif
					.endif
				.endif
			.else
				and	httpflags,1 xor -1
				lea	esi,hctrls
				cld
				.while word ptr[esi]!=-1
					lodsw
					movzx	eax,ax
					invoke	GetDlgItem,hDlg,eax
					invoke	EnableWindow,eax,0
				.endw
			.endif
		.elseif (ax==500)&&(httpflags&1)
			invoke	IsDlgButtonChecked,hDlg,500
			.if eax==BST_CHECKED
				invoke	GetDlgItem,hDlg,103
				invoke	EnableWindow,eax,1
				invoke	GetDlgItem,hDlg,104
				invoke	EnableWindow,eax,0
				invoke	GetDlgItem,hDlg,7
				invoke	EnableWindow,eax,0
				invoke	GetDlgItem,hDlg,105
				invoke	EnableWindow,eax,0
				invoke	GetDlgItem,hDlg,8
				invoke	EnableWindow,eax,0
			.endif
		.elseif (ax==501)&&(httpflags&1)
			invoke	IsDlgButtonChecked,hDlg,501
			.if eax==BST_CHECKED
				invoke	GetDlgItem,hDlg,103
				invoke	EnableWindow,eax,0
				invoke	GetDlgItem,hDlg,104
				invoke	EnableWindow,eax,1
				invoke	GetDlgItem,hDlg,7
				invoke	EnableWindow,eax,1
				invoke	GetDlgItem,hDlg,105
				invoke	EnableWindow,eax,0
				invoke	GetDlgItem,hDlg,8
				invoke	EnableWindow,eax,0
			.endif
		.elseif (ax==502)&&(httpflags&1)
			invoke	IsDlgButtonChecked,hDlg,502
			.if eax==BST_CHECKED
				invoke	GetDlgItem,hDlg,103
				invoke	EnableWindow,eax,0
				invoke	GetDlgItem,hDlg,104
				invoke	EnableWindow,eax,0
				invoke	GetDlgItem,hDlg,7
				invoke	EnableWindow,eax,0
				invoke	GetDlgItem,hDlg,105
				invoke	EnableWindow,eax,1
				invoke	GetDlgItem,hDlg,8
				invoke	EnableWindow,eax,1
			.endif
		.elseif (ax==100)&&(bx==EN_CHANGE)
			invoke	GetDlgItemInt,hDlg,100,0,0
			mov	httpport,ax
		.endif
	.elseif uMsg==WM_NOTIFY
		mov	ebx,lParam
		assume	ebx:ptr NMHDR
		mov	eax,[ebx].code
		assume	ebx:nothing
		.if eax==LVN_ITEMCHANGED
			assume	ebx:ptr NM_LISTVIEW
			.if ([ebx].uChanged&LVIF_STATE)&&([ebx].iItem!=-1)
				mov	eax,[ebx].uOldState
				xor	eax,[ebx].uNewState
				push	ebx
				.if eax&8192
					mov	eax,[ebx].iItem
					mov	lvit.iItem,eax
					mov	lvit.iSubItem,0
					mov	lvit.lParam,-1
					mov	lvit.imask,LVIF_PARAM
					invoke	SendDlgItemMessage,hDlg,200,LVM_GETITEM,0,addr lvit
					.if eax
						mov	edi,lvit.lParam
						.if edi!=-1
							assume	edi:ptr web_info
							.if [ebx].uNewState&8192
								or	[edi].webflags,64
							.else
								and	[edi].webflags,64 xor -1
							.endif
							assume	edi:nothing
						.endif
					.endif
				.endif
				pop	ebx
				.if ([ebx].uNewState&LVIS_SELECTED)&&(!([ebx].uOldState&LVIS_SELECTED))
					mov	eax,[ebx].iItem
					mov	lvit.iItem,eax
					mov	lvit.iSubItem,0
					mov	lvit.lParam,-1
					mov	lvit.imask,LVIF_PARAM
					invoke	SendDlgItemMessage,hDlg,200,LVM_GETITEM,0,addr lvit
					.if eax
						mov	edi,lvit.lParam
						.if edi!=-1
							mov	esi,hDlg
							call	host_set_params
						.endif
					.endif
				.endif
			.endif
		.endif
		assume	ebx:nothing
	.endif
	xor	eax,eax
	ret
dlg19proc	ENDP

hwdate:	movzx	eax,systime.wYear
	call	w4
	mov	al,'-'
	stosb
	movzx	eax,systime.wMonth
	call	w2
	mov	al,'-'
	stosb
	movzx	eax,systime.wDay
	call	w2
	mov	al,' '
	stosb
	movzx	eax,systime.wHour
	call	w2
	mov	al,':'
	stosb
	movzx	eax,systime.wMinute
	call	w2
	mov	al,':'
	stosb
	movzx	eax,systime.wSecond
	call	w2
	ret

httpwdate:
	mov	eax,'etaD'
	stosd
	mov	ax,' :'
	stosw
	movzx	eax,systime.wDayOfWeek
	.if eax>6
		int 3
		mov	eax,6
	.endif
	mov	eax,dword ptr wdays[eax*4]
	stosd
	mov	al,32
	stosb
	movzx	eax,systime.wDay
	call	w2
	mov	al,32
	stosb
	movzx	eax,systime.wMonth
	dec	eax
	.if eax>11
		int 3
		mov	eax,11
	.endif
	mov	eax,dword ptr wmonths[eax*4]
	stosd
	movzx	eax,systime.wYear
	call	w4
	mov	al,32
	stosb
	movzx	eax,systime.wHour
	call	w2
	mov	al,':'
	stosb
	movzx	eax,systime.wMinute
	call	w2
	mov	al,':'
	stosb
	movzx	eax,systime.wSecond
	call	w2
	mov	eax,'TMG '
	stosd
	mov	ax,0a0dh
	stosw
	ret

proxy_1	db	'<HTML><HEAD><TITLE>Proxies are disabled</TITLE></HEAD><BODY bgColor=#000000 text=#ffffff><H1><CENTER>Proxies are disabled</CENTER><P></H1>'
	db	'<FONT face="Arial" size="4"><SMALL><UL><LI>The area you are trying to access may contain sensitive information. Allowing this information'
	db	' to be viewed or altered by a third-party proxy server may represent a security risk for you and for this server.</LI></UL></SMALL></FONT></BODY></HTML>',0
proxy_1_c=418+4+5
proxy_2	db	'<HTML><HEAD><TITLE>Insecure proxy settings</TITLE></HEAD><BODY bgColor=#000000 text=#ffffff><H1><CENTER>Insecure proxy settings</CENTER><P></H1>'
	db	'<FONT face="Arial" size="4"><SMALL><UL><LI>The proxy server you are using is altering important parts of your data. Your access using this proxy has'
	db	' been disallowed.</LI></UL></SMALL></FONT></BODY></HTML>',0
proxy_2_c=339+4+5
proxy_3	db	'<HTML><HEAD><TITLE>Banned</TITLE></HEAD><BODY bgColor=#000000 text=#ffffff><H1><CENTER>Banned</CENTER><P></H1><FONT face="Arial" size="4"><SMALL>'
	db	'<UL><LI>You are banned from this server by <B>%[changedby]</B>. Wait until your ban expires or an administrator removes it.</LI><LI>Reason: <B>%[reason]</B></LI><LI>'
	db	'Remaining time: <B>%[expires]</B>.</LI></UL></SMALL></FONT></BODY></HTML>',0


endm

http_parse	macro
	mov	eax,[esi].ovr.bfidx2
	mov	ecx,[esi].ovr.bfsize2
	lea	eax,[ecx+eax]
	.if eax>3
		sub	eax,3
	.endif
	.if [esi].http_tmp==0
		xor	ecx,ecx
		push	ecx
		.while ecx<eax
			.if word ptr[ebx+ecx]==0a0dh
				mov	edx,[ebx+ecx+2]
				or	edx,20202020h
				.if edx=='tnoc'
					mov	edx,[ebx+ecx+2+4]
					or	edx,202020h
					.if edx=='-tne'
						mov	edx,[ebx+ecx+2+4+4]
						or	edx,20202020h
						.if edx=='gnel'
							mov	dx,[ebx+ecx+2+4+4+4]
							or	dx,2020h
							.if (dx=='ht')&&(byte ptr[ebx+ecx+2+4+4+4+2]==':')
								push	eax
								push	ebx
								push	ecx
								push	esi
								lea	esi,[ebx+ecx+2+4+4+4+2+1]
								.while byte ptr[esi]==32
									inc	esi
								.endw
								call	atoi
								mov	edx,eax
								pop	esi
								pop	ecx
								pop	ebx
								pop	eax
								mov	[esp],edx
							.endif
						.endif
					.endif
				.endif
			.endif
			.break .if (dword ptr[ebx+ecx]==0a0d0a0dh)||(word ptr[ebx+ecx]==0a0ah)
			inc	ecx
		.endw
		pop	edx
		.if ecx>max_http_header
			mov	eax,[ebx]
			jmp	_nothttp
		.elseif (dword ptr[ebx+ecx]!=0a0d0a0dh)&&(word ptr[ebx+ecx]!=0a0ah)
			ret
		.endif
		.if (edx!=0)
		;	lea	edx,[edx+ecx+4]
			mov	dword ptr[esi].http_tmp,edx
			.if edx>BUFMAX1-4096
				.if edx>BUFMAX3
					mov	edx,BUFMAX3-4096
				.endif
				mov	[esi].http_tmp,edx
			;	.if [esi].http_tmp[4]==0
					lea	edx,[edx+4096]
					push	eax
					push	edx
					push	ecx
					push	ebx
					invoke	GlobalAlloc,GPTR,edx
					mov	[esi].http_tmp[4],eax
					mov	byte ptr[eax],0
					pop	ebx
					pop	ecx
					pop	edx
					pop	eax
			;	.endif
				mov	[esi].minsharepro,0
			.endif
		.else
			.if (dword ptr[ebx+ecx]==0a0d0a0dh)
				lea	ecx,[ecx+4]
			.else
				inc	ecx
				inc	ecx
			.endif
			mov	eax,[esi].ovr.bfidx2
			add	[esi].ovr.bfsize2,eax
			mov	[esi].ovr.bfidx2,ecx
			sub	[esi].ovr.bfsize2,ecx
			or	[esi]._web,1
			jmp	skipload
		.endif
	.endif
	or	[esi]._web,1
	.if [esi].http_tmp[4]
		mov	ecx,[esi].ovr.bfsize2
		push	esi
		push	edi
		mov	edi,[esi].http_tmp[4]
		add	edi,[esi].minsharepro
		mov	eax,[esi].http_tmp
		sub	eax,[esi].minsharepro
		lea	edx,[esi].ovr.bfidx2
		mov	ecx,[esi].ovr.bfidx2
		add	ecx,[esi].ovr.bfsize2
		mov	[esi].ovr.bfidx2,0
		mov	[esi].ovr.bfsize2,0
		mov	esi,[esi].ovr.buffer2
		.while ecx
			.break .if (dword ptr[esi]==0a0d0a0dh)||(word ptr[esi]==0a0ah)
			inc	esi
			inc	dword ptr[edx]
			dec	ecx
		.endw
		.if dword ptr[esi]==0a0d0a0dh
			add	dword ptr[edx],4
			.if ecx>=4
				sub	ecx,4
				lea	esi,[esi+4]
			.else
				add	esi,ecx
				xor	ecx,ecx
			.endif
		.elseif word ptr[esi]==0a0ah
			add	dword ptr[edx],2
			.if ecx>=2
				inc	esi
				inc	esi
				dec	ecx
				dec	ecx
			.else
				add	esi,ecx
				xor	ecx,ecx
			.endif
		.endif
		mov	edx,ecx
		.if ecx>eax
			mov	ecx,eax
		.endif
		sub	edx,eax
		sub	eax,ecx
		.if ecx
			cld
			push	ecx
			rep	movsb
			pop	ecx
		.endif
		pop	edi
		pop	esi
		add	[esi].minsharepro,ecx
		.if eax
			ret
		.endif
		mov	eax,edx
		sub	eax,[esi].ovr.bfidx2
		mov	[esi].ovr.bfidx2,edx
		sub	[esi].ovr.bfsize2,eax
	.else
		mov	eax,[esi].ovr.bfidx2
		add	[esi].ovr.bfsize2,eax
		mov	[esi].ovr.bfidx2,0
		mov	eax,[esi].http_tmp
		lea	edx,[esi].ovr.bfidx2
		mov	ecx,[esi].ovr.bfidx2
		add	ecx,[esi].ovr.bfsize2
		mov	ebx,[esi].ovr.buffer2
		mov	[esi].ovr.bfidx2,0
		mov	[esi].ovr.bfsize2,0
		.while ecx
			.break .if (dword ptr[ebx]==0a0d0a0dh)||(word ptr[ebx]==0a0ah)
			inc	ebx
			inc	dword ptr[edx]
			dec	ecx
		.endw
		.if dword ptr[ebx]==0a0d0a0dh
			add	dword ptr[edx],4
			.if ecx>=4
				sub	ecx,4
			.else
				xor	ecx,ecx
			.endif
		.elseif word ptr[ebx]==0a0ah
			add	dword ptr[edx],2
			.if ecx>=2
				dec	ecx
				dec	ecx
			.else
				xor	ecx,ecx
			.endif
		.endif
		mov	[esi].ovr.bfsize2,ecx

		mov	eax,[esi].http_tmp
		.if eax>ecx
			ret
		.endif
		add	[esi].ovr.bfidx2,eax
	.endif

skipload:
	mov	[esi].cs_whois_who_seen.lasttick,0
	mov	dword ptr [esi].cs_whois_who_seen.flcnt1,0
	getbuffer
	mov	ebx,[esi].ovr.buffer2
	lea	ebx,[ebx+4]
	.while byte ptr[ebx]==32
		inc	ebx
	.endw
	xor	ecx,ecx
	.while (byte ptr[ebx]>32)&&(byte ptr[ebx]!='?')&&(byte ptr[ebx]!='#')&&(ecx<1023)
		mov	al,[ebx]
		mov	[edi+ecx],al
		inc	ecx
		inc	ebx
	.endw
	.while (byte ptr[ebx]!=13)&&(byte ptr[ebx]!=10)&&(byte ptr[ebx]!=0)
		inc	ebx
	.endw
	mov	byte ptr[edi+ecx],0
	lea	edi,[edi+1024]
	mov	dword ptr[edi],0	;host_id
	mov	dword ptr[edi+4],0	;TTL,proxy
	mov	byte ptr[edi+8],0	;referer
	mov	byte ptr[edi+8+1024],0	;user-agent
	mov	byte ptr[edi+8+1024+512],0 ;cookie
	mov	edx,dword ptr[esi].ovr.buffer2
	.if byte ptr[edx]=='H'
		or	byte ptr[edi+4],16
	.endif
	.while dword ptr[ebx]!=0a0d0a0dh
		.while (byte ptr[ebx]==13)||(byte ptr[ebx]==10)
			inc	ebx
		.endw
		mov	eax,[ebx]
		or	eax,20202020h
		.if (eax=='tsoh')&&(byte ptr[ebx+4]==':')
			lea	ebx,[ebx+5]
			.while (byte ptr[ebx]==32)
				inc	ebx
			.endw
			mov	dword ptr [esi].cs_whois_who_seen.flcnt1,ebx
			mov	eax,[ebx]
			or	eax,20202020h
			.if (eax=='ptth')&&(word ptr[ebx+4]=='/:')&&(byte ptr[ebx+6]=='/')
				lea	ebx,[ebx+7]
				.while byte ptr[ebx]==32
					inc	ebx
				.endw
			.endif
			mov	edx,httpmem
			.while edx
				assume	edx:ptr web_info
				push	edx
				lea	edx,[edx].hostname
				xor	ecx,ecx
				mov	ax,100h
				.while byte ptr[edx+ecx]
					mov	al,[edx+ecx]
					mov	ah,[ebx+ecx]
					or	ax,2020h
					.break .if al!=ah
					inc	ecx
				.endw
				pop	edx
				.if (al==ah)&&((byte ptr[ebx+ecx]==13)||(byte ptr[ebx+ecx]==10)||(byte ptr[ebx+ecx]==0)||(byte ptr[ebx+ecx]==':')||(byte ptr[ebx+ecx]=='/')||(byte ptr[ebx+ecx]=='\'))
					.if [edx].webflags&1
						mov	eax,[esi]._ip
						xchg	al,ah
						rol	eax,16
						xchg	al,ah
						mov	ecx,[edx].clientip
						xchg	cl,ch
						rol	ecx,16
						xchg	cl,ch
						.if eax>=ecx
							mov	ecx,[edx+4].clientip
							xchg	cl,ch
							rol	ecx,16
							xchg	cl,ch
							.if eax<=ecx
								mov	[edi],edx
								jmp	_hostok
							.endif
						.endif
					.else
						mov	[edi],edx
					;	jmp	_hostok
					.endif
				.endif
				assume	edx:nothing
				mov	edx,[edx]
			.endw
		.elseif eax=='nnoc'
			mov	eax,[ebx+4]
			or	eax,20202020h
			.if eax=='itce'
				mov	ax,[ebx+8]
				or	ax,2020h
				.if (ax=='no')&&(byte ptr[ebx+10]==':')
					lea	ebx,[ebx+11]
					.while byte ptr[ebx]==32
						inc	ebx
					.endw
					mov	eax,[ebx]
					or	eax,20202020h
					.if eax=='solc'
						or	byte ptr[edi+4],1
					.endif
				.endif
			.endif
		.elseif (eax=='resu')&&(byte ptr[ebx+4]=='-')
			mov	eax,[ebx+5]
			or	eax,20202020h
			.if (eax=='nega')&&((byte ptr[ebx+5+4]=='t')||(byte ptr[ebx+5+4]=='T'))
				lea	ebx,[ebx+5+4+1]
				.while byte ptr[ebx]==32
					inc	ebx
				.endw
				.if byte ptr[ebx]==':'
					inc	ebx
				.endif
				.while byte ptr[ebx]==32
					inc	ebx
				.endw
				push	edi
				lea	edi,[edi+8+1024]
				xor	ecx,ecx
				.while (ecx<511)&&(byte ptr[ebx]!=13)&&(byte ptr[ebx]!=10)&&(byte ptr[ebx]!=0)
					mov	al,[ebx]
					stosb
					inc	ebx
					inc	ecx
				.endw
				mov	al,0
				stosb
				pop	edi
			.endif
		.elseif (eax=='efer')
			mov	eax,[ebx+4]
			or	eax,20202020h
			.if eax==':rer'
				lea	ebx,[ebx+8]
				.while byte ptr[ebx]==32
					inc	ebx
				.endw
				push	edi
				lea	edi,[edi+8]
				xor	ecx,ecx
				.while (ecx<1023)&&(byte ptr[ebx]!=13)&&(byte ptr[ebx]!=10)&&(byte ptr[ebx]!=0)
					mov	al,[ebx]
					stosb
					inc	ebx
					inc	ecx
				.endw
				mov	al,0
				stosb
				pop	edi
			.endif
		.elseif eax=='kooc'
			mov	ax,[ebx+4]
			or	ax,2020h
			.if (ax=='ei')&&(byte ptr[ebx+6]==':')
				lea	ebx,[ebx+7]
				.while byte ptr[ebx]==32
					inc	ebx
				.endw
				push	edi
				lea	edi,[edi+8+1024+512]
				xor	ecx,ecx
				.while (ecx<1023)&&(byte ptr[ebx]!=13)&&(byte ptr[ebx]!=10)&&(byte ptr[ebx]!=0)
					mov	al,[ebx]
					stosb
					inc	ebx
					inc	ecx
				.endw
				mov	al,0
				stosb
				pop	edi
			.endif
		.elseif (eax=='xorp')||(eax==':aiv')
			or	byte ptr[edi+4],2
		.elseif (al=='x')&&(byte ptr[ebx+1]=='-')
			mov	eax,[ebx+2]
			or	eax,20202020h
			.if (eax=='wrof')||(eax=='dnes')
				or	byte ptr[edi+4],2+4
				push	ebx
				push	edx
				.while (byte ptr[ebx]!=':')&&(byte ptr[ebx]>32)
					inc	ebx
				.endw
				.while (byte ptr[ebx]==32)||(byte ptr[ebx]==':')
					inc	ebx
				.endw
				call	is_ip
				.if eax
					.if ([esi].cs_whois_who_seen.lasttick!=0)&&([esi].cs_whois_who_seen.lasttick!=ecx)
						mov	[esi].cs_whois_who_seen.lasttick,-1
					.else
						mov	[esi].cs_whois_who_seen.lasttick,ecx
					.endif
				.endif
				pop	edx
				pop	ebx
			.endif
		.elseif (ax=='am')&&((byte ptr[ebx+2]=='x')||(byte ptr[ebx+2]=='X'))&&(byte ptr[ebx+3]=='-')
			mov	eax,[ebx+4]
			or	eax,20202020h
			.if eax=='wrof'
				or	byte ptr[edi+4],2
			.endif
		.endif
_hostok:	.while (byte ptr[ebx]!=13)&&(byte ptr[ebx]!=10)
			inc	ebx
		.endw
	.endw
	.if dword ptr[edi]==0
		mov	edx,httpmem
		.while edx
			assume	edx:ptr web_info
			mov	ax,word ptr[edx].hostname
			.if ax=='*'
				.if [edx].webflags&1
					mov	eax,[esi]._ip
					xchg	al,ah
					rol	eax,16
					xchg	al,ah
					mov	ecx,[edx].clientip
					xchg	cl,ch
					rol	ecx,16
					xchg	cl,ch
					.if eax>=ecx
						mov	ecx,[edx+4].clientip
						xchg	cl,ch
						rol	ecx,16
						xchg	cl,ch
						.if eax<=ecx
							mov	[edi],edx
							mov	ebx,[esi].ovr.buffer2
							.while (byte ptr[ebx]!=13)&&(byte ptr[ebx]!=10)
								inc	ebx
							.endw
							jmp	_hostok
						.endif
					.endif
				.else
					mov	[edi],edx
					mov	ebx,[esi].ovr.buffer2
					.while (byte ptr[ebx]!=13)&&(byte ptr[ebx]!=10)
						inc	ebx
					.endw
					jmp	_hostok
				.endif
			.endif
			assume	edx:nothing
			mov	edx,[edx]
		.endw
		.if [esi].http_tmp[4]
			invoke	GlobalFree,[esi].http_tmp[4]
			mov	[esi].http_tmp[4],0
		.endif
		mov	[esi].http_tmp,0
		ret
	.endif
	mov	edx,dword ptr[edi]
	assume	edx:ptr web_info
	.if (!([edx].webflags&1024))
		xor	eax,eax
		inc	eax
		mov	ecx,hPlugins
		.while ecx
			assume	ecx:ptr pluginInfo
			.if ([ecx].pluginStatus==1)&&([ecx]._onhttp1!=0)
				push	edx
				push	ecx
				push	esi
				push	edi
				push	ebp
				mov	ebp,esp

				push	dword ptr[edi+4]
				lea	eax,[edi+8+1024+512]
				push	eax
				lea	eax,[edi+8+1024]
				push	eax
				lea	eax,[edi+8]
				push	eax
				mov	edx,dword ptr[edi]
				lea	eax,[edx].hostname
				push	eax
				push	[esi].ovr.buffer2
				push	[esi].sessionId
				call	[ecx]._onhttp1
				.if ebp!=esp
					mov	al,19
					int 3
				.endif
				pop	ebp
				pop	edi
				pop	esi
				pop	ecx
				pop	edx
				.break .if (eax==0)||(eax==-1)
			.endif
			assume	ecx:nothing
			mov	ecx,dword ptr[ecx]
		.endw
		.if eax==0
			mov	eax,[esi].ipptr
			assume	eax:ptr ip_info
			mov	dword ptr[eax].timer1,0
			mov	dword ptr[eax].timer3,0
			mov	[eax].fcount,0
			assume	eax:nothing
			.if [esi].http_tmp[4]
				invoke	GlobalFree,[esi].http_tmp[4]
				mov	[esi].http_tmp[4],0
			.endif
			mov	[esi].http_tmp,0
			ret
		.elseif eax==-1
			.if [esi].http_tmp[4]
				invoke	GlobalFree,[esi].http_tmp[4]
				mov	[esi].http_tmp[4],0
			.endif
			mov	[esi].http_tmp,0
			ret
		.endif
	.endif
	mov	ebx,[esi].ovr.buffer2
	.if [edx].webflags&128
		push	edx
		push	edi
		lea	edi,[edi+4096]
		call	http_req
		pop	edi
		pop	edx
	.endif
	.if [edx].webflags&256
		invoke	SaveLog,edx
	.endif
	.if (byte ptr[edi+4]&4)
		mov	eax,[esi].cs_whois_who_seen.lasttick
		.if (eax==0)||(eax==-1)||(al==127)||(ax==168*256+192)||(al==10)||((al==172)&&(ah>=16)&&(ah<=31))||(eax==[esi]._ip)
			push	edi
			push	edx
			lea	edi,[edi+4096]
			lea	edx,httphdr
			call	copyedx
			lea	edx,http200
			call	copyedx
			call	httpwdate
			lea	edx,httpctype
			call	copyedx
			mov	eax,proxy_2_c
			push	ebx
			call	itoa
			pop	ebx
			mov	ax,0a0dh
			stosw
			lea	edx,cachectrl
			call	copyedx
			lea	edx,httpconn
			call	copyedx
			mov	eax,[esp+4]
			mov	eax,[eax+4]
			.if eax&1
				lea	edx,cclose
			.else
				lea	edx,ckeep
			.endif
			push	eax
			call	copyedx
			mov	ax,0a0dh
			stosw
			pop	eax
			.if (!(eax&16))
				lea	edx,proxy_2
				call	copyedx
			.endif
			mov	ecx,edi
			pop	edx
			pop	edi
			push	edi
			lea	edi,[edi+4096]
			sub	ecx,edi
			invoke	asend,edi,ecx
			pop	edi
			mov	eax,[edi+4]
			.if al&1
				call	disconn
			.endif
			.if [esi].http_tmp[4]
				invoke	GlobalFree,[esi].http_tmp[4]
				mov	[esi].http_tmp[4],0
			.endif
			mov	[esi].http_tmp,0
			ret
		.endif
	.endif
	.if ([edx].webflags&16)&&(byte ptr[edi+4]&6)&&((!([edx].webflags&2048))||(!(byte ptr[edi+4]&4)))
		push	edi
		push	edx
		lea	edi,[edi+4096]
		lea	edx,httphdr
		call	copyedx
		lea	edx,http200
		call	copyedx
		call	httpwdate
		lea	edx,httpctype
		call	copyedx
		mov	eax,proxy_1_c
		push	ebx
		call	itoa
		pop	ebx
		mov	ax,0a0dh
		stosw
		lea	edx,cachectrl
		call	copyedx
		lea	edx,httpconn
		call	copyedx
		mov	eax,[esp+4]
		mov	eax,[eax+4]
		.if eax&1
			lea	edx,cclose
		.else
			lea	edx,ckeep
		.endif
		push	eax
		call	copyedx
		mov	ax,0a0dh
		stosw
		pop	eax
		.if (!(eax&16))
			lea	edx,proxy_1
			call	copyedx
		.endif
		mov	ecx,edi
		pop	edx
		pop	edi
		push	edi
		lea	edi,[edi+4096]
		sub	ecx,edi
		invoke	asend,edi,ecx
		pop	edi
		mov	eax,[edi+4]
		.if al&1
			call	disconn
		.endif
		.if [esi].http_tmp[4]
			invoke	GlobalFree,[esi].http_tmp[4]
			mov	[esi].http_tmp[4],0
		.endif
		mov	[esi].http_tmp,0
		ret
	.endif
	.if (!([esi]._web&2))
		push	edx
		.if (!([esi]._web&4))&&(byte ptr[edi+4]&6)
			mov	eax,[esi].cs_whois_who_seen.lasttick
			.if (eax==0)||(eax==-1)
				mov	eax,[esi]._ip
			.endif
			push	edi
			push	esi
			mov	esi,hProf
			mov	edi,esi
			xchg	al,ah
			rol	eax,16
			xchg	al,ah
			.while esi!=0
				lea	edi,dword ptr[esi+12]
				.while word ptr[edi]!=0
					.if (word ptr[edi+2]==-1)&&(word ptr[edi+48]!=0)&&(byte ptr[edi+8]==0)&&(byte ptr[edi+128+2+4+4]!=0)
						assume	ecx:ptr usrstruc
						assume	esi:ptr usrstruc
						pop	ecx
						push	ecx
						.if (byte ptr[edi+128+1]==1)
							mov	edx,[edi+128+2]
							xchg	dl,dh
							rol	edx,16
							xchg	dl,dh
							.if eax>=edx
								mov	edx,[edi+128+2+4]
								xchg	dl,dh
								rol	edx,16
								xchg	dl,dh
								.if eax<=edx
									xor	eax,eax
									.break
								.endif
							.endif
						.endif
						assume	ecx:nothing
						assume	esi:nothing
					.endif
					movzx	ecx,word ptr[edi]
					add	edi,ecx
				.endw
				.break .if eax==0
				mov	esi,dword ptr[esi]
			.endw
			pop	esi
			assume	esi:ptr usrstruc
			.if eax==0
				mov	eax,[edi+60]
				and	dword ptr[esi].rights,eax
				mov	eax,[edi+56]
				and	dword ptr[esi+4].rights,eax
			.endif
			pop	edi
		.endif
		pop	edx
		mov	al,[esi].rights
		and	al,7
		.if al!=7
			push	edx
			push	ebx
			plugban2
			pop	ebx
			pop	edx
			assume	edx:ptr web_info
		.else
			xor	eax,eax
		.endif
		.if eax
			or	[esi]._web,4
			push	edi
			push	edx
			lea	edi,[edi+4096]
			lea	edx,httphdr
			call	copyedx
			lea	edx,http200
			call	copyedx
			call	httpwdate
			lea	edx,httpctype
			call	copyedx
			push	edi
			invoke	GlobalAlloc,GPTR,sizeof web_user_info+max_http_header+max_http_header
			push	eax
			assume	eax:ptr web_user_info
			mov	[eax].ptr_usrstruc,esi
			assume	eax:nothing
			lea	edi,[edi+1024]
			lea	ebx,proxy_3
			invoke	httpvars,8192,0,0,eax,0
			call	GlobalFree
			mov	ecx,edi
			pop	edi
			lea	edx,[edi+1024]
			sub	ecx,edx
			mov	eax,ecx
			push	edx
			call	itoa
			pop	ebx
			mov	ax,0a0dh
			stosw
		;	lea	edx,cachectrl
		;	call	copyedx
			lea	edx,httpserv
			call	copyedx
			lea	edx,httpconn
			call	copyedx
			mov	eax,[esp+4]
			mov	eax,[eax+4]
			.if eax&1
				lea	edx,cclose
			.else
				lea	edx,ckeep
			.endif
			push	eax
			call	copyedx
			mov	ax,0a0dh
			stosw
			pop	eax
			.if (!(eax&16))
				mov	edx,ebx
				.while ecx
					mov	al,[edx]
					stosb
					inc	edx
					dec	ecx
				.endw
			.endif
			mov	ecx,edi
			pop	edx
			pop	edi
			push	edi
			lea	edi,[edi+4096]
			sub	ecx,edi
			invoke	asend,edi,ecx
			pop	edi
			mov	eax,[edi+4]
			.if al&1
				call	disconn
			.endif
			.if [esi].http_tmp[4]
				invoke	GlobalFree,[esi].http_tmp[4]
				mov	[esi].http_tmp[4],0
			.endif
			mov	[esi].http_tmp,0
			ret
		.else
			or	[esi]._web,2
		.endif
	.endif
	mov	eax,[esi].ipptr
	assume	eax:ptr ip_info
	mov	dword ptr[eax].timer1,0
	mov	dword ptr[eax].timer3,0
	mov	[eax].fcount,0
	assume	eax:nothing
	.if [edx].webopt==0
		push	edi
		push	edx
		lea	edi,[edi+4096]
		lea	edx,httphdr
		call	copyedx
		lea	edx,httpfound
		call	copyedx
		pop	edx
		push	edx
		mov	ecx,edi
		lea	edx,[edx].webredir
		call	copyedx
		mov	ebx,dword ptr[esp+4]
		sub	ebx,1024
		.if (byte ptr[ebx]!='/')||(byte ptr[ebx+1]!=0)
			.if byte ptr[edi-1]!='/'
				mov	al,'/'
				stosb
			.endif
			.if byte ptr[ebx]=='/'
				inc	ebx
			.endif
			.while (byte ptr[ebx]>32)
				mov	al,[ebx]
				stosb
				inc	ebx
			.endw
		.endif
		mov	eax,edi
		sub	eax,ecx
		push	eax
		mov	ax,0a0dh
		stosw
		call	httpwdate
		lea	edx,httpctype
		call	copyedx
		mov	eax,sizeof wredir+sizeof wredir1
		pop	ecx
		lea	eax,[eax+ecx-2]
		push	ebx
		call	itoa
		pop	ebx
		mov	ax,0a0dh
		stosw
		lea	edx,cachectrl
		call	copyedx
		lea	edx,httpconn
		call	copyedx
		mov	eax,[esp+4]
		mov	eax,[eax+4]
		.if eax&1
			lea	edx,cclose
		.else
			lea	edx,ckeep
		.endif
		push	eax
		call	copyedx
		mov	ax,0a0dh
		stosw
		pop	eax
		.if (!(eax&16))
			lea	edx,wredir
			call	copyedx
			pop	edx
			push	edx
			lea	edx,[edx].webredir
			call	copyedx
			mov	ebx,dword ptr[esp+4]
			sub	ebx,1024
			.if (byte ptr[ebx]!='/')||(byte ptr[ebx+1]!=0)
				.if byte ptr[edi-1]!='/'
					mov	al,'/'
					stosb
				.endif
				.while (byte ptr[ebx]>32)
					mov	al,[ebx]
					stosb
					inc	ebx
				.endw
			.endif
			lea	edx,wredir1
			call	copyedx
		.endif
		mov	ecx,edi
		pop	edx
		pop	edi
		push	edi
		lea	edi,[edi+4096]
		sub	ecx,edi
		invoke	asend,edi,ecx
		pop	edi
		mov	eax,[edi+4]
		.if al&1
			call	disconn
		.endif
	.else	;if dword ptr[ebx]!='DAEH'
		push	edx
		mov	eax,[esi].http_tmp
		add	eax,[esi].ovr.bfidx2
		shl	eax,1
		lea	eax,[eax+max_http_header+sizeof web_user_info]
		invoke	GlobalAlloc,GPTR,eax
		pop	edx
		push	edi
		mov	edi,eax
		assume	edi:ptr web_user_info
		mov	[edi].buffer_in,0
		push	edx
		invoke	GlobalAlloc,GPTR,web_min_alloc
		pop	edx
		mov	[edi].buffer_out,eax
		mov	[edi].buffer_out_size,web_min_alloc
		mov	[edi].ptr_web_info,edx
		mov	[edi].ptr_usrstruc,esi
		push	edi
		push	edx
		mov	edx,dword ptr [esi].cs_whois_who_seen.flcnt1
		lea	edi,[edi]._host
		xor	ecx,ecx
		.if edx
			.while (ecx<511)&&(byte ptr[edx]>32)
				mov	al,[edx]
				stosb
				inc	edx
				inc	ecx
			.endw
		.endif
		mov	al,0
		stosb
		pop	edx
		pop	edi
		pop	ebx
		mov	eax,[ebx+4]
		mov	[edi].proxy_flags,eax
		mov	[edi].newlocation,0
		mov	[edi].newcookies,0
		mov	[edi].cptr,0
		mov	[edi].cptr[4],0
		mov	[edi].cpages,-1
		mov	[edi].cpages[4],-1
		mov	[edi].ptrcomments,-1
		mov	[edi].ptrcomments[4],-1
		mov	byte ptr[edi]._var,0
		.if (al&4)
			mov	eax,[esi].cs_whois_who_seen.lasttick
			.if (eax==0)||(eax==-1)||(al==127)||(ax==168*256+192)||(al==10)||((al==172)&&(ah>=16)&&(ah<=31))||(eax==[esi]._ip)
				xor	eax,eax
				dec	eax
			.endif
		.else
			mov	eax,[esi]._ip
		.endif
		mov	[edi].realip,eax
		lea	edx,[ebx+8]
		push	edi
		lea	edi,[edi].referer
		call	copyedx
		mov	al,0
		stosb
		pop	edi
		lea	edx,[ebx+8+1024]
		push	edi
		lea	edi,[edi].user_agent
		call	copyedx
		pop	edi
		lea	edx,[ebx+8+1024+512]
		push	edi
		lea	edi,[edi].cookies
		call	copyedx
		pop	edi
		push	edi
		mov	edx,[esi].ovr.buffer2
		lea	edx,[edx+4]
		.while byte ptr[edx]==32
			inc	edx
		.endw
		lea	edi,[edi].get_path
		.while (byte ptr[edx]!=0)&&(byte ptr[edx]!='?')&&(byte ptr[edx]!='#')&&(byte ptr[edx]!=' ')&&(byte ptr[edx]!=13)&&(byte ptr[edx]!=10)
			mov	al,[edx]
			stosb
			inc	edx
		.endw
		mov	al,0
		stosb
		.if byte ptr[edx]=='?'
			pop	edi
			push	edi
			inc	edx
			lea	edi,[edi]._var
			.while (byte ptr[edx]!=13)&&(byte ptr[edx]!=10)&&(byte ptr[edx]!=32)
				mov	al,[edx]
				.break .if al==0
				stosb
				inc	edx
				dec	ecx
			.endw
			mov	al,0
			stosb
		.endif
		pop	edi
		push	edi
		.if dword ptr[esi].http_tmp
			lea	edi,[edi]._var
			.if byte ptr[edi]
				.while byte ptr[edi]
					inc	edi
				.endw
				mov	al,'&'
				stosb
			.endif
			push	esi
			push	ecx
			mov	ecx,dword ptr[esi].http_tmp
			.if [esi].http_tmp[4]
				mov	esi,dword ptr[esi+4].http_tmp
			.else
				mov	esi,[esi].ovr.buffer2
				.while (dword ptr[esi]!=0a0d0a0dh)&&(word ptr[esi]!=0a0ah)
					inc	esi
				.endw
				.if dword ptr[esi]==0a0d0a0dh
					lodsd
				.else
					lodsw
				.endif
			.endif
			rep	movsb
			mov	al,0
			stosb
			pop	ecx
			pop	esi
		.endif
		pop	edi
		push	edi
		lea	edx,[edi]._var
		mov	edi,edx
		.while byte ptr[edx]
			mov	al,[edx]
			.if al=='%'
				.if byte ptr[edx+1]!=0
					mov	ah,[edx+1]
					.if ah>='a'
						sub	ah,32
					.endif
					.if ah>'9'
						sub	ah,7
					.endif
					sub	ah,48
					.if ah<16
						mov	al,ah
						inc	edx
						.if byte ptr[edx+1]
							mov	ah,[edx+1]
							.if ah>='a'
								sub	ah,32
							.endif
							.if ah>'9'
								sub	ah,7
							.endif
							sub	ah,48
							.if ah<16
								inc	edx
								shl	al,4
								or	al,ah
								.if al=='+'
									xor	ecx,ecx
									.while byte ptr[edx+ecx]
										inc	ecx
									.endw
									.while ecx
										mov	al,[edx+ecx]
										mov	[edx+ecx+2],al
										dec	ecx
									.endw
									mov	eax,'34#&'
									stosd
									mov	al,';'
									stosb
									inc	edx
									inc	edx
								.elseif al=='&'
									xor	ecx,ecx
									.while byte ptr[edx+ecx]
										inc	ecx
									.endw
									.while ecx
										mov	al,[edx+ecx]
										mov	[edx+ecx+2],al
										dec	ecx
									.endw
									mov	eax,'pma&'
									stosd
									mov	al,';'
									stosb
									inc	edx
									inc	edx
								.elseif al
									stosb
								.else
									mov	al,32
									stosb
								.endif
							.else
								.if al
									stosb
								.else
									mov	al,32
									stosb
								.endif
							.endif
						.else
							.if al
								stosb
							.else
								mov	al,32
								stosb
							.endif
						.endif
					.else
						stosb
					.endif
				.else
					stosb
				.endif
			.else
				stosb
			.endif
			inc	edx
		.endw
		mov	al,0
		stosb
		pop	edi
		mov	[edi].buffer_in,0
		invoke	CreateThread,0,0,addr serveThread,edi,0,addr [edi].hThread
		mov	[edi].hThread,eax
		assume	edx:nothing
		assume	edi:nothing
	.endif
	.if [esi].http_tmp[4]
		invoke	GlobalFree,[esi].http_tmp[4]
		mov	[esi].http_tmp[4],0
	.endif
	mov	[esi].http_tmp,0
	ret

assume	edi:ptr web_user_info

lform	db	'<HTML><HEAD><TITLE>Login</TITLE></HEAD><BODY bgColor=#000000 text=#FFFFFF link=#FFFFCC onload="document.login.user.focus();"><CENTER><H1>'
	db	'Enter your login information</H1><P><FORM name="login" method="POST"><TABLE><TR><TD><TABLE><TR><TD align="right">Username:</TD><TD align=left>'
	db	'<INPUT type="text" name="user" size="25" maxlength="40" title="Username" value="',0
lform1	db	'" /></TD></TR><TR><TD align="right">Password:</TD>'
	db	'<TD align=left><INPUT type="password" name="pass" size="25" maxlength="40" title="Password" value="" /></TD></TR></TABLE></TD></TR><TR>'
	db	'<TD align="center"><INPUT type="submit" name="login" value="Log in"></TD></TR></FORM></CENTER></BODY></HTML>',0
rform	db	'<HTML><HEAD><TITLE>Register</TITLE></HEAD><BODY bgColor=#000000 text=#FFFFFF link=#FFFFCC onload="document.login.user.focus();"><CENTER>'
	db	'<H1>Enter your account information</H1><P><FORM name="login" method="POST"><TABLE><TR><TD><TABLE><TR><TD align="right">Username:</TD><TD align=left>'
	db	'<INPUT type="text" name="user" size="25" maxlength="40" title="Username" value="',0
rform1	db	'" /></TD></TR><TR><TD align="right">Password:</TD><TD align=left><INPUT type="password" name="pass" size="25" maxlength="40" title="Password" value="" />'
	db	'</TD></TR><TR><TD align="right">Re-enter password:</TD><TD align=left><INPUT type="password" name="repass" size="25" maxlength="40" title="Password" value="" /></TD></TR>',0
rform1_	db	'</TABLE></TD></TR><TR><TD align="center"><INPUT type="submit" name="login" value="Register"></TD></TR></FORM></CENTER></BODY></HTML>',0
sigtxt1	db	'<TR><TD colspan="2" align="center"><BR><HR><BR></TD></TR><TR><TD align="right" valign="top">Your signature:'
	db	'</TD><TD align=left><INPUT type="text" name="reason" size="25" maxlength="220" title="Signature" value="',0
sigtxt2	db	'" /><BR><SMALL>220 characters, BBCode is allowed<BR><BR></SMALL></TD></TR>'
	db	'<TR><TD align="right">Language:</TD><TD align="left"><SELECT name="lang" style="width:170;">',0
sigopt	db	'<OPTION value="',0
sigopt1	db	' </OPTION>',0
sigtxt3	db	'</SELECT></TD></TR><TR><TD><BR>&nbsp;</TD><TD></TD></TR>',0
cform	db	'<HTML><HEAD><TITLE>Your Account</TITLE></HEAD><BODY bgColor=#000000 text=#FFFFFF link=#FFFFCC onload="document.login.user.focus();"><CENTER>'
	db	'<H1>Your Account</H1><P><FORM name="login" method="POST"><TABLE><TR><TD><TABLE><TR><TD align="right">Old password:</TD><TD align=left>'
	db	'<INPUT type="password" name="oldpass" size="25" maxlength="40" title="Old Password" value="'
	db	'" /></TD></TR><TR><TD align="right">New Password:</TD><TD align=left><INPUT type="password" name="pass" size="25" maxlength="40" title="New Password" value="" />'
	db	'</TD></TR><TR><TD align="right">Re-enter password:</TD><TD align=left><INPUT type="password" name="repass" size="25" maxlength="40" title="New Password" value="" />'
	db	'</TD></TR>',0
cform1	db	'</TABLE></TD></TR><TR><TD align="center"><INPUT type="submit" name="login" value="Change"></TD></TR></FORM></CENTER></BODY></HTML>',0
pwderr0	db	'<HTML><HEAD><TITLE>Insufficient rights</TITLE><META http-equiv="Refresh" content="5; URL=/"></HEAD><BODY bgColor=#000000 text=#FFFFFF link=#FFFFCC>'
	db	'<TABLE width="100%" height="100%"><TR><TD align="center" valign="center"><H1>Your profile settings do not allow this operation to be completed.</H1></TD></TR>'
	db	'</TABLE></BODY></HTML>',0
pwderr1	db	'<HTML><HEAD><TITLE>Insufficient rights</TITLE><META http-equiv="Refresh" content="5; URL=/"></HEAD><BODY bgColor=#000000 text=#FFFFFF link=#FFFFCC>'
	db	'<TABLE width="100%" height="100%"><TR><TD align="center" valign="center"><H1>Your profile settings do not allow self registrations.</H1></TD></TR>'
	db	'</TABLE></BODY></HTML>',0
pwderr2	db	'<HTML><HEAD><TITLE>Not registered</TITLE><META http-equiv="Refresh" content="5; URL=/"></HEAD><BODY bgColor=#000000 text=#FFFFFF link=#FFFFCC>'
	db	'<TABLE width="100%" height="100%"><TR><TD align="center" valign="center"><H1>Your nickname is not registered or it was registered by somebody else. Be sure you have a valid account before trying to log in.</H1></TD></TR>'
	db	'</TABLE></BODY></HTML>',0
pwderr3	db	'<HTML><HEAD><TITLE>Invalid Password</TITLE><META http-equiv="Refresh" content="5; URL=/"></HEAD><BODY bgColor=#000000 text=#FFFFFF link=#FFFFCC>'
	db	'<TABLE width="100%" height="100%"><TR><TD align="center" valign="center"><H1>Invalid password.</H1></TD></TR>'
	db	'</TABLE></BODY></HTML>',0
pwderr3a db	'<HTML><HEAD><TITLE>Invalid Password</TITLE><META http-equiv="Refresh" content="5; URL=/"></HEAD><BODY bgColor=#000000 text=#FFFFFF link=#FFFFCC>'
	db	'<TABLE width="100%" height="100%"><TR><TD align="center" valign="center"><H1>Your profile settings disallow using a weak password. Choose a better password and try again.</H1></TD></TR>'
	db	'</TABLE></BODY></HTML>',0
pwderr4	db	'<HTML><HEAD><TITLE>Too many requests</TITLE></HEAD><BODY bgColor=#000000 text=#ffffff><H1><CENTER>Too many requests</CENTER><P></H1><FONT face="Arial" size="4">'
	db	'<SMALL><LI>The server is currently busy serving other requests.</LI><LI>Please wait <B id="seconds">%</B>',13,10,'<SCRIPT LANGUAGE="JavaScript"><!--',13,10
	db	9,'var i=%;',13,10,9,'function wait()',13,10,9,'{',13,10,9,9,'if(i) window.setTimeout(',39,'wait()',39,',1000);',13,10,9,9,'else self.location.reload();',13,10
	db	9,9,'document.all.seconds.innerHTML=i--;',13,10,9,'}',13,10,9,'wait();',13,10,'//-->',13,10,'</SCRIPT>',13,10,'seconds before refreshing this page.</LI></SMALL></FONT></BODY></HTML>',0
errnick	db	'<HTML><HEAD><TITLE>Error in nickname</TITLE><META http-equiv="Refresh" content="5; URL=/"></HEAD><BODY bgColor=#000000 text=#FFFFFF link=#FFFFCC>'
	db	'<TABLE width="100%" height="100%"><TR><TD align="center" valign="center"><H1>Your nickname contains invalid characters.</H1></TD></TR>'
	db	'</TABLE></BODY></HTML>',0
blist1	db	'<HTML><HEAD><TITLE>Banlist</TITLE></HEAD><BODY bgColor=#000000 text=#ffffff><H1><CENTER>Banlist</CENTER></H1><P><CENTER><TABLE width="90%" cellspacing="1">'
	db	'<TR><TH align="center" bgcolor="#808080">Pos.</TH><TH align="center" bgcolor="#808080">Level</TH><TH align="center" bgcolor="#808080">ID</TH><TH align="center" bgcolor="#808080">'
	db	'Remaining time</TH><TH align="center" bgcolor="#808080">Target</TH><TH align="center" bgcolor="#808080">Operator and Reason</TH><TH align="center" bgcolor="#808080">Unban</TH></TR>',0
blist2	db	'<BR><BR><FORM method="POST"><INPUT type="text" name="target" size="25" maxlength="40" title="Nick or IP" value="" />&nbsp;<INPUT type="submit" name="ban" value="Ban">'
blist2a	db	'</CENTER></BODY></HTML>',0
blist3	db	'<A href="/bans?start=',0
blist4	db	'&target=_id_',0
blist5	db	'">Unban</A></TD></TR>',0
blist6	db	'">Previous page</A>',0
blist7	db	'">Next page</A>',0
ctrl_l1	db	'<SELECT name=lang>',0
ctrl_l2	db	'</SELECT>',0
ctrl_l3	db	'<OPTION value="',0
ctrl_l4	db	' selected',0
_lang_	db	'lang',0
_reason_ db	'reason',0
_ret_	db	'return',0
_nick_	db	'nick',0
_comment_ db	'comment',0
_pcomment_ db	'postcomment',0
_pcomm_ db	'post',0
_dcomment_ db	'cdelete',0
_title_	db	'title',0
_sep_	db	'separator',0
_user_	db	'user',0
_pass_	db	'pass',0
_repass_ db	'repass',0
_lastuser_ db	'lastuser',0
_login_	db	'login',0
_start_	db	'start',0
_target_ db	'target',0
_oldpass_ db	'oldpass',0
_cpage_	db	'cpage',0
defret	db	'/',0

updlang	PROC	uses esi ebx ecx
	lea	ebx,_lang_
	call	getvar
	.if (eax!=0)&&(byte ptr[edx]=='=')
		lea	ebx,[edx+1]
		push	edi
		call	findlang
		pop	edi
		mov	edx,esi
		mov	esi,[edi].ptr_usrstruc
		.if eax
			mov	ebx,edx
			sub	ebx,langptr
			mov	eax,[esi].ipptr
			assume	eax:ptr ip_info
			mov	[eax].langtmp,bl
			assume	eax:nothing
			mov	eax,ebx
			mov	ebx,langptr
			mov	eax,[ebx+eax]
			mov	[esi].lptr,eax
			.if ([esi].userid!=0)&&([esi].profptr!=0)
				push	edi
				mov	edi,[esi].profptr
					mov	eax,dword ptr[esi].lptr
					mov	eax,[eax+87*4]
					mov	ax,word ptr[eax]
					mov	word ptr[edi+84],ax
					call	updaccount
				pop	edi
			.endif
		.endif
	.endif
	lea	ebx,_reason_
	call	getvar
	.if (eax!=0)&&(byte ptr[edx]=='=')
		lea	ebx,[edx+1]
		mov	esi,[edi].ptr_usrstruc
		.if ([esi].userid!=0)&&([esi].profptr!=0)
			push	edi
			mov	edi,[esi].profptr
				push	edi
				lea	edi,[edi+328]
				mov	ecx,219
				.while (byte ptr[ebx]!=0)&&(ecx!=0)
					mov	al,[ebx]
					.if (al=='&')
						.if (dword ptr[ebx+1]!=';pma')&&(byte ptr[ebx+1]!='#')
							.break
						.endif
						.if dword ptr[ebx+1]==';pma'
							lea	ebx,[ebx+4]
						.else
							push	esi
							lea	esi,[ebx+2]
							call	atoi
							dec	esi
							mov	ebx,esi
							.if byte ptr[ebx]!=';'
								dec	ebx
							.endif
							.if al=='|'
								mov	al,''
							.elseif al=='$'
								mov	al,''
							.endif
							pop	esi
						.endif
					.elseif al=='+'
						mov	al,32
					.endif
					stosb
					inc	ebx
					dec	ecx
				.endw
				mov	al,0
				stosb
				pop	edi
				call	updaccount
			pop	edi
		.endif
	.endif
	ret
updlang	ENDP

getvar:	lea	edx,[edi]._var
	xor	ecx,ecx
	xor	eax,eax
	.while byte ptr[edx]
		.while (byte ptr[edx]==32)||(byte ptr[edx]=='&')
			inc	edx
		.endw
		xor	ecx,ecx
		.while (byte ptr[ebx+ecx]!=0)
			mov	al,[ebx+ecx]
			.if (al>='A')&&(al<='Z')
				or	al,20h
			.endif
			mov	ah,[edx]
			.if (ah>='A')&&(ah<='Z')
				or	ah,20h
			.endif
			.break .if al!=ah
			inc	ecx
			inc	edx
		.endw
		xor	eax,eax
		.if (byte ptr[ebx+ecx]==0)&&((byte ptr[edx]=='=')||(byte ptr[edx]<33)||(byte ptr[edx]=='&'))
			inc	eax
			ret
		.endif
		.while (byte ptr[edx]!='&')&&(byte ptr[edx]!=0)
			inc	edx
		.endw
	.endw
	xor	eax,eax
	ret

;edx=offset cookies
;ebx=search
getcookie:
	xor	ecx,ecx
	xor	eax,eax
	.while byte ptr[edx]
		.while (byte ptr[edx]==32)||(byte ptr[edx]==';')
			inc	edx
		.endw
		xor	ecx,ecx
		.while (byte ptr[ebx+ecx]!=0)
			mov	al,[ebx+ecx]
			.if (al>='A')&&(al<='Z')
				or	al,20h
			.endif
			mov	ah,[edx]
			.if (ah>='A')&&(ah<='Z')
				or	ah,20h
			.endif
			.break .if al!=ah
			inc	ecx
			inc	edx
		.endw
		xor	eax,eax
		.if (byte ptr[ebx+ecx]==0)&&((byte ptr[edx]=='=')||(byte ptr[edx]<33)||(byte ptr[edx]==';'))
			inc	eax
			ret
		.endif
		.while (byte ptr[edx]!=';')&&(byte ptr[edx]!=0)
			inc	edx
		.endw
	.endw
	xor	eax,eax
	ret

;edi,edx
wcpage:	push	edi
	push	ebx
	mov	edi,edx
	lea	ebx,_cpage_
	call	getvar
	pop	ebx
	.if eax
		.while (byte ptr[edx]=='=')||(byte ptr[edx]==32)
			inc	edx
		.endw
		push	esi
		push	ebx
		mov	esi,edx
		call	atoi
		pop	ebx
		pop	esi
	.endif
	pop	edi
	call	itoa
	ret

_return_:
;	lea	ebx,_ret_
;	call	getvar
	.if [edi].referer==0
		lea	edx,defret
	.else
		lea	edx,[edi].referer
		lea	ecx,[edi].get_path
		.if byte ptr[ecx]=='/'
			inc	ecx
		.endif
		mov	eax,[edx]
		or	eax,20202020h
		.if (eax=='ptth')&&(word ptr[edx+4]=='/:')&&(byte ptr[edx+6]=='/')
			lea	edx,[edx+7]
		.endif
		.while (byte ptr[edx]!=0)&&(byte ptr[edx]!='/')&&(byte ptr[edx]!='\')
			inc	edx
		.endw
		.if byte ptr[edx]
			inc	edx
		.endif
		.while (byte ptr[edx]!=0)&&(byte ptr[edx]!='?')&&(byte ptr[edx]!='#')&&(byte ptr[edx]!='&')
			mov	al,[edx]
			.break .if al!=[ecx]
			inc	edx
			inc	ecx
		.endw
		.if ((byte ptr[edx]==0)||(byte ptr[edx]=='?')||(byte ptr[edx]=='#')||(byte ptr[edx]=='&'))&&((byte ptr[ecx]==0)||(byte ptr[ecx]=='#')||(byte ptr[ecx]=='?')||(byte ptr[ecx]=='&'))
			lea	edx,defret
		.else
			lea	edx,[edi].referer
		.endif
	.endif
	xor	eax,eax
	.while (byte ptr[edx+eax]!=0)&&(byte ptr[edx+eax]!='&')
		.if (word ptr[edx+eax]=='3%')||(byte ptr[edx+eax]=='"')||(byte ptr[edx+eax]==39)||(byte ptr[edx+eax]=='<')||(byte ptr[edx+eax]=='>')
			ret
		.endif
		inc	eax
	.endw
	mov	ebx,edx
	push	edi
	mov	edi,dword ptr[edi].buffer_out
	lea	edx,httphdr
	call	copyedx
	lea	edx,httpfound
	call	copyedx
	mov	ecx,edi
	xor	edx,edx
	.while (byte ptr[ebx+edx]!=0)&&(byte ptr[ebx+edx]!='&')&&(edx<256)
		mov	al,[ebx+edx]
		stosb
		inc	edx
	.endw
	mov	eax,edi
	sub	eax,ecx
	push	eax
	mov	ax,0a0dh
	stosw
	push	ebx
	call	httpwdate
	mov	edx,[esp+4+4]
	assume	edx:ptr web_user_info
	.if [edx].newcookies
		mov	edx,dword ptr[edx].newcookies
		assume	edx:nothing
		.while byte ptr[edx]
			.while (byte ptr[edx]==13)||(byte ptr[edx]==10)||(byte ptr[edx]==32)||(byte ptr[edx]==9)
				inc	edx
			.endw
			.if byte ptr[edx]
				mov	eax,'-teS'
				stosd
				mov	eax,'kooC'
				stosd
				mov	eax,' :ei'
				stosd
				mov	ah,0
				.while (byte ptr[edx]>31)
					mov	al,[edx]
					.if al=='='
						mov	ah,1
					.endif
					stosb
					inc	edx
				.endw
				.if ah==0
					push	edx
					lea	edx,cookiex
					call	copyedx
					pop	edx
				.endif
				mov	ax,0a0dh
				stosw
			.endif
		.endw
	.endif
	assume	edx:nothing
	lea	edx,httpctype
	call	copyedx
	mov	eax,sizeof wredir+sizeof wredir1
	pop	ebx
	pop	ecx
	push	ebx
	lea	eax,[eax+ecx-2]
	call	itoa
	pop	ebx
	mov	ax,0a0dh
	stosw
	lea	edx,cachectrl
	call	copyedx
	lea	edx,httpconn
	call	copyedx
	pop	ecx
	push	ecx
	assume	ecx:ptr web_user_info
	mov	eax,[ecx].proxy_flags
	assume	ecx:nothing
	.if eax&1
		lea	edx,cclose
	.else
		lea	edx,ckeep
	.endif
	call	copyedx
	mov	ax,0a0dh
	stosw
	mov	edx,[esp]
	assume	edx:ptr web_user_info
	mov	eax,[edx].proxy_flags
	assume	edx:nothing
	.if (!(eax&16))
		lea	edx,wredir
		call	copyedx
		xor	edx,edx
		.while (byte ptr[ebx+edx]!=0)&&(byte ptr[ebx+edx]!='&')&&(edx<256)
			mov	al,[ebx+edx]
			stosb
			inc	edx
		.endw
		lea	edx,wredir1
		call	copyedx
	.endif
	mov	ecx,edi
	pop	edi
	push	edi
	sub	ecx,dword ptr[edi].buffer_out
	mov	esi,[edi].ptr_usrstruc
	invoke	asend,dword ptr[edi].buffer_out,ecx
	pop	edi
	ret

;edi=web_user_info
;ecx=buffer+size
httpsend:
	push	ecx
	push	edi
	mov	edi,ecx
	mov	al,0
	stosb
	lea	edx,httphdr
	call	copyedx
	lea	edx,http200
	call	copyedx
	push	ecx
	call	httpwdate
	pop	ecx
	lea	edx,httpctype
	call	copyedx
	pop	eax
	push	eax
	assume	eax:ptr web_user_info
	mov	edx,dword ptr[eax].buffer_out
	assume	eax:nothing
	mov	eax,[esp+4]
	sub	eax,edx
	call	itoa
	mov	ax,0a0dh
	stosw
	lea	edx,cachectrl
	call	copyedx
	lea	edx,httpconn
	call	copyedx
	pop	ecx
	push	ecx
	assume	ecx:ptr web_user_info
	mov	eax,[ecx].proxy_flags
	mov	esi,[ecx].ptr_usrstruc
	assume	ecx:nothing
	.if eax&1
		lea	edx,cclose
	.else
		lea	edx,ckeep
	.endif
	push	eax
	call	copyedx
	mov	ax,0a0dh
	stosw
	pop	eax
	.if (!(eax&16))
		mov	edx,[esp]
		assume	edx:ptr web_user_info
		mov	edx,dword ptr[edx].buffer_out
		assume	edx:nothing
		call	copyedx
	.endif
	mov	ecx,edi
	mov	edi,[esp+4]
	inc	edi
	sub	ecx,edi
	invoke	asend,edi,ecx
	pop	edi
	mov	eax,[edi].proxy_flags
	.if al&1
		call	disconn
	.endif
	pop	ecx
	ret

cexp	db	'; expires=Thu, 31-Dec-2099 00:00:00 GMT',0
wpath:	push	eax
	mov	eax,'ap ;'
	stosd
	mov	eax,'/=ht'
	stosd
	mov	eax,'od ;'
	stosd
	mov	eax,'niam'
	stosd
	mov	ax,'.='
	stosw
	mov	eax,[esp]
	assume	eax:ptr web_user_info
	lea	edx,[eax]._host
	.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=':')
		mov	al,[edx]
		stosb
		inc	edx
	.endw
	lea	edx,cexp
	call	copyedx
	assume	eax:nothing
	mov	al,0
	stosb
	pop	eax
	ret

_login:	mov	esi,[edi].ptr_usrstruc
	lea	ebx,_user_
	lea	edx,[edi].cookies
	call	getcookie
	.if eax
		.if byte ptr[edx]=='='
			inc	edx
			mov	esi,[edi].ptr_usrstruc
			push	edi
			push	edx
			getbuffer
			pop	edx
			xor	ecx,ecx
			.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=';')&&(ecx<39)
				mov	al,[edx]
				.if al=='&'
					.if byte ptr[edx]=='#'
						push	esi
						lea	esi,[edx+2]
						call	atoi
						lea	edx,[esi-1]
						.if al=='|'
							mov	al,''
						.elseif al=='$'
							mov	al,''
						.endif
						pop	esi
						stosb
					.endif
				.elseif (al==39)||(al==34)||(al=='<')||(al=='>')
					mov	al,'_'
					stosb
				.elseif al=='%'
					inc	edx
					mov	ax,[edx]
					inc	edx
					.if al>'Z'
						sub	al,32
					.endif
					.if ah>'Z'
						sub	ah,32
					.endif
					.if al>'9'
						sub	al,7
					.endif
					.if ah>'9'
						sub	ah,7
					.endif
					sub	al,30h
					sub	ah,30h
					shl	al,4
					or	al,ah
					.if al=='|'
						mov	al,''
					.elseif al=='$'
						mov	al,''
					.endif
					stosb
				.else
					stosb
				.endif
				inc	edx
			.endw
			mov	ax,'|'
			stosw
			getbuffer
			mov	ebx,edi
			call	f_profile
			.if (edi!=-1)&&(edi!=-2)
				mov	eax,[esi]._ip
				lea	ebx,[edi+88]
				.if byte ptr[edi+88]==1
					xor	eax,[ebx+1]
				.else
					.while byte ptr[ebx]
						rol	eax,1
						add	al,[ebx]
						inc	ebx
					.endw
					xor	eax,[esi]._ip
				.endif
				push	eax
				push	edi
				mov	edi,[esp+8]
				lea	ebx,_login_
				lea	edx,[edi].cookies
				call	getcookie
				pop	ebx
				pop	ecx
				.if (eax!=0)&&(byte ptr[edx]=='=')
					inc	edx
					push	esi
					mov	esi,edx
					push	ecx
					push	ebx
					call	atoi
					pop	edx
					pop	ecx
					pop	esi
					.if eax==ecx
						push	edx
						getbuffer
						pop	edx
						mov	ecx,edi
						mov	edi,edx
						push	edi
						mov	edx,ecx
						lea	edi,[esi]._name
						xor	ecx,ecx
						.while (byte ptr[edx]!=0)&&(byte ptr[edx]!='|')
							mov	al,[edx]
							stosb
							inc	edx
							inc	ecx
							.break .if ecx>38
						.endw
						mov	al,0
						stosb
						lea	edi,[esi].req_name
						lea	edx,[esi]._name
						call	copyedx
						mov	al,0
						stosb
						pop	edi
						mov	[esi].profptr,edi
						mov	ax,word ptr[edi+48]
						mov	[esi].profileid,ax
						mov	eax,dword ptr[edi+52]
						mov	[esi].userid,eax
						mov	eax,dword ptr[edi+56]
						mov	dword ptr[esi+4].rights,eax
						mov	eax,dword ptr[edi+60]
						mov	dword ptr[esi].rights,eax
						mov	eax,dword ptr[edi+64]
						mov	[esi].access,eax
						mov	eax,dword ptr[edi+68]
						mov	[esi+4].access,eax
						mov	eax,dword ptr[edi+72]
						mov	[esi+8].access,eax
						mov	eax,dword ptr[edi+278]
						mov	[esi+12].access,eax
						mov	al,byte ptr[edi+278+4]
						mov	[esi].accflag,al
						mov	ax,word ptr[edi+86]
						mov	[esi].modifier,ax
						lea	ebx,dword ptr[edi+84]
						call	_lang
					.endif
				.endif
			.endif
			pop	edi
		.endif
	.endif
	ret


serveThread	PROC	lParam:DWORD
	local	fsize:DWORD,hdr:DWORD,htsocket:DWORD,bsent:DWORD,lasthm:DWORD,dcconv:DWORD
	mov	edi,lParam
	assume	edx:ptr web_info
	mov	edi,lParam
	mov	hdr,0
	mov	bsent,0
	lea	edx,[edi].get_path
	push	edi
	mov	edi,edx
	.while (byte ptr[edx]!=0)
		mov	al,[edx]
		.if al=='%'
			mov	ah,[edx+1]
			.if ((ah<='9')&&(ah>='0'))||((ah<='F')&&(ah>='A'))||((ah<='f')&&(ah>='a'))
				mov	ah,[edx+2]
				.if ((ah<='9')&&(ah>='0'))||((ah<='F')&&(ah>='A'))||((ah<='f')&&(ah>='a'))
					inc	edx
					mov	al,[edx]
					.if al>'Z'
						sub	al,32
					.endif
					.if al>'9'
						sub	al,7
					.endif
					sub	al,'0'
					inc	edx
					mov	ah,[edx]
					.if ah>'Z'
						sub	ah,32
					.endif
					.if ah>'9'
						sub	ah,7
					.endif
					sub	ah,'0'
					shl	al,4
					or	al,ah
					stosb
				.else
					stosb
				.endif
			.else
				stosb
			.endif
		.else
			stosb
		.endif
		inc	edx
	.endw
	mov	al,0
	stosb
	pop	edi

	lea	edx,[edi].get_path
	call	fix_path
	mov	edx,[edi].ptr_web_info
	mov	eax,[edx].webflags
	mov	dcconv,eax
	.if (!([edx].webflags&1024))
		mov	ecx,hPlugins
		.while ecx
			assume	ecx:ptr pluginInfo
			.if ([ecx].pluginStatus==1)&&([ecx]._onhttp4!=0)
				lea	edx,[edi].get_path
				.if byte ptr[edx]=='/'
					inc	edx
				.endif
				push	ecx
				lea	ecx,[ecx].dllName
				.while byte ptr[ecx]
					mov	al,byte ptr[ecx]
					mov	ah,byte ptr[edx]
					or	ax,2020h
					.break .if al!=ah
					inc	edx
					inc	ecx
				.endw
				.if (byte ptr[ecx]==0)&&((byte ptr[edx]==0)||(byte ptr[edx]=='?')||(byte ptr[edx]=='/')||(byte ptr[edx]==':'))
					pop	ecx
					push	esi
					push	edi
					push	ecx
					invoke	GlobalAlloc,GPTR,8192
					pop	ecx
					mov	ebx,eax
					push	ebx
					push	ebp
					mov	ebp,esp
					mov	eax,8192
					push	eax
					push	ebx
					lea	eax,[edi]._var
					push	eax
					lea	eax,[edi].cookies
					push	eax
					lea	eax,[edi].user_agent
					push	eax
					lea	eax,[edi].referer
					push	eax
					mov	edx,dword ptr[edi]
					lea	eax,[edi]._host
					push	eax
					lea	eax,[edi].get_path
					push	eax
					mov	esi,[edi].ptr_usrstruc
					push	[esi].sessionId
					call	[ecx]._onhttp4
					.if ebp!=esp
						mov	al,21
						int 3
					.endif
					pop	ebp
					pop	ebx
					pop	edi
					pop	esi
					.if eax==-1
						invoke	GlobalFree,ebx
						jmp	_endt
					.elseif eax==0
						invoke	GlobalFree,ebx
					.else
						mov	esi,[edi].ptr_usrstruc
						mov	[edi].buffer_in,eax
						jmp	_srq
					.endif
					.break
				.endif
				pop	ecx
			.endif
			assume	ecx:nothing
			mov	ecx,dword ptr[ecx]
		.endw
	.endif
	.if (dword ptr[edi].get_path=='nal/')&&(dword ptr[edi+4].get_path=='gaug')&&(word ptr[edi+8].get_path=='e')
		call	_login
		call	updlang
_ret__:		call	_return_
_ret_1:		jmp	_endt
	.elseif (dword ptr[edi].get_path=='per/')&&(dword ptr[edi+4].get_path=='tro')
		call	_login
		mov	esi,dword ptr[edi].ptr_usrstruc
		.if (!([esi+1].rights&_1_chat3))
			jmp	_ret__
		.endif
		.if (!([esi+5].rights&_5_spam2))
			mov	eax,[esi].ipptr
			assume	eax:ptr ip_info
			mov	dl,byte ptr systime.wHour
			mov	dh,byte ptr systime.wMinute
			shl	dh,4
			and	dx,0f00fh
			or	dl,dh
			.if dl==byte ptr[eax].reserved
				lea	edx,pwderr4
				push	edi
				mov	edi,dword ptr[edi].buffer_out
				.while byte ptr[edx]
					mov	al,[edx]
					.if al=='%'
						mov	eax,60
						sub	ax,systime.wSecond
						.if ax>60
							mov	ax,60
						.elseif ax==0
							inc	eax
						.endif
						push	edx
						movzx	eax,al
						call	itoa
						pop	edx
					.else
						stosb
					.endif
					inc	edx
				.endw
				mov	ecx,edi
				pop	edi
				call	httpsend
				jmp	_ret_1
			.else
				mov	byte ptr[eax].reserved,dl
			.endif
			assume	eax:nothing
		.endif
		lea	ebx,_sep_
		call	getvar
		.if eax
			mov	byte ptr[edx-9],0
		.endif
		.if byte ptr[esi]._name==0
			lea	ebx,_nick_
			call	getvar
		.else
			lea	edx,[esi]._name
			jmp	_l_1
		.endif
		.if byte ptr[edx]=='='
			inc	edx
_l_1:			push	edx
			.if [edi].newcookies==0
				push	ebx
				push	edx
				invoke	GlobalAlloc,GPTR,2048
				pop	edx
				pop	ebx
				mov	[edi].newcookies,eax
				mov	byte ptr[eax],0
			.endif
			push	edi
			mov	edi,[edi].newcookies
			xor	ecx,ecx
			.while (ecx<2000)&&(byte ptr[edi]!=0)
				inc	edi
				inc	ecx
			.endw
			mov	eax,'tsal'
			stosd
			mov	eax,'resu'
			stosd
			mov	al,'='
			stosb
			mov	ebx,[esp+4]
			.while (byte ptr[ebx]!=0)&&(byte ptr[ebx]!=']')&&(ecx<100)
				mov	al,[ebx]
				.if al<32
					mov	al,32
				.elseif (al=='&')&&(byte ptr[ebx+1]!='#')
					.break
				.elseif (al==39)||(al==34)||(al=='<')||(al=='>')
					mov	al,'_'
				.endif
				stosb
				inc	ebx
				inc	ecx
			.endw
			mov	ax,0a0dh
			stosw
			mov	al,0
			stosb
			pop	edi
			pop	edx
		.else
			xor	edx,edx
		.endif
		mov	esi,edx
		lea	ebx,_comment_
		call	getvar
		.if byte ptr[edx]=='='
			inc	edx
			.if byte ptr[edx]==0
				xor	edx,edx
			.endif
		.else
			xor	edx,edx
		.endif
		.if edx
			mov	eax,[edi].ptr_web_info
			assume	eax:ptr web_info
			mov	eax,[eax].webflags
			assume	eax:nothing
			mov	ebx,edx
			mov	edx,esi
			push	edi
			mov	esi,dword ptr[edi].ptr_usrstruc
			mov	edi,dword ptr[edi].buffer_out
			call	opc_web
			pop	edi
		.endif
		jmp	_ret__
	.elseif (dword ptr[edi].get_path=='nab/')&&(word ptr[edi+4].get_path=='s')
		call	_login
		mov	esi,[edi].ptr_usrstruc
		.if (!([esi+2].rights&_2_kick3))&&(!([esi+3].rights&_3_kick4))
			push	edi
			lea	edx,pwderr0
			jmp	_ends_
		.endif
		lea	ebx,_target_
		call	getvar
		.if (eax!=0)&&(byte ptr[edx]=='=')
			inc	edx
			push	edi
			mov	edi,[edi].buffer_out
			push	edi
			.while (byte ptr[edx]!=0)
				mov	al,[edx]
				.if al=='&'
					.if byte ptr[edx]=='#'
						lea	esi,[edx+2]
						call	atoi
						lea	edx,[esi-1]
						.if al=='|'
							mov	al,''
						.elseif al=='$'
							mov	al,''
						.endif
						stosb
					.else
						.break
					.endif
				.elseif al=='+'
					mov	al,32
					stosb
				.else
					stosb
				.endif
				inc	edx
			.endw
			mov	word ptr[edi],'|'
			pop	ebx

			push	ebx
			call	findban
			pop	ebx
h_unbanr:		.if (edi!=-1)
				mov	al,byte ptr[edi+60]
				and	al,7
				.if al==7
					pop	edi
					jmp	_ret__
				.endif
				.if (!([esi+3].rights&_3_kick4))
					lea	edx,[esi]._name
					xor	ecx,ecx
					.while byte ptr[edx+ecx]!=0
						mov	al,[edx+ecx]
						mov	ah,byte ptr[edi+ecx+230]
						or	ax,2020h
						.break .if al!=ah
						inc	ecx
					.endw
					.if byte ptr[edi+230+ecx]!=0
						lea	edx,pwderr0
						jmp	_ends_
					.endif
				.endif
				call	_r_unban
				pop	edi
			;	lea	ebx,_start_
			;	call	getvar
			;	.if eax
					jmp	_wbans
			;	.endif
			;	jmp	_ret__
			.else
				push	ebx
				push	esi
				mov	esi,ebx
				push	ebx
				xor	eax,eax
				call	getrange
				pop	ebx
				.if esi!=ebx
					pop	esi
					call	find_i_pro
					pop	ebx
					.if edi!=-1
						jmp	h_unbanr
					.endif
				.else
					pop	esi
					pop	ebx
				.endif
				push	ebx
				push	ebx
				call	findprofile
				.if (edi!=-1)
					pop	eax
					.while (byte ptr[ebx]==32)||(byte ptr[ebx]==9)||(byte ptr[ebx]==13)||(byte ptr[ebx]==10)
						inc	ebx
					.endw
					mov	ecx,[esi].access
					.if dword ptr[edi+64]>=ecx
						pop	eax
						lea	edx,pwderr0
						jmp	_ends_
					.endif
				.else
					pop	ebx
					call	findusr1
					.if (edi!=-1)&&(edi!=offset rbstruc)&&(edi!=offset opchat)
						push	esi
						push	edi
						assume	edi:ptr usrstruc
						mov	eax,[edi]._ip
						assume	edi:ptr web_user_info
						getbuffer
						pop	esi
						call	make_iprofile
						pop	esi
					.else
						getbuffer
						push	esi
						mov	esi,ebx
						push	ebx
						call	getrange
						pop	ebx
						.if esi!=ebx
							mov	edx,esi
							pop	esi
							push	esi
							mov	eax,ecx
							call	make_iprofile
							mov	byte ptr[edi+128+1],1
							pop	esi
						.else
							pop	esi
							push	esi
							call	make_xprofile
							pop	esi
						.endif
					.endif
				.endif
				pop	edx
				.while (byte ptr[edx]!=0)&&(byte ptr[edx]!='+')&&(byte ptr[edx]!=' ')&&(byte ptr[edx]!='|')
					inc	edx
				.endw
				.while (byte ptr[edx]=='+')||(byte ptr[edx]==' ')
					inc	edx
				.endw
				push	edi
				lea	edi,[edi+328]
				mov	ecx,219
				.while (byte ptr[edx]!=0)&&(byte ptr[edx]!='|')&&(ecx!=0)
					mov	al,[edx]
					.if al=='&'
						.if byte ptr[edx]=='#'
							lea	esi,[edx+2]
							call	atoi
							lea	edx,[esi-1]
							.if al=='|'
								mov	al,''
							.elseif al=='$'
								mov	al,''
							.endif
							dec	ecx
							stosb
						.else
							.break
						.endif
					.elseif al=='+'
						mov	al,32
						stosb
						dec	ecx
					.else
						stosb
						dec	ecx
					.endif
					inc	edx
				.endw
				mov	al,0
				stosb
				pop	edi
				mov	dword ptr[edi+76],0
				mov	word ptr[edi+50],1
				mov	ebx,3
				xor	eax,eax
				push	dword ptr[edi+76]
				push	dword ptr[edi+538]
				push	dword ptr[edi+538+4]
				call	setban
				pop	dword ptr[edi+538+4]
				pop	dword ptr[edi+538]
				pop	dword ptr[edi+76]
			.endif
			pop	edi
		.endif
_wbans:		push	edi
		lea	ebx,_start_
		call	getvar
		xor	ecx,ecx
		.if (eax!=0)&&(byte ptr[edx]=='=')
			lea	esi,[edx+1]
			call	atoi
			mov	ecx,eax
		.endif
		push	ebp
		mov	ebp,ecx
		mov	edi,dword ptr[edi].buffer_out
		lea	edx,blist1
		call	copyedx
		mov	esi,hProf
		.if ecx
			.while (esi!=0)
				push	ecx
				lea	edx,[esi+12]
				.while word ptr[edx]!=0
					.if (word ptr[edx+2]==-1)&&(word ptr[edx+48]!=0)
						mov	al,byte ptr[edx+60]
						and	al,7
						.if (al!=7)
							pop	ecx
							dec	ecx
							push	ecx
							.if ecx==0
								pop	eax
								push	ecx
								jmp	hbdisp
							.endif
						.endif
					.endif
					movzx	ecx,word ptr[edx]
					add	edx,ecx
				.endw
				pop	ecx
				mov	esi,dword ptr[esi]
			.endw
		.endif
		xor	ecx,ecx
		.while esi!=0
			push	ecx
			lea	edx,[esi+12]
			.while word ptr[edx]!=0
				.if (word ptr[edx+2]==-1)&&(word ptr[edx+48]!=0)
					mov	al,[edx+60]
					and	al,7
					.if (al!=7)
						pop	ecx
						push	ecx
						push	eax
						mov	eax,'>RT<'
						stosd
						mov	eax,'>DT<'
						stosd
						mov	word ptr[edi],0a0dh
						inc	edi
						inc	edi
						lea	eax,[ecx+ebp]
						push	edx
						call	itoa
						pop	edx
						mov	eax,'DT/<'
						stosd
						mov	al,'>'
						stosb
						mov	eax,'>DT<'
						stosd
						pop	eax
						.if (!(al&1))
							mov	al,0
						.elseif (!(al&2))
							mov	al,1
						.else
							mov	al,2
						.endif
						or	al,30h
						stosb
						mov	eax,'DT/<'
						stosd
						mov	al,'>'
						stosb
						mov	eax,'>DT<'
						stosd
						mov	eax,dword ptr[edx+52]
						push	edx
						call	itoa
						pop	edx
						mov	eax,'DT/<'
						stosd
						mov	al,'>'
						stosb
						mov	eax,'>DT<'
						stosd
						mov	ebx,edx
						push	edx
						.if dword ptr[ebx+76]!=0
							call	bwtime
						.else
							mov	eax,'mreP'
							stosd
							mov	eax,'nena'
							stosd
							mov	ax,900h+'t'
							stosw
						.endif
						mov	eax,'DT/<'
						stosd
						mov	al,'>'
						stosb
						mov	eax,'>DT<'
						stosd
						call	bwusr
						mov	eax,'DT/<'
						stosd
						mov	al,'>'
						stosb
						mov	eax,'>DT<'
						stosd
						mov	eax,';tl&'
						stosd
						lea	edx,[ebx+230]
						invoke	dc_to_web,1
						mov	eax,';tg&'
						stosd
						mov	al,' '
						stosb
						lea	edx,[ebx+328]
						invoke	dc_to_web,1
						mov	eax,'DT/<'
						stosd
						mov	al,'>'
						stosb
						mov	eax,'>DT<'
						stosd
						lea	edx,blist3
						call	copyedx
						mov	eax,ebp
						push	ebx
						call	itoa
						pop	ebx
						lea	edx,blist4
						call	copyedx
						mov	eax,[ebx+52]
						push	edx
						call	itoa
						lea	edx,blist5
						call	copyedx
						pop	edx
						pop	edx
						pop	ecx
						inc	ecx
						push	ecx
						.break .if cx>=maxresults
hbdisp:
					.endif
				.endif
				movzx	ecx,word ptr[edx]
				add	edx,ecx
			.endw
			pop	ecx
			xor	edx,edx
			.if cx>=maxresults
				inc	edx
				.break
			.endif
			mov	esi,dword ptr[esi]
		.endw
		mov	eax,'AT/<'
		stosd
		mov	eax,'>ELB'
		stosd
		.if (edx!=0)||(ebp!=0)
			mov	eax,'>RB<'
			stosd
			.if ebp
				push	edx
				lea	edx,blist3
				call	copyedx
				mov	eax,ebp
				.if ax<=maxresults
					xor	eax,eax
				.else
					sub	ax,maxresults
				.endif
				movzx	eax,ax
				call	itoa
				lea	edx,blist6
				call	copyedx
				pop	edx
				.if edx
					mov	eax,'sbn&'
					stosd
					mov	eax,'n&;p'
					stosd
					mov	eax,';psb'
					stosd
				.endif
			.endif
			.if edx
				lea	edx,blist3
				call	copyedx
				mov	eax,ebp
				add	ax,maxresults
				movzx	eax,ax
				call	itoa
				lea	edx,blist7
				call	copyedx
			.endif
		.endif
		pop	ebp
		lea	edx,blist2
		call	copyedx
		mov	ecx,edi
		pop	edi
		call	httpsend
		jmp	_ret_1
	.elseif (dword ptr[edi].get_path=='gol/')&&(word ptr[edi+4].get_path=='ni')&&(byte ptr[edi+6].get_path==0)
		lea	ebx,_user_
		call	getvar
		.if eax==0
			lea	ebx,_oldpass_
			call	getvar
			.if eax
				.if byte ptr[edx]!='='
					mov	byte ptr[edx-1],'.'
					push	edx
					lea	ebx,_oldpass_
					call	getvar
					.if eax
						pop	eax
					.else
						pop	edx
					.endif
				.endif
				.if byte ptr[edx]=='='
					inc	edx
					mov	esi,[edi].ptr_usrstruc
					push	edx
					call	_login
					call	updlang
					pop	edx
					mov	esi,[esi].profptr
					.if esi==0
						jmp	_rep
					.endif
					push	edi
					push	edx
					call	chkpass
					.if eax==0
						pop	eax
						.if byte ptr[eax]=='&'
							pop	edi
							jmp	_ret__
						.endif
						push	eax
						jmp	_n_pass
					.endif
					pop	eax
					pop	edi
					lea	ebx,_repass_
					call	getvar
					.if eax
						push	edi
						mov	esi,[edi].ptr_usrstruc
						.if (byte ptr[edx]!='=')||((byte ptr[edx+1]==0)||(dword ptr[edx+1]=='sap&')||(dword ptr[edx+1]=='per&')||(dword ptr[edx+1]=='ter&')||(dword ptr[edx+1]=='gol&'))
							jmp	_rp_s
						.elseif (dword ptr[edx+1]=='esu&')||(dword ptr[edx+1]=='aer&')||(dword ptr[edx+1]=='nal&')
_rp_s:							mov	byte ptr[edx-1],'='
							lea	ebx,_repass_
							call	getvar
						.endif
						push	edx
						lea	ebx,_pass_
						call	getvar
						.if byte ptr[edx]=='='
							inc	edx
						.endif
						pop	ebx
						.if byte ptr[ebx]=='='
							inc	ebx
						.endif
						push	ebx
						mov	ecx,ebx
						.while (byte ptr[edx]!=0)&&(dword ptr[edx]!='sap&')&&(dword ptr[edx]!='per&')&&(dword ptr[edx]!='ter&')&&(dword ptr[edx]!='gol&')&&(dword ptr[edx]!='aer&')&&(dword ptr[edx]!='nal&')
							mov	al,byte ptr[ebx]
							.break .if al!=byte ptr[edx]
							inc	ebx
							inc	edx
						.endw
						.if ((byte ptr[edx]==0)||(dword ptr[edx]=='per&')||(dword ptr[edx]=='ter&')||(dword ptr[edx]=='gol&')||(dword ptr[edx]=='aer&')||(dword ptr[edx]=='nal&'))
							.if ((byte ptr[ebx]==0)||(dword ptr[ebx]=='sap&')||(dword ptr[ebx]=='ter&')||(dword ptr[ebx]=='gol&')||(dword ptr[ebx]=='aer&')||(dword ptr[ebx]=='nal&'))
							.else
								pop	eax
								lea	edx,pwderr3
								jmp	_ends_
							.endif
						.else
							pop	eax
							lea	edx,pwderr3
							jmp	_ends_
						.endif
						mov	edi,[esi].profptr
						call	updaccount
						lea	edi,[edi+88]
						mov	eax,[esi].access
						pop	ebx
						xor	ecx,ecx
						.while 1
							.if ((byte ptr[ebx+ecx]==0)||(dword ptr[ebx+ecx]=='sap&')||(dword ptr[ebx+ecx]=='ter&')||(dword ptr[ebx+ecx]=='gol&')||(dword ptr[ebx+ecx]=='aer&')||(dword ptr[ebx+ecx]=='nal&'))
								mov	word ptr[ebx+ecx],'|'
								.break
							.endif
							inc	ecx
						.endw
						.if (s_mypass.cmdflag&32)&&(eax>=s_getinfo.cmdparam1)
							call	isbadpass
							.if eax
								mov	byte ptr[edi],1
								mov	dword ptr[edi+1],eax
								mov	byte ptr[edi+5],0
							.else
								lea	edx,pwderr3a
								jmp	_ends_
							.endif
						.else
							xor	ecx,ecx
							.while (byte ptr[ebx+ecx]!='|')&&(byte ptr[ebx+ecx]!=32)&&(ecx<38)
								inc	ecx
							.endw
							.if ecx
								xor	ecx,ecx
								.while (byte ptr[ebx]!='|')&&(byte ptr[ebx]!=32)&&(ecx<38)
									mov	al,[ebx]
									stosb
									inc	ebx
									inc	ecx
								.endw
								mov	al,0
								stosb
							.endif
						.endif
						pop	edi
						jmp	_ret__
					.endif
				.else
					mov	esi,[edi].ptr_usrstruc
					call	_login
				.endif
				push	edi
				lea	edx,cform
				mov	edi,dword ptr[edi].buffer_out
				call	copyedx

				lea	edx,sigtxt1
				call	copyedx
				.if ([esi].profptr!=0)&&([esi].userid!=0)
					mov	edx,[esi].profptr
					lea	edx,[edx+328]
					invoke	dc_to_web,dcconv
					mov	edx,[esi].profptr
					movzx	ecx,word ptr[edx+84]
				.else
					xor	ecx,ecx
				.endif
				lea	edx,sigtxt2
				call	copyedx

				mov	edx,langptr
				.while dword ptr[edx]!=0
					push	edx
					lea	edx,sigopt
					call	copyedx
					mov	edx,[esp]
					mov	edx,dword ptr[edx]
					mov	edx,dword ptr[edx+87*4]
					mov	ax,word ptr[edx]
					stosw
					.if ax==cx
						mov	eax,'es "'
						stosd
						mov	eax,'tcel'
						stosd
						mov	eax,' >de'
						stosd
					.else
						mov	eax,' >"'
						stosd
					.endif
					dec	edi
					mov	edx,[esp]
					mov	edx,dword ptr[edx]
					mov	edx,dword ptr[edx+87*4]
					mov	ax,word ptr[edx]
					stosw
					lea	edx,sigopt1
					call	copyedx
					pop	edx
					lea	edx,dword ptr[edx+4]
				.endw
				lea	edx,sigtxt3
				call	copyedx
				lea	edx,cform1
				call	copyedx

				mov	ecx,edi
				pop	edi
				call	httpsend
				jmp	_ret_1
			.endif
_rep:			push	edi
			lea	ecx,[edi].cookies
			push	ecx
			lea	ebx,_repass_
			call	getvar
			mov	esi,[edi].ptr_usrstruc
			mov	edi,dword ptr[edi].buffer_out
			pop	ecx
			.if eax==0
				lea	edx,lform
				call	copyedx
				mov	edx,ecx
				lea	ebx,_user_
				call	getcookie
				.if eax==0
					lea	ebx,_user_
					call	getcookie
					.if eax
						jmp	_lst_
					.endif
					lea	ebx,_lastuser_
					call	getcookie
					.if eax
						jmp	_lst_
					.endif
				.else
_lst_:					.if byte ptr[edx]=='='
						inc	edx
						.while byte ptr[edx]==32
							inc	edx
						.endw
						xor	ecx,ecx
						.while (byte ptr[edx]>32)&&(byte ptr[edx]!=';')&&(ecx<60)
							mov	al,[edx]
							stosb
							inc	edx
							inc	ecx
						.endw
					.endif
				.endif
				lea	edx,lform1
				call	copyedx
			.else
				.if [esi+4].rights&_4_pwd1
					push	edi
					push	esi
					push	ecx
					mov	edi,[esp+4+4+4]
					call	_login
					call	updlang
					pop	ecx
					pop	esi
					pop	edi
					lea	edx,rform
					call	copyedx
					mov	edx,ecx
					lea	ebx,_user_
					call	getcookie
					.if eax
						.if byte ptr[edx]=='='
							inc	edx
							.while byte ptr[edx]==32
								inc	edx
							.endw
							xor	ecx,ecx
							.while (byte ptr[edx]>32)&&(byte ptr[edx]!=';')&&(ecx<60)
								mov	al,[edx]
								stosb
								inc	edx
								inc	ecx
							.endw
						.endif
					.endif
					lea	edx,rform1
					call	copyedx
					lea	edx,sigtxt1
					call	copyedx
					.if ([esi].profptr!=0)&&([esi].userid!=0)
						mov	edx,[esi].profptr
						lea	edx,[edx+328]
						invoke	dc_to_web,dcconv
						mov	ecx,[esi].profptr
						movzx	ecx,word ptr[ecx+84]
					.else
						xor	ecx,ecx
					.endif
					lea	edx,sigtxt2
					call	copyedx

					mov	edx,langptr
					.while dword ptr[edx]!=0
						push	edx
						lea	edx,sigopt
						call	copyedx
						mov	edx,[esp]
						mov	edx,dword ptr[edx]
						mov	edx,dword ptr[edx+87*4]
						mov	ax,word ptr[edx]
						stosw
						.if ax==cx
							mov	eax,'es "'
							stosd
							mov	eax,'tcel'
							stosd
							mov	eax,' >de'
							stosd
						.else
							mov	eax,' >"'
							stosd
						.endif
						dec	edi
						mov	edx,[esp]
						mov	edx,dword ptr[edx]
						mov	edx,dword ptr[edx+87*4]
						mov	ax,word ptr[edx]
						stosw
						lea	edx,sigopt1
						call	copyedx
						pop	edx
						lea	edx,dword ptr[edx+4]
					.endw
					lea	edx,sigtxt3
					call	copyedx
					lea	edx,rform1_
					call	copyedx
				.else
					push	edi
					push	esi
					push	ecx
					mov	edi,[esp+4+4+4]
					call	_login
					call	updlang
					pop	ecx
					pop	esi
					pop	edi
					lea	edx,pwderr1
_ends_:					pop	edi
					push	edi
					mov	edi,dword ptr[edi].buffer_out
					call	copyedx
				.endif
			.endif
			mov	ecx,edi
			pop	edi
			call	httpsend
			jmp	_ret_1
		.else
			push	edi
			.if byte ptr[edx]=='='
				inc	edx
			.endif
			mov	edi,[edi].buffer_out
			push	edx
			call	esc_nick
			pop	edx
			mov	eax,[esp]
			assume	eax:ptr web_user_info
			mov	eax,[eax].buffer_out
			assume	eax:nothing
			.if byte ptr[eax]==0
				invoke	GlobalAlloc,GPTR,512
				pop	edi
				push	edi
				mov	[edi].newcookies,eax
				mov	edi,eax
				mov	eax,'resu'
				stosd
				mov	ax,'='
				stosw
				mov	eax,[esp]
				call	wpath
				dec	edi
				mov	ax,0a0dh
				stosw
				mov	eax,'igol'
				stosd
				mov	eax,'0=n'
				stosd
				mov	eax,[esp]
				call	wpath
				pop	edi
				mov	esi,[edi].ptr_usrstruc
				mov	edx,offset def_user
				mov	eax,dword ptr[edx+4]
				mov	dword ptr[esi].rights,eax
				mov	eax,dword ptr[edx]
				mov	dword ptr[esi+4].rights,eax
				mov	eax,dword ptr[edx+8]
				mov	[esi].access,eax
				mov	eax,dword ptr [edx+12]
				mov	[esi+4].access,eax
				mov	eax,dword ptr[edx+16]
				mov	[esi+8].access,eax
				mov	eax,dword ptr[edx+20]
				mov	[esi+12].access,eax
				mov	[esi].profileid,2
				mov	[esi].userid,0
				mov	[esi].profptr,0
				jmp	_ret__
			.endif
			mov	ax,'|'
			stosw
			.while (byte ptr[edx]!=0)&&(dword ptr[edx]!='sap&')&&(dword ptr[edx]!='per&')&&(dword ptr[edx]!='ter&')&&(dword ptr[edx]!='gol&')&&(dword ptr[edx]!='aer&')&&(dword ptr[edx]!='nal&')
				mov	al,[edx]
				stosb
				inc	edx
			.endw
			mov	al,0
			stosb
			pop	edi
			push	edi
			lea	ebx,_repass_
			call	getvar
			.if eax==0
				pop	edi
				push	edi
				mov	ebx,[edi].buffer_out

				.if byte ptr[ebx]=='|'
					lea	edx,errnick
					jmp	_ends_
				.endif
				mov	esi,[edi].ptr_usrstruc
				call	f_profile
				.if (edi==-1)||(edi==-2)
					lea	edx,pwderr2
					jmp	_ends_
				.endif
				mov	esi,edi
				pop	edi
				push	edi
				lea	ebx,_pass_
				call	getvar
				.if eax
					.if byte ptr[edx]=='='
						inc	edx
						.if (byte ptr[edx]==0)||(dword ptr[edx]=='sap&')||(dword ptr[edx]=='per&')||(dword ptr[edx]=='ter&')||(dword ptr[edx]=='gol&')||(dword ptr[edx]=='aer&')||(dword ptr[edx]=='nal&')
							xor	eax,eax
						.endif
					.else
						xor	eax,eax
					.endif
				.endif
				.if (eax==0)&&(byte ptr[esi+88]==0)
_gpass_:				mov	edx,esi
					pop	edi
					push	edi
					mov	esi,[edi].ptr_usrstruc
					mov	ecx,[edi].buffer_out
					mov	edi,edx
					push	edi
					mov	edx,ecx
					lea	edi,[esi]._name
					xor	ecx,ecx
					.while (byte ptr[edx]!=0)&&(byte ptr[edx]!='|')
						mov	al,[edx]
						stosb
						inc	edx
						inc	ecx
						.break .if ecx>38
					.endw
					mov	al,0
					stosb
					lea	edi,[esi].req_name
					lea	edx,[esi]._name
					call	copyedx
					mov	al,0
					stosb
					pop	edi
					mov	[esi].profptr,edi
					mov	ax,word ptr[edi+48]
					mov	[esi].profileid,ax
					mov	eax,dword ptr[edi+52]
					mov	[esi].userid,eax
					mov	eax,dword ptr[edi+56]
					mov	dword ptr[esi+4].rights,eax
					mov	eax,dword ptr[edi+60]
					mov	dword ptr[esi].rights,eax
					mov	eax,dword ptr[edi+64]
					mov	[esi].access,eax
					mov	eax,dword ptr[edi+68]
					mov	[esi+4].access,eax
					mov	eax,dword ptr[edi+72]
					mov	[esi+8].access,eax
					mov	eax,dword ptr[edi+278]
					mov	[esi+12].access,eax
					mov	al,byte ptr[edi+278+4]
					mov	[esi].accflag,al
					mov	ax,word ptr[edi+86]
					mov	[esi].modifier,ax
					lea	ebx,dword ptr[edi+84]
					call	_lang
					mov	ebx,edi
					pop	edi
					push	edi
					mov	edx,[edi].buffer_out
					.while byte ptr[edx]
						inc	edx
					.endw
					inc	edx
					push	ebx
					invoke	GlobalAlloc,GPTR,512
					pop	ebx
					mov	[edi].newcookies,eax
					mov	edi,eax
					mov	eax,'resu'
					stosd
					mov	al,'='
					stosb
					lea	edx,[esi]._name
					call	copyedx
					mov	eax,[esp]
					call	wpath
					dec	edi
					assume	eax:nothing
					mov	ax,0a0dh
					stosw
					mov	eax,'igol'
					stosd
					mov	ax,'=n'
					stosw
					mov	eax,[esi]._ip
					lea	ebx,[ebx+88]
					.if byte ptr[ebx]==1
						xor	eax,[ebx+1]
					.else
						.while byte ptr[ebx]
							rol	eax,1
							add	al,[ebx]
							inc	ebx
						.endw
						xor	eax,[esi]._ip
					.endif
					call	itoa
					mov	eax,[esp]
					call	wpath
					pop	edi
					call	updlang
					jmp	_ret__
				.else
					push	edx
					call	chkpass
					.if eax
						pop	edx
						jmp	_gpass_
					.endif
_n_pass:				pop	ebx
					pop	edi
					push	edi
					mov	esi,[edi].ptr_usrstruc
					onBadSettings	6
					.if eax==0
						pop	esi
						jmp	_gpass_
					.endif
					pop	edi
					push	edi
					mov	edx,[edi].buffer_out
					lea	edi,[esi]._name
					xor	ecx,ecx
					.while (byte ptr[edx]!=0)&&(byte ptr[edx]!='|')
						mov	al,[edx]
						stosb
						inc	edx
						inc	ecx
						.break .if ecx>38
					.endw
					mov	al,0
					stosb
					lea	edi,[esi].req_name
					lea	edx,[esi]._name
					call	copyedx
					mov	al,0
					stosb
					.if s_mypass.cmdflag&4
						mov	eax,[esi].ipptr
						assume	eax:ptr ip_info
						inc	[eax].invpasvd
						movzx	eax,byte ptr[eax].invpasvd
						assume	eax:nothing
						.if ax>=word ptr s_mypass.cmdparam2
							mov	eax,[esi]._ip
							push	ebx
							push	esi
							mov	edi,esi
							lea	esi,rbstruc
							call	findiprofile
							.if edi!=-1
								push	edi
								mov	dword ptr[edi+76],1
								mov	word ptr[edi+50],2
								movzx	eax,word ptr s_mypass.cmdparam2+2
								movzx	edx,byte ptr s_mypass.cmdparam1+1
								mov	ecx,[esp+4]
								call	getbantime
								lea	edi,[edi+328]
								mov	esi,[esp+4]
								mov	ecx,89
								call	getlstr
								mov	al,0
								stosb
								pop	edi
								mov	ebx,3
								xor	eax,eax
								lea	esi,rbstruc
								push	dword ptr[edi+76]
								push	dword ptr[edi+538]
								push	dword ptr[edi+538+4]
								call	setban
								pop	dword ptr[edi+538+4]
								pop	dword ptr[edi+538]
								pop	dword ptr[edi+76]
								pop	esi
								push	esi
								mov	[esi].profptr,edi
								mov	eax,dword ptr[edi+52]
								mov	[esi].userid,eax
							.endif
							pop	esi
							pop	ebx
						.endif
					.endif
					getbuffer
					xor	ecx,ecx
					.while (byte ptr[ebx+ecx]!=0)&&(byte ptr[ebx+ecx]!='&')
						inc	ecx
					.endw
					mov	word ptr[ebx+ecx],'|'
					mov	dword ptr [esi].rights,0
					mov	dword ptr [esi+4].rights,0
					call	invpass
					lea	edx,pwderr3
					jmp	_ends_
				.endif
			.else
				.if (byte ptr[edx]!='=')||((byte ptr[edx+1]==0)||(dword ptr[edx+1]=='sap&')||(dword ptr[edx+1]=='per&')||(dword ptr[edx+1]=='ter&'))
					jmp	_re_s_1
				.elseif (dword ptr[edx+1]=='gol&')||(dword ptr[edx+1]=='esu&')||(dword ptr[edx+1]=='aer&')||(dword ptr[edx+1]=='nal&')
_re_s_1:				mov	byte ptr[edx-1],'='
					lea	ebx,_repass_
					call	getvar
				.endif
				push	edx
				lea	ebx,_pass_
				call	getvar
				.if byte ptr[edx]=='='
					inc	edx
				.endif
				pop	ebx
				.if byte ptr[ebx]=='='
					inc	ebx
				.endif
				push	ebx
				mov	ecx,ebx
				.while (byte ptr[edx]!=0)&&(dword ptr[edx]!='sap&')&&(dword ptr[edx]!='per&')&&(dword ptr[edx]!='ter&')&&(dword ptr[edx]!='gol&')&&(dword ptr[edx]!='aer&')&&(dword ptr[edx]!='sap&')
					mov	al,byte ptr[ebx]
					.break .if al!=byte ptr[edx]
					inc	ebx
					inc	edx
				.endw
				.if ((byte ptr[edx]==0)||(dword ptr[edx]=='per&')||(dword ptr[edx]=='ter&')||(dword ptr[edx]=='gol&')||(dword ptr[edx]=='aer&')||(dword ptr[edx]=='nal&'))
					.if ((byte ptr[ebx]==0)||(dword ptr[ebx]=='sap&')||(dword ptr[ebx]=='ter&')||(dword ptr[ebx]=='gol&')||(dword ptr[ebx]=='aer&')||(dword ptr[ebx]=='nal&'))
					.else
						pop	eax
						lea	edx,pwderr3
						jmp	_ends_
					.endif
				.else
					pop	eax
					lea	edx,pwderr3
					jmp	_ends_
				.endif
				mov	edi,[esp+4]
				mov	ebx,[edi].buffer_out

				.if byte ptr[ebx]=='|'
					pop	ebx
					lea	edx,errnick
					jmp	_ends_
				.endif
				call	nickcorr
				.if eax!=0
					pop	ebx
					lea	edx,errnick
					jmp	_ends_
				.endif
				xor	ecx,ecx
				.while byte ptr[ebx+ecx]!='|'
					.if byte ptr[ebx+ecx]=='%'
						pop	ebx
						lea	edx,errnick
						jmp	_ends_
					.endif
					inc	ecx
				.endw
				mov	esi,[edi].ptr_usrstruc
				call	scan_ip
				.if eax!=0
					pop	ebx
					lea	edx,errnick
					jmp	_ends_
				.endif
				push	ebx
				call	f_profile
				pop	ebx
				mov	byte ptr[ebx+ecx],0
				.if (edi!=-1)&&(edi!=-2)
					pop	ebx
					lea	edx,pwderr2
					jmp	_ends_
				.endif
				lea	edi,[esi]._name
				xor	ecx,ecx
				.while byte ptr[ebx+ecx]!='|'
					mov	al,[ebx+ecx]
					stosb
					.break .if ecx>38
					inc	ecx
				.endw
				mov	al,0
				stosb

				.if (!([esi+5].rights&_5_spam2))
					mov	eax,[esi].ipptr
					assume	eax:ptr ip_info
					mov	dl,byte ptr systime.wHour
					mov	dh,byte ptr systime.wDay
					shl	dh,4
					and	dx,0f00fh
					or	dl,dh
					.if dl==byte ptr[eax+1].reserved
						lea	edx,pwderr4
						mov	edi,[esp+4]
						push	edi
						mov	edi,dword ptr[edi].buffer_out
						.while byte ptr[edx]
							mov	al,[edx]
							.if al=='%'
								push	edx
								movzx	eax,systime.wMinute
								xor	edx,edx
								mov	ecx,60
								mul	ecx
								mov	edx,3600
								sub	edx,eax
								.if dx>3600
									mov	dx,3600
								.elseif dx==0
									inc	edx
								.endif
								mov	eax,edx
								call	itoa
								pop	edx
							.else
								stosb
							.endif
							inc	edx
						.endw
						mov	ecx,edi
						pop	edi
						call	httpsend
						pop	eax
						jmp	_ret_1
					.else
						mov	byte ptr[eax+1].reserved,dl
					.endif
				.endif

				inc	[esi].access
				call	findnprofile
				dec	[esi].access
				.if edi==-1
					push	ebx
					mov	ebx,esi
					push	esi
					getbuffer
					push	eax
					push	ebx
					call	make_nprofile
					pop	ebx
					pop	eax
					pop	esi
					pop	ebx
				.endif
				call	updaccount
				mov	ecx,edi
				lea	edi,[edi+88]
				mov	eax,[esi].access
				pop	ebx
				push	ecx
				xor	ecx,ecx
				.while 1
					.if ((byte ptr[ebx+ecx]==0)||(dword ptr[ebx+ecx]=='sap&')||(dword ptr[ebx+ecx]=='ter&')||(dword ptr[ebx+ecx]=='gol&')||(dword ptr[ebx+ecx]=='aer&')||(dword ptr[ebx+ecx]=='nal&'))
						lea	edx,[ebx+ecx]
						push	dword ptr[edx]
						push	edx
						mov	word ptr[edx],'|'
						.break
					.endif
					inc	ecx
				.endw
				.if (s_mypass.cmdflag&32)&&(eax>=s_getinfo.cmdparam1)
					call	isbadpass
					.if eax
						mov	byte ptr[edi],1
						mov	dword ptr[edi+1],eax
						mov	byte ptr[edi+5],0
					.else
						lea	edx,pwderr3a
						pop	eax
						pop	dword ptr[eax]
						pop	ecx
						jmp	_ends_
					.endif
				.else
					xor	ecx,ecx
					.while (byte ptr[ebx+ecx]!='|')&&(byte ptr[ebx+ecx]!=32)&&(ecx<38)
						inc	ecx
					.endw
					.if ecx
						xor	ecx,ecx
						.while (byte ptr[ebx]!='|')&&(byte ptr[ebx]!=32)&&(ecx<38)
							mov	al,[ebx]
							stosb
							inc	ebx
							inc	ecx
						.endw
						mov	al,0
						stosb
					.else
						lea	edx,pwderr3
						pop	eax
						pop	dword ptr[eax]
						pop	ecx
						jmp	_ends_
					.endif
				.endif
				pop	eax
				pop	dword ptr[eax]
				pop	esi
		;		mov	edi,[esp]
		;		call	updlang
				jmp	_gpass_
			.endif
			pop	edi
		.endif
	.endif

reread:	mov	esi,[edi].ptr_usrstruc
	mov	eax,[esi].hSocket
	mov	htsocket,eax
	mov	edx,[edi].ptr_web_info
	.if [edx].webopt==1
		lea	edx,[edx].webindex
	.elseif [edx].webopt==2
		lea	ecx,[edx].webshare
		.if byte ptr[ecx]
			push	edi
			mov	edx,ecx
			lea	ecx,[edi].get_path
			mov	edi,[edi].buffer_out
			push	edi
			mov	al,0
			call	copyedx
			.if (al!='/')&&(al!='\')
				mov	al,'\'
				stosb
			.endif
			.while (byte ptr[ecx]!=0)&&(byte ptr[ecx]!='?')&&(byte ptr[ecx]!='#')&&(byte ptr[ecx]!=':')
				.while (byte ptr[ecx]=='/')||(byte ptr[ecx]=='\')||(byte ptr[ecx]==32)
					inc	ecx
				.endw
				.break .if byte ptr[ecx]==0
				.if (byte ptr[ecx]<33)||(byte ptr[ecx]=='.')
					pop	eax
					pop	edi
					jmp	_send404
				.endif
				.if byte ptr[edi-1]!='\'
					mov	al,'\'
					stosb
				.endif
				.while (byte ptr[ecx]!=0)&&(byte ptr[ecx]!='/')&&(byte ptr[ecx]!='\')
					mov	al,[ecx]
					.if (al<32)||(al==34)||(al=='*')||(al=='|')||(al=='<')||(al=='>')
						pop	eax
						pop	edi
						jmp	_send404
					.else
						stosb
					.endif
					inc	ecx
				.endw
				mov	al,0
				stosb
				.break .if byte ptr[ecx]==0
				push	ecx
				mov	ecx,[esp+4]
				invoke	GetFileAttributes,ecx
				pop	ecx
				.if eax==-1
					pop	eax
					pop	edi
					jmp	_send404
				.endif
				dec	edi
			.endw
			push	ecx
			mov	ecx,[esp+4]
			.if byte ptr[ecx]=='.'
				xor	eax,eax
				dec	eax
			.else
				invoke	GetFileAttributes,ecx
			.endif
			pop	ecx
			.if eax==-1
				pop	eax
				pop	edi
				jmp	_send404
			.elseif eax&FILE_ATTRIBUTE_DIRECTORY
				.if (byte ptr[edi-1]=='\')||(byte ptr[edi-1]=='/')
					dec	edi
				.elseif (byte ptr[edi-1]==0)
					mov	eax,lParam
					assume	eax:ptr web_user_info
					.if (word ptr[eax].get_path!='/')&&(word ptr[eax].get_path!='\')
					lea	ecx,[eax].get_path
					assume	eax:nothing
					.while (byte ptr[ecx]!=0)&&(byte ptr[ecx]!='?')&&(byte ptr[ecx]!='#')&&(byte ptr[ecx]!=':')
						inc	ecx
					.endw
					mov	al,[ecx]
					mov	byte ptr[ecx],'/'
					inc	ecx
					.while al
						xchg	al,[ecx]
						inc	ecx
					.endw
					mov	byte ptr[ecx],al
					pop	eax
					pop	edi

_rpage:					mov	edi,lParam
					mov	edi,[edi].buffer_out
					lea	edx,httphdr
					call	copyedx
					lea	edx,httpfound
					call	copyedx
					mov	eax,lParam
					assume	eax:ptr web_user_info
					lea	edx,[eax].get_path
					push	edi
					push	eax
					call	copyedx
					pop	eax
					lea	edx,[eax]._var
					assume	eax:nothing
					.if byte ptr[edx]
						mov	al,'?'
						stosb
						.while byte ptr[edx]
							mov	eax,dword ptr[edx]
							or	eax,20202020h
							.if (eax=='ledc')
								mov	eax,dword ptr[edx+4]
								or	eax,202020h
								.if eax=='=ete'
									.while (byte ptr[edx]!='&')&&(byte ptr[edx]!=0)
										inc	edx
									.endw
									.if byte ptr[edi-1]=='&'
										dec	edi
									.endif
								.else
									.while (byte ptr[edx]!='&')&&(byte ptr[edx]!=0)
										mov	al,byte ptr[edx]
										stosb
										inc	edx
									.endw
								.endif
							.else
								.while (byte ptr[edx]!='&')&&(byte ptr[edx]!=0)
									mov	al,[edx]
									stosb
									inc	edx
								.endw
							.endif
							.if byte ptr[edx]=='&'
								mov	al,[edx]
								stosb
								inc	edx
								mov	eax,dword ptr[edx]
								or	eax,202020h
								.if eax==';pma'
									lea	edx,[edx+4]
								.endif
							.endif
						.endw
					.endif
					mov	edx,edi
					pop	eax
					sub	edx,eax
					mov	ax,0a0dh
					stosw
					push	edx
					call	httpwdate
					lea	edx,httpctype
					call	copyedx
					mov	eax,sizeof wredir+sizeof wredir1-2
					pop	edx
					add	eax,edx
					call	itoa
					mov	ax,0a0dh
					stosw
					lea	edx,cachectrl
					call	copyedx
					lea	edx,httpconn
					call	copyedx
					mov	ecx,lParam
					assume	ecx:ptr web_user_info
					mov	eax,[ecx].proxy_flags
					assume	ecx:nothing
					.if eax&1
						lea	edx,cclose
					.else
						lea	edx,ckeep
					.endif
					push	eax
					call	copyedx
					mov	ax,0a0dh
					stosw
					pop	eax
					.if (!(eax&16))
						lea	edx,wredir
						call	copyedx
						mov	eax,lParam
						assume	eax:ptr web_user_info
						lea	edx,[eax].get_path
						assume	eax:nothing
						call	copyedx
						lea	edx,wredir1
						call	copyedx
					.endif
					mov	ecx,edi
					mov	edi,lParam
					mov	edi,dword ptr[edi].buffer_out
					sub	ecx,edi
					invoke	asend,edi,ecx
					jmp	_endt
					.endif
				.endif
				lea	edx,_defidx
				call	copyedx
				mov	al,0
				stosb
				push	ecx
				mov	ecx,[esp+4]
				invoke	GetFileAttributes,ecx
				pop	ecx
				.if (eax==-1)||(eax&FILE_ATTRIBUTE_DIRECTORY)
					dec	edi
					dec	edi
					mov	al,0
					stosb
				.endif
			.endif
			pop	edx
			pop	edi
		.else
_send404:		mov	edx,[edi].ptr_web_info
			.if (!([edx].webflags&1024))
				xor	eax,eax
				inc	eax
				push	edx
				mov	ecx,hPlugins
				.while ecx
					assume	ecx:ptr pluginInfo
					.if ([ecx].pluginStatus==1)&&([ecx]._onhttp2!=0)
						push	edx
						push	ecx
						push	esi
						push	edi
						push	ebp
						mov	ebp,esp

						lea	eax,[edi].cookies
						push	eax
						lea	eax,[edi].user_agent
						push	eax
						lea	eax,[edi].referer
						push	eax
						mov	edx,dword ptr[edi]
						lea	eax,[edi]._host
						push	eax
						lea	eax,[edi].get_path
						push	eax
						mov	eax,404
						push	eax
						push	[esi].sessionId
						call	[ecx]._onhttp2
						.if ebp!=esp
							mov	al,20
							int 3
						.endif
						pop	ebp
						pop	edi
						pop	esi
						pop	ecx
						pop	edx
						.break .if (eax==0)
					.endif
					assume	ecx:nothing
					mov	ecx,dword ptr[ecx]
				.endw
				pop	edx
				.if eax==0
					jmp	_endt
				.endif
			.endif
			or	[edi].proxy_flags,64
			.if ([edx].webflags&2)
				lea	edx,[edx]._404
			.elseif (word ptr[edi].get_path=='/')
				push	edi
				lea	ecx,[edx].webshare
				mov	edx,ecx
				mov	edi,[edi].buffer_out
				push	edi
				mov	al,0
				call	copyedx
				.if (al!='/')&&(al!='\')
					mov	al,'\'
					stosb
				.endif
				lea	edx,defidx
				call	copyedx
				mov	ecx,[esp]
				invoke	GetFileAttributes,ecx
				.if (eax==-1)||(eax&FILE_ATTRIBUTE_DIRECTORY)
					dec	edi
					dec	edi
					mov	al,0
					stosb
				.endif
				pop	edx
				pop	edi
			.else
				push	edi
				push	edx
				mov	edi,[edi].buffer_out
				lea	edx,httphdr
				call	copyedx
				lea	edx,httpfound
				call	copyedx
				mov	al,'/'
				stosb
				mov	ax,0a0dh
				stosw
				call	httpwdate
				lea	edx,httpctype
				call	copyedx
				mov	eax,sizeof wredir+sizeof wredir1+1-2
				call	itoa
				mov	ax,0a0dh
				stosw
				lea	edx,cachectrl
				call	copyedx
				lea	edx,httpconn
				call	copyedx
				mov	ecx,lParam
				assume	ecx:ptr web_user_info
				mov	eax,[ecx].proxy_flags
				assume	ecx:nothing
				.if eax&1
					lea	edx,cclose
				.else
					lea	edx,ckeep
				.endif
				push	eax
				call	copyedx
				mov	ax,0a0dh
				stosw
				pop	eax
				.if (!(eax&16))
					lea	edx,wredir
					call	copyedx
					pop	edx
					push	edx
					lea	edx,[edx].webredir
					call	copyedx
					mov	al,'/'
					stosb
					lea	edx,wredir1
					call	copyedx
				.endif
				mov	ecx,edi
				pop	edx
				mov	edi,lParam
				mov	edi,dword ptr[edi].buffer_out
				sub	ecx,edi
				invoke	asend,edi,ecx
				pop	edi
				jmp	_endt
			.endif
		.endif
	.else
		int 3
	.endif

	push	edx
	invoke	CreateFile,edx,GENERIC_READ,FILE_SHARE_READ or FILE_SHARE_WRITE,0,OPEN_EXISTING,0,0
	push	eax
	.if eax!=INVALID_HANDLE_VALUE
		invoke	GetFileSize,eax,0
	.else
		xor	eax,eax
	.endif
	mov	fsize,eax
	pop	ecx
	push	ecx
	invoke	ReadFile,ecx,addr hdr,4,addr bread,0
	pop	ecx
	pop	edx
	push	edx
	push	ecx
	invoke	SetFilePointer,ecx,0,0,FILE_BEGIN
	.if byte ptr hdr=='<'
		mov	eax,fsize
		.if 0 ;eax>2*1024*1024
			call	CloseHandle
			pop	edx
			push	edi
			push	edx
			lea	edi,[edi+4096]
			lea	edx,httphdr
			call	copyedx
			mov	eax,lParam
			assume	eax:ptr web_user_info
			.if [eax].proxy_flags&64
				assume	eax:nothing
				lea	edx,http404
			.else
				lea	edx,http200
			.endif
			call	copyedx
			call	httpwdate
			lea	edx,httpctype
			call	copyedx
			mov	al,'0'
			stosb
			mov	ax,0a0dh
			stosw
			lea	edx,cachectrl
			call	copyedx
			lea	edx,httpconn
			call	copyedx
			mov	eax,[esp+4]
			mov	eax,[eax+4]
			.if eax&1
				lea	edx,cclose
			.else
				lea	edx,ckeep
			.endif
			call	copyedx
			mov	ax,0a0dh
			stosw
			mov	ecx,edi
			pop	edx
			pop	edi
			push	edi
			lea	edi,[edi+4096]
			sub	ecx,edi
			invoke	asend,edi,ecx
			pop	edi
		.else
			push	eax
			lea	eax,[eax+1024]
			invoke	GlobalAlloc,GPTR,eax
			pop	ecx
			pop	edx
			push	edx
			mov	[edi].buffer_in,eax
			invoke	ReadFile,edx,eax,ecx,addr bread,0
			mov	edx,[edi].buffer_in
			add	edx,bread
			mov	byte ptr[edx],0
			call	CloseHandle
			call	_login
			mov	esi,[edi].ptr_usrstruc
			mov	edx,[edi].ptr_web_info
			.if ([esi+6].rights&_6_plug0)
				lea	ebx,_dcomment_
				push	edx
				call	getvar
				.if eax
					.if byte ptr[edx]=='='
						inc	edx
						pop	eax
						.if (byte ptr[edx]<='9')&&(byte ptr[edx]>='0')
							push	esi
							mov	esi,edx
							call	atoi
							.while (byte ptr[esi]>='0')&&(byte ptr[esi]<='9')
								.if byte ptr[esi-1]=='-'
									push	eax
									call	atoi
									mov	edx,eax
									pop	eax
									.if eax>=edx
										sub	eax,edx
									.endif
								.else
									push	eax
									call	atoi
									mov	edx,eax
									pop	eax
									add	eax,edx
								.endif
							.endw
							push	eax
							invoke	GetPageCount,edi
							pop	eax
							.if [edi].cpages1&80h
								mov	edx,[edi].cpages
								dec	edx
								.if edx>=eax
									sub	edx,eax
									mov	eax,edx
								.else
									xor	eax,eax
								.endif
							.endif
							pop	esi
							pop	ebx
							invoke	DeleteComments,ebx
						.endif
						jmp	_rpage
					.endif
				.endif
				pop	edx
			.endif
			.if ((byte ptr[esi]._name!=0)||(!([edx].webflags&8)))&&([esi].rights&_0_chat0)&&([edx].webflags&4)
				lea	ebx,_title_
				call	getvar
				.if eax==0
					xor	edx,edx
				.endif
				mov	[edi].ptrcomments[8],edx
				.if byte ptr[esi]._name==0
					lea	ebx,_user_
					call	getvar
					.if eax
						.if byte ptr[edx]=='='
							inc	edx
						.endif
						push	edi
						lea	edi,[esi]._name
						call	esc_nick
						lea	ebx,[esi]._name
						call	findprofile
						.if edi!=-1
							mov	byte ptr[esi]._name,0
						.endif
						pop	edi
					.endif
				.endif
				lea	ebx,_pcomm_
				call	getvar
				.if eax==0
					lea	ebx,_pcomment_
					call	getvar
				.else
					xor	eax,eax
				.endif
				pop	ebx
				.if eax
					push	ebx
					push	edx
					lea	ebx,_sep_
					call	getvar
					.if eax
						.if byte ptr[edx-10]=='&'
							lea	ecx,[edx-10]
						.else
							lea	ecx,[edx-9]
						.endif
						.if byte ptr[ecx]
							mov	byte ptr[ecx],0
						.else
							xor	ecx,ecx
						.endif
					.endif
					pop	edx
					pop	ebx
					push	ecx
					push	ebx
					xor	ecx,ecx
					.while byte ptr[edx+ecx]
						.if byte ptr[edx+ecx]=='+'
							mov	byte ptr[edx+ecx],' '
							inc	ecx
						.elseif byte ptr[edx+ecx]=='&'
							.if byte ptr[edx+ecx+1]=='#'
								push	esi
								push	edx
								push	ecx
								lea	esi,[edx+ecx+2]
								call	atoi
								.if byte ptr[esi-1]!=';'
									dec	esi
								.endif
								pop	ecx
								pop	edx
								.if al!='+'
									push	edx
									push	ecx
									push	edi
									lea	edi,[edx+ecx]
									stosb
									.while byte ptr[esi]
										inc	esi
									.endw
									pop	edi
									pop	ecx
									pop	edx
								.else
									inc	ecx
								.endif
								pop	esi
							.endif
							inc	ecx
						.else
							inc	ecx
						.endif
					.endw
					mov	ecx,[edi].buffer_in
					.while byte ptr[ecx]
						.if word ptr[ecx]=='[%'
							mov	eax,[ecx+2]
							or	eax,20202020h
							.if eax=='tadc'
								.break
							.endif
						.endif
						inc	ecx
					.endw
					.if byte ptr[edx]=='='
						inc	edx
					.endif
					mov	eax,dword ptr[edi].ptr_web_info
					assume	eax:ptr web_info
					.if (word ptr[ecx]=='[%')&&(byte ptr[edx]!=0)
						assume	eax:nothing
						.if (!([esi+5].rights&_5_spam3))
							push	edx
							push	ecx
							mov	ebx,edx
							mov	edx,[edi].ptr_web_info
							lea	edx,[edx].forbid
							push	edi
							forbid_web
							pop	edi
							pop	ecx
							pop	edx
						.endif
						.if (!([esi+5].rights&_5_spam2))
							push	edx
							push	ecx
							mov	eax,[esi].ipptr
							assume	eax:ptr ip_info
							mov	dl,byte ptr systime.wHour
							mov	dh,byte ptr systime.wMinute
							shl	dh,4
							and	dx,0f00fh
							or	dl,dh
							.if dl==byte ptr[eax].reserved
								lea	edx,pwderr4
								push	edi
								mov	edi,dword ptr[edi].buffer_out
								.while byte ptr[edx]
									mov	al,[edx]
									.if al=='%'
										mov	eax,60
										sub	ax,systime.wSecond
										.if ax>60
											mov	ax,60
										.elseif ax==0
											inc	eax
										.endif
										push	edx
										movzx	eax,al
										call	itoa
										pop	edx
									.else
										stosb
									.endif
									inc	edx
								.endw
								mov	ecx,edi
								pop	edi
								call	httpsend
								pop	ecx
								pop	edx
								pop	ebx
								pop	ecx
								jmp	_endt
							.else
								mov	byte ptr[eax].reserved,dl
							.endif
							pop	ecx
							pop	edx
							assume	eax:nothing
						.endif
						.if ([esi].waiting&2)
							pop	ebx
							pop	ecx
							jmp	_endt
						.endif
						pop	ebx
						push	ebx
						lea	eax,hubdesc
						invoke	ShowComment,ebx,edx,ecx
						invoke	PostComment,ebx,edx,ecx,addr random
						push	edi
						push	esi
						lea	esi,[edi].get_path
						mov	eax,[edi].ptr_usrstruc
						assume	eax:ptr usrstruc
						mov	eax,[eax].ovr.buffer2
						assume	eax:nothing
						mov	edi,[edi].buffer_out
						push	edi
						push	eax
						lea	edx,httphdr
						call	copyedx
						lea	edx,httpfound
						call	copyedx
						mov	ecx,edi
						mov	edx,esi
						call	copyedx
					;	mov	eax,[esp+4+4]
					;	assume	eax:ptr web_user_info
					;	lea	edx,[eax]._var
					;	assume	eax:nothing
						pop	edx
						lea	edx,[edx+4]
						.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=13)&&(byte ptr[edx]!=10)&&(byte ptr[edx]!='?')
							inc	edx
						.endw
						mov	al,'?'
						stosb
						.if byte ptr[edx]=='?'
							inc	edx
							.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=32)&&(byte ptr[edx]!=13)&&(byte ptr[edx]!=10)
								mov	al,[edx]
								stosb
								inc	edx
							.endw
							mov	al,'&'
							stosb
						.endif
						mov	eax,'tsop'
						stosd
						mov	eax,edi
						sub	eax,ecx
						push	eax
						mov	ax,0a0dh
						stosw
						call	httpwdate
						lea	edx,httpctype
						call	copyedx
						mov	eax,sizeof wredir+sizeof wredir1
						pop	ecx
						lea	eax,[eax+ecx-2]
						push	ebx
						call	itoa
						pop	ebx
						mov	ax,0a0dh
						stosw
						lea	edx,cachectrl
						call	copyedx
						lea	edx,httpconn
						call	copyedx
						lea	edx,cclose
						call	copyedx
						mov	ax,0a0dh
						stosw
						lea	edx,wredir
						call	copyedx
						mov	edx,esi
						call	copyedx
						mov	eax,'apc?'
						stosd
						mov	eax,'1=eg'
						stosd
						lea	edx,wredir1
						call	copyedx
						mov	ecx,edi
						pop	edx
						sub	ecx,edx
						pop	esi
						pop	edi
						mov	esi,[edi].ptr_usrstruc
						invoke	asend,edx,ecx
						pop	ebx
						pop	ecx
						jmp	_endt
				;		pop	ebx
				;		pop	ecx
				;		lea	ebx,_pcomment_
				;		xor	eax,eax
				;		inc	eax
				;		.while eax
				;			call	getvar
				;			.if eax
				;				mov	byte ptr[edx-1],-1
				;			.endif
				;		.endw
				;		jmp	reread
					.endif
					pop	ebx
					pop	ecx
					.if ecx
						mov	byte ptr[ecx],'&'
					.endif
				.endif
			.else
				pop	eax
			.endif
_srq:			invoke	GetPageCount,edi
			mov	edx,[edi].ptr_web_info
			mov	ebx,[edi].buffer_in

			inc	dword ptr[edx].webindex[508]
			push	edi
			mov	ecx,edi
			mov	edx,[edi].ptr_web_info
			mov	eax,[edi].buffer_out_size
			mov	edi,[edi].buffer_out
			lea	edi,dword ptr[edi+2048]
			sub	eax,8192
			invoke	httpvars,eax,0,dword ptr[edx].webindex[508],ecx,dcconv
			mov	ecx,edi
			pop	edi
			mov	edx,[edi].buffer_out
			lea	edx,[edx+2048]
			sub	ecx,edx
			mov	[edi].buffer_out_size,ecx

			push	edi
			mov	edi,[edi].buffer_out
			lea	edx,httphdr
			call	copyedx
			pop	edx
			push	edx
			assume	edx:ptr web_user_info
			.if [edx].newlocation
				mov	edx,dword ptr[edx].newlocation
				assume	edx:nothing
				push	edx
				.if (word ptr[edx]=='03')&&(byte ptr[edx+1]<'8')&&(byte ptr[edx+1]>='0')
					.while byte ptr[edx]>31
						mov	al,[edx]
						stosb
						inc	edx
					.endw
					.while byte ptr[edx]==13
						inc	edx
					.endw
					lea	edx,httploc
					call	copyedx
				.else
					lea	edx,httpfound
					call	copyedx
				.endif
				pop	edx
				.while byte ptr[edx]>31
					inc	edx
				.endw
				.while (byte ptr[edx]==13)||(byte ptr[edx]==32)||(byte ptr[edx]==9)||(byte ptr[edx]==10)
					inc	edx
				.endw
			.else
				mov	eax,lParam
				assume	eax:ptr web_user_info
				.if [eax].proxy_flags&64
					assume	eax:nothing
					lea	edx,http404
				.else
					lea	edx,http200
				.endif
			.endif
			call	copyedx
			call	httpwdate
			pop	edx
			push	edx
			assume	edx:ptr web_user_info
			.if [edx].newcookies
				mov	edx,dword ptr[edx].newcookies
				assume	edx:nothing
				.while byte ptr[edx]
					.while (byte ptr[edx]==13)||(byte ptr[edx]==10)||(byte ptr[edx]==32)||(byte ptr[edx]==9)
						inc	edx
					.endw
					.if byte ptr[edx]
						mov	eax,'-teS'
						stosd
						mov	eax,'kooC'
						stosd
						mov	eax,' :ei'
						stosd
						mov	ah,0
						.while (byte ptr[edx]>31)
							mov	al,[edx]
							.if al=='='
								mov	ah,1
							.endif
							stosb
							inc	edx
						.endw
						.if ah==0
							push	edx
							lea	edx,cookiex
							call	copyedx
							pop	edx
						.endif
						mov	ax,0a0dh
						stosw
					.endif
				.endw
			.endif
			lea	edx,httpctype
			call	copyedx
			mov	edx,edi
			pop	edi
			mov	eax,[edi].buffer_out_size
			mov	edi,edx
			call	itoa
			mov	ax,0a0dh
			stosw
			lea	edx,cachectrl
			call	copyedx
		;	lea	edx,httpserv
		;	call	copyedx
			lea	edx,httpconn
			call	copyedx
			push	edi
			mov	edi,lParam
			mov	eax,[edi].proxy_flags
			pop	edi
			.if eax&1
				lea	edx,cclose
			.else
				lea	edx,ckeep
			.endif
			push	eax
			call	copyedx
			mov	ax,0a0dh
			stosw
			pop	eax

			.if (!(eax&16))
				push	edi
				mov	edi,lParam
				mov	ecx,[edi].buffer_out_size
				mov	edx,[edi].buffer_out
				lea	edx,[edx+2048]
				pop	edi
				push	esi
				mov	esi,edx
				rep	movsb
				pop	esi
			.endif
			mov	ecx,edi
			mov	edi,lParam
			mov	edi,[edi].buffer_out
			sub	ecx,edi
			mov	[esi].loggedin,0

			.while ecx
				push	ecx
				.if ecx>4096
					mov	ecx,4096
				.endif
				sub	dword ptr[esp],ecx
				push	ecx
				add	bsent,ecx
				invoke	asend,edi,ecx
				pop	ecx
				add	edi,ecx

				mov	edx,lParam
				assume	edx:ptr web_user_info
				mov	edx,[edx].ptr_web_info
				assume	edx:ptr web_info
				.if [edx].webflags&32
					movzx	eax,systime.wMinute
					shl	eax,16
					mov	ax,systime.wSecond
					.if eax!=lasthm
						mov	lasthm,eax
						mov	bsent,0
					.else
						mov	eax,[edx].upload
						shl	eax,10
						.if eax<=bsent
							.while 1
								movzx	eax,systime.wMinute
								shl	eax,16
								mov	ax,systime.wSecond
								.if eax!=lasthm
									mov	lasthm,eax
									mov	bsent,0
									.break
								.endif
								mov	eax,htsocket
								.if ([esi].waiting&2)||([esi].hSocket!=eax)
									.break
								.endif
								invoke	Sleep,10
							.endw
						.endif
					.endif
				.endif
				assume	edx:nothing
				.while 1
					xor	ecx,ecx
					mov	eax,htsocket
					mov	edx,s_private
					assume	edx:ptr s_record
					.while (edx!=0)&&([edx].s_pending!=0)
						.if [edx].s_opcode==4
							.if [edx].s_socket==eax
								inc	ecx
							.endif
						.endif
						mov	edx,[edx].s_next
					.endw
					assume	edx:nothing
					.break .if ecx<4
					.if ([esi].waiting&2)||([esi].hSocket!=eax)
						.break
					.endif
					invoke	Sleep,10
				.endw
				pop	ecx
				mov	eax,htsocket
				.if ([esi].waiting&2)||([esi].hSocket!=eax)
					.break
				.endif
			.endw
		.endif
	.else
		invoke	GlobalAlloc,GPTR,8192
		mov	[edi].buffer_in,eax
		push	eax
		mov	edi,eax

		lea	edx,httphdr
		call	copyedx
		assume	eax:ptr web_user_info
		mov	eax,lParam
		.if [eax].proxy_flags&64
			lea	edx,http404
			assume	eax:nothing
		.else
			lea	edx,http200
		.endif
		call	copyedx
		call	httpwdate
		lea	edx,httpct1
		call	copyedx
		mov	edx,[esp+8]
		xor	ecx,ecx
		.while byte ptr[edx]
			.if byte ptr[edx]=='.'
				mov	ecx,[edx]
			.elseif byte ptr[edx]=='\'
				xor	ecx,ecx
			.endif
			inc	edx
		.endw
		.if ecx&0ff0000h
		.else
			movzx	ecx,cx
		.endif
		lea	edx,defct1
		.if ecx
			mov	eax,ecx
			or	eax,20202020h
			mov	ecx,c_types
			inc	ecx
			push	edi
			cld
			lea	edi,c_type
			repne	scasd
			.if ecx
				sub	edi,offset c_type
				shr	edi,2
				.if edi
					dec	edi
				.endif
				mov	edx,m_tbl[edi*4]
			.endif
			pop	edi
		.endif
		call	copyedx
		mov	ax,0a0dh
		stosw
	;	lea	edx,httpctype
		lea	edx,httpclen
		call	copyedx
		mov	eax,fsize
		call	itoa
		mov	ax,0a0dh
		stosw
	;	lea	edx,cachectrl
	;	call	copyedx
		lea	edx,httpserv
		call	copyedx
		lea	edx,httpconn
		call	copyedx
		push	edi
		mov	edi,lParam
		mov	eax,[edi].proxy_flags
		pop	edi
		.if eax&1
			lea	edx,cclose
		.else
			lea	edx,ckeep
		.endif
		.if eax&16
			mov	fsize,0
		.endif
		call	copyedx
		mov	ax,0a0dh
		stosw
		mov	ecx,edi
		pop	edi
		push	edi
		sub	ecx,edi
		invoke	asend,edi,ecx
		mov	eax,[esp+4]
		mov	[esi].loggedin,0
		.while fsize
			mov	ecx,4096
			pop	edi
			pop	eax
			push	eax
			push	edi
			.if ecx>fsize
				mov	ecx,fsize
			.endif
			sub	fsize,ecx
			push	ecx
			invoke	ReadFile,eax,edi,ecx,addr bread,0
			pop	ecx
			pop	edi
			push	edi
			add	bsent,ecx
			invoke	asend,edi,ecx

			mov	edx,lParam
			assume	edx:ptr web_user_info
			mov	edx,[edx].ptr_web_info
			assume	edx:ptr web_info
			.if [edx].webflags&32
				movzx	eax,systime.wMinute
				shl	eax,16
				mov	ax,systime.wSecond
				.if eax!=lasthm
					mov	lasthm,eax
					mov	bsent,0
				.else
					mov	eax,[edx].upload
					shl	eax,10
					.if eax<=bsent
						.while 1
							movzx	eax,systime.wMinute
							shl	eax,16
							mov	ax,systime.wSecond
							.if eax!=lasthm
								mov	lasthm,eax
								mov	bsent,0
								.break
							.endif
							mov	eax,htsocket
							.if ([esi].waiting&2)||([esi].hSocket!=eax)
								.break
							.endif
							invoke	Sleep,10
						.endw
					.endif
				.endif
			.endif
			assume	edx:nothing
			.while 1
				xor	ecx,ecx
				mov	eax,htsocket
				mov	edx,s_private
				assume	edx:ptr s_record
				.while (edx!=0)&&([edx].s_pending!=0)
					.if [edx].s_opcode==4
						.if [edx].s_socket==eax
							inc	ecx
						.endif
					.endif
					mov	edx,[edx].s_next
				.endw
				assume	edx:nothing
				.break .if ecx<4
				.if ([esi].waiting&2)||([esi].hSocket!=eax)
					.break
				.endif
				invoke	Sleep,10
			.endw
			mov	eax,htsocket
			.if ([esi].waiting&2)||([esi].hSocket!=eax)
				.break
			.endif
		.endw
		pop	eax
		call	CloseHandle
	.endif
;	.while 1
;		xor	ecx,ecx
;		mov	eax,htsocket
;		mov	edx,s_private
;		assume	edx:ptr s_record
;		.while (edx!=0)&&([edx].s_pending!=0)
;			.if [edx].s_opcode==4
;				.if [edx].s_socket==eax
;					inc	ecx
;				.endif
;			.endif
;			mov	edx,[edx].s_next
;		.endw
;		assume	edx:nothing
;		.break .if ecx==0
;		.if ([esi].waiting&2)||([esi].hSocket!=eax)
;			.break
;		.endif
;		invoke	Sleep,10
;	.endw
;	invoke	Sleep,100
;	call	disconn
_endt:	mov	edi,lParam
	.if [edi].proxy_flags&1
		call	disconn
	.endif
	mov	esi,[edi].ptr_usrstruc
	or	[esi]._web,128
	mov	edi,lParam
	.if [edi].buffer_out
		invoke	GlobalFree,[edi].buffer_out
	.endif
	.if [edi].newlocation
		invoke	GlobalFree,[edi].newlocation
	.endif
	.if [edi].newcookies
		invoke	GlobalFree,[edi].newcookies
	.endif
	.if [edi].buffer_in
		invoke	GlobalFree,[edi].buffer_in
	.endif
	push	[edi].hThread
	invoke	GlobalFree,lParam
	call	CloseHandle
	assume	edi:nothing
	assume	edx:nothing
	invoke	ExitThread,0
	ret
serveThread	ENDP

endm
