;	HeXHub version 5.11 Copyright (C) 2006-2014 Albu Cristian
;
;	This program is free software; you can redistribute it and/or modify
;	it under the terms of the GNU General Public License as published by
;	the Free Software Foundation.
;
;	This program is distributed in the hope that it will be useful,
;	but WITHOUT ANY WARRANTY; without even the implied warranty of
;	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;	GNU General Public License for more details.
;
;	You should have received a copy of the GNU General Public License
;	along with this program; if not, write to the Free Software
;	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
;
;	For more information send and e-mail to cristian.albu@gmail.com

zcompress	PROTO	:DWORD,:DWORD

z_stream	STRUCT
	next_in		dd	?
	avail_in	dd	?
	total_in	dd	?
	next_out	dd	?
	avail_out	dd	?
	total_out	dd	?
	msg		dd	?
	state		dd	?
	zalloc		dd	?
	zfree		dd	?
	opaque		dd	?
	data_type	dd	?
	adler		dd	?
	reserved	dd	?
z_stream	ENDS

ZLibdata	macro
	deflateInit	dd	?
	deflate		dd	?
	deflateEnd	dd	?
endm

ZLib_init	macro
	mov	deflateInit,0
endm

ZLib_procs	macro
zlibdll	db	'zlib1.dll',0
deflate1 db	'deflateInit_',0
deflate2 db	'deflate',0
deflate3 db	'deflateEnd',0
zver	db	'1.2.5',0

zcompress	PROC	uses esi edi ebx edx lpBuf:DWORD,bufsize:DWORD
	local	datasize:DWORD
	local	zstrm:z_stream
	.if bufsize==0
		ret
	.endif
	assume	edx:ptr s_record
	mov	esi,[edx].s_sendto
	assume	edx:nothing
	assume	esi:ptr usrstruc
	.if ((s_supports.cmdparam1&512) && ([esi].myinfwait&8192)) || ((s_supports.cmdparam1&2048) && ([esi].myinfwait&16384))
		.if deflateInit==0
			invoke	LoadLibrary,addr zlibdll
			.if eax
				mov	esi,eax
				invoke	GetProcAddress,esi,addr deflate1
				mov	deflateInit,eax
				invoke	GetProcAddress,esi,addr deflate2
				.if eax
					mov	deflate,eax
					invoke	GetProcAddress,esi,addr deflate3
					.if eax
						mov	deflateEnd,eax
					.else
						mov	deflateInit,eax
					.endif
				.else
					mov	deflateInit,0
				.endif
			.endif
		.endif
		mov	edx,lpBuf
		.if deflateInit && (byte ptr[edx]=='$' || byte ptr[edx]=='<')
			lea	edi,zstrm
			mov	ecx,sizeof zstrm
			xor	eax,eax
			cld
			rep	stosb
			mov	eax,bufsize
			lea	eax,[eax+2048]
			mov	datasize,eax
			invoke	GlobalAlloc,GPTR,eax
			mov	edi,eax
			push	38h
			push	offset zver
			push	9
			lea	ecx,zstrm
			push	ecx
			call	deflateInit
			add	esp,16
			.if eax==0
				mov	eax,lpBuf
				mov	zstrm.next_in,eax
				mov	zstrm.next_out,edi
				mov	eax,bufsize
				mov	zstrm.avail_in,eax
				mov	eax,datasize
				mov	zstrm.avail_out,eax
				push	4	;Z_FINISH
				lea	ecx,zstrm
				push	ecx
				call	deflate
				add	esp,8
				.if eax==1
					xor	eax,eax
				.endif
				push	eax
				lea	ecx,zstrm
				push	ecx
				call	deflateEnd
				add	esp,4
				mov	eax,datasize
				sub	eax,zstrm.avail_out
				mov	datasize,eax
				pop	eax
			.endif
			.if eax==0
				xor	ecx,ecx
				xor	eax,eax
				.while ecx < datasize
					.if byte ptr[edi+ecx]=='\' || byte ptr[edi+ecx]=='|'
						inc	eax
					.endif
					inc	ecx
				.endw
				mov	ecx,datasize
				lea	ecx,[ecx+4]
				.if ecx < bufsize
					push	edi
					lea	edx,[eax+ecx]
					.if ((s_supports.cmdparam1&512) && ([esi].myinfwait&8192))
						lea	ecx,[ecx+2]
						.if ecx<bufsize
							mov	esi,edi
							mov	edi,lpBuf
							mov	eax,'nOZ$'
							stosd
							mov	al,'|'
							stosb
							mov	ecx,datasize
							rep	movsb
					;		mov	al,1
					;		stosb
							mov	edx,edi
							sub	edx,lpBuf
							.if edx>bufsize
								mov	al,223
								int 3
							.endif
							mov	bufsize,edx
						.endif
					.elseif ((s_supports.cmdparam1&2048) && ([esi].myinfwait&16384)) && edx<bufsize
						mov	esi,edi
						xor	ecx,ecx
						mov	edi,lpBuf
						mov	eax,' Z$'
						stosd
						dec	edi
						.while ecx<datasize
							mov	al,[esi+ecx]
							inc	ecx
							.if al=='\'
								stosb
								stosb
							.elseif al=='|'
								mov	ax,'P\'
								stosw
							.else
								stosb
							.endif
						.endw
						mov	al,'|'
						stosb
						mov	edx,edi
						sub	edx,lpBuf
						.if edx>bufsize
							mov	al,222
							int 3
						.endif
						mov	bufsize,edx
					.endif
					pop	edi
				.endif
			.endif
			invoke	GlobalFree,edi
		.endif
	.endif
	mov	ecx,bufsize
	assume	esi:nothing
	ret
zcompress	ENDP
endm

